<?php

/*
  Plugin Name: Download After Submit
  Plugin URI: http://liveforms.org/
  Description: Live Forms form WordPress Download Manager Pro
  Author: Shaon
  Version: 1.2.1
  Author URI: http://liveforms.org/
 */


class liveform_for_wpdmpro {

    public $package_id = 0;

    function __construct(){
        add_action('wpdm_download_lock_option', array($this,'lock_settings'));
        add_action('wpdm_download_lock', array($this,'download_lock'),10, 2);
        add_action('wpdm_check_lock', array($this,'check_download_lock'),10, 2);
        add_action('liveform-showform_before_form_fields', array($this,'add_hidden_field'));
        add_filter('liveform_submitform_thankyou_message', array($this,'show_download_button'));
        add_action( 'admin_notices', array($this, 'required_plugins'));
        add_action( 'liveforms_form_settings', array($this, 'package_select'));

    }

    function email_link($email, $file){
        $eml = get_option('_wpdm_etpl');
        $eml['fromname'] = isset($eml['fromname']) ? $eml['fromname'] : get_bloginfo('name');
        $eml['frommail'] = isset($eml['frommail']) ? $eml['frommail'] : get_bloginfo('admin_email');
        $eml['subject'] = isset($eml['subject']) ? $eml['subject'] : 'Download ' . $file['post_title'];

        $headers = 'From: ' . $eml['fromname'] . ' <' . $eml['frommail'] . '>' . "\r\nContent-type: text/html\r\n";

        $keys = array();
        foreach ($file as $fkey => $value) {
            $_key = "[$fkey]";
            $tdata[$_key] = $value;
        }
        $tdata["[site_url]"] = home_url('/');
        $tdata["[site_name]"] = get_bloginfo('sitename');
        $tdata["[download_url]"] = $file['download_url'];
        $tdata["unsaved:///"] = "";
        $tdata["[date]"] = date(get_option('date_format'), time());

        $message = $eml['body'];

        foreach ($tdata as $skey => $svalue) {
            if(!is_array($svalue)) {
                $message = str_replace(strval($skey), strval($svalue), $message);
                $eml['subject'] = str_replace(strval($skey), strval($svalue), $eml['subject']);
            }
        }

        //do something before sending download link
        do_action("wpdm_before_email_download_link", $_POST, $file);

        $message = str_replace('[#message#]',stripslashes($message), file_get_contents(wpdm_tpl_path('html-frame.html',WPDM_BASE_DIR.'email-templates/')));
        wp_mail($email, stripcslashes($eml['subject']), stripcslashes($message), $headers);
    }

    function findEmail($data, &$emails){
        foreach($data as $val) {
            if (is_array($val))
                $this->findEmail($val, $emails);
            else if(is_email($val))
                $emails[] = $val;
        }

    }


    function download_lock($extralocks, $file)
    {

        $liveform = liveforms::getInstance();
        if (get_post_meta($file['ID'], '__wpdm_liveform_lock', true) != 1 || get_post_meta($file['ID'], '__wpdm_liveform_id', true) == '') return $extralocks;
        $extralocks['html'] .= "<div class='panel panel-default'><div class='panel-heading'>Download NOW!</div><div class='panel-body'>".do_shortcode('[liveform form_id='. get_post_meta($file['ID'], '__wpdm_liveform_id', true).']')."</div>";
        $extralocks['lock'] = 'locked';
        $this->package_id = $file['ID'];
        return $extralocks;
    }

    function check_download_lock($lock, $id)
    {
        if (get_post_meta($id, '__wpdm_liveform_lock', true) == '1') $lock = 'locked';
        return $lock;
    }

    function add_hidden_field($formid){
        global $post;
        $pid = 0;
        $form_data = get_post_meta($formid, 'form_data', true);
        $form_data = maybe_unserialize($form_data);
        if(isset($form_data['download'])) $this->package_id = $form_data['download'];
        if(is_singular('wpdmpro')) $this->package_id = get_the_ID();
        if($this->package_id > 0)
            echo "<input type='hidden' name='after_submit_wpdm' value='{$this->package_id}' />";
    }

    function show_download_button($message){
        if(!isset($_POST['after_submit_wpdm'])) return $message;
        $key = uniqid();
        update_post_meta($_POST['after_submit_wpdm'], "__wpdmkey_".$key, 3);
        if(isset($_POST['after_submit_wpdm'])) {
            $file = array('ID' => $_POST['after_submit_wpdm']);
            $_SESSION['_wpdm_unlocked_'.$_POST['after_submit_wpdm']] = 1;
            $download_url = wpdm_download_url($file, "_wpdmkey={$key}");
            $link_label = get_post_meta($_POST['after_submit_wpdm'], '__wpdm_link_label', true);
            $link_label = $link_label ? $link_label : 'Download';

            $email_link = get_post_meta($_POST['after_submit_wpdm'],'__wpdm_form_lock_email_downlad_link', true);
            if(!$email_link)
                $message .= "<hr style='margin: 10px 0'/><a class='btn btn-success' href='{$download_url}'><i class='fa fa-downlaod'></i> " . $link_label . "</a>";
            else {
                $file['download_url'] = $download_url;
                $file['post_title'] = get_the_title($file['ID']);
                $this->findEmail($_POST, $emails);
                $this->email_link($emails, $file);
            }
        }
        return $message;
    }


    function lock_settings($post = null)
    {
        $id = is_object($post)?$post->ID:null;
        ?>

        <div class="panel panel-default">
        <h3 class="panel-heading"><label><input type="checkbox" rel="form_lock" class="wpdmlock"
                   name="file[liveform_lock]" <?php if (get_post_meta($id, '__wpdm_liveform_lock', true) == '1') echo "checked=checked"; ?>
                   value="1"><?php echo __('Enable Form Lock', 'wpdmpro'); ?> </h3>
        <div id="form_lock"
             class="formlock fwpdmlock panel-body"  <?php if (get_post_meta($id, '__wpdm_liveform_lock', true) != '1') echo "style='display:none'"; ?> >

            <div class="form-group">
            Select From: <br/>
            <select id="fl" class="chzn-select" name="file[liveform_id]" style="width: 250px;min-width: 250px;">
                <?php
                $forms = get_posts('post_type=form&posts_per_page=1000');

                foreach ($forms as $form) {

                    // foreach($res as $row){
                    ?>

                    <option
                        value="<?php echo $form->ID; ?>" <?php if (get_post_meta(get_the_ID(), '__wpdm_liveform_id', true) == $form->ID) echo "selected=selected"; ?> ><?php echo $form->post_title; ?></option>


                <?php

                }

                ?>
            </select>
            </div>
            <div class="form-group">
                <label><input type="hidden" value="0" name="file[form_lock_email_downlad_link]" /><input type="checkbox" name="file[form_lock_email_downlad_link]" value="1" <?php checked(1, get_post_meta(get_the_ID(),'__wpdm_form_lock_email_downlad_link', true)); ?> /> Email Download Link</label>
            </div>


        </div>
        </div>

    <?php
    }

    function package_select($form_data){
        if(!defined('WPDM_Version') || version_compare(WPDM_Version, '4.0.0', '>')) return;
        ?>
        <div class="form-group">

            <label form="download">Download After Submit: </label>
            <select class="form-control" name="contact[download]" id="download">
                <?php
                global $post;
                $args = array( 'numberposts' => -1,'post_type' => 'wpdmpro');
                $posts = get_posts($args);
                foreach( $posts as $post ) : setup_postdata($post); ?>
                    <option value="<? echo $post->ID; ?>" <?php isset($form_data['download']) && selected($form_data['download'], $post->ID); ?> ><?php the_title(); ?></option>
                <?php endforeach; ?>
            </select>

        </div>
    <?php
    }

    function required_plugins()
    {
        $plugin_messages = array();

        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

        // Download the Yoast WordPress SEO plugin
        if(!is_plugin_active( 'liveforms/liveforms.php' ))
        {
            $plugins_dir = dirname(dirname(__FILE__));
            if(!file_exists($plugins_dir.'/liveforms/liveforms.php')) {
                echo '
                   <div style="border: 2px solid #D54E21 !important;border-radius: 3px;" class="updated">
                    <p>
                        <strong>Mostly Ready!</strong><br>
                        <i>Now you need to install Live Forms</i>
                        <a data-title="Download Manager" aria-label="More information about Download Manager" class="thickbox button button-primary button-hero" style="float:right;margin-top: -23px;margin-right: -6px;border: 0 none;border-radius: 2px;box-shadow: none;background: #D54E21" href="plugin-install.php?tab=plugin-information&amp;plugin=liveforms&amp;TB_iframe=true&amp;width=772&amp;height=658">Install Now!</a>

                </p>
                </div>
                   ';
            } else {
                activate_plugin( 'liveforms/liveforms.php' );
            }
        }
    }



}

new liveform_for_wpdmpro();