<?php
/**
 * Description of affiliatefunctions
 *
 * @author USER
 */
class AffiliateFunctions {
    private $table;
    public function __construct() {
        global $wpdb;
        $this->table = $wpdb->prefix .'affiliate_referer';

    }

    public function displayAffiliateGraph($user_id){
        global $wpdb;

        $results = $wpdb->get_results(
                $wpdb->prepare(
                        "SELECT * FROM `{$this->table}` WHERE user_id=%s ORDER BY `depth` asc",
                                $user_id

                        ),
                ARRAY_A
                );

              //this is select so i can use $wpdb->num_rows
        $ret = "";
        if($results==NULL){
            $ret = "";
        }
        else {
            //do the html
            //will do graphic later, now sending list of informations only
            $ret = <<< EOD
            <table class='table'>
                <thead>
                    <tr>
                        <th>SL</th>
                        <th>User Name</th>
                        <th>Depth</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Date</th>
                    </tr>
                </thead>
                <tfoot>
                    <tr>
                        <th>SL</th>
                        <th>User Name</th>
                        <th>Depth</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Date</th>
                    </tr>
                </tfoot>
EOD;

            //echo "</pre>"; print_r($levels); echo "</pre>";
            $sl = 1;
            foreach($results as $row):
                $date = date("F j, Y g:i a", strtotime($row["updated"]));
                $user = get_user_by( 'id', $row['referer_id'] );
                if($user->first_name != '' || $user->last_name != ''){
                    $name = $user->first_name . ' ' . $user->last_name;
                }
                else {
                    $name = $user->display_name;
                }
                $user = null;


                $ret .= <<< EOD
                <tr>
                    <td>{$sl}</td>
                    <td>{$name}</td>
                    <td>{$row['depth']}</td>
                    <td>{$row['product']}</td>
                    <td>{$row['amount']}</td>
                    <td>{$date}</td>
                </tr>        
EOD;
                $sl++;

            endforeach;
            $ret .= "</table>";
        }


        //$query = "'SELECT * FROM `{$this->table}` WHERE referer_id=%s ORDER BY depth asc','$ref_user_id'";


        return $ret;

    }

    public function affiliateGraph($user_id=null){
        if($user_id == null) {
            global $current_user;
            $user_id = $current_user->ID;
        }
        if($user_id == null){
            return "Invalild User ID";
        }

        global $wpdb;

        $results = $wpdb->get_results(
                $wpdb->prepare(
                        "SELECT * FROM `{$this->table}` WHERE user_id=%s ORDER BY `depth` asc",
                                $user_id

                        ),
                ARRAY_A
                );

              //this is select so i can use $wpdb->num_rows
        $ret = "";
        $tbl = '';
        if($results==NULL){
            $ret = "";
        }
        else {

            $ret = array();
            $user = get_userdata($user_id);
            if($user->first_name != '' || $user->last_name != ''){
                $name = $user->first_name . ' ' . $user->last_name;
            }
            else {
                $name = $user->display_name;
            }
            $gravatar = get_avatar( $user_id , 48, plugins_url('multilevel-marketing/assets/user.png') );
            $ret[0] = array(
                'memberId' => $user_id,
                'parentId' => null,
                'amount' => 0,
                'name' => $name,
                'gravatar' => $gravatar,
                'package' => '',
                'status' => '',
                'p' => 'false'
            );
            $user = null;

            $total = 0;
            $income = 0;
            //$levels = wpmp_getAllLevels();
            $tbl = <<< EOD

            <table class='card table table-bordered table-hover'>
                <thead>
                    <tr>
                        <th>#</th>
                        <th>Customer Name</th>
                        <th>Level</th>
                        <th>Purchase Date</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Payment Status</th>
                    </tr>
                </thead>
                <tfoot>
                    <tr>
                        <th>#</th>
                        <th>Customer Name</th>
                        <th>Level</th>
                        <th>Purchase Date</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Payment Status</th>
                    </tr>
                </tfoot>
                <tbody>
                    
EOD;
            $i=1;
            foreach ($results as $row):

                $date = date("F j, Y g:i a", strtotime($row["updated"]));
                $user = get_user_by( 'id', $row['referer_id'] );
                if($user->first_name != '' || $user->last_name != ''){
                    $name = $user->first_name . ' ' . $user->last_name;
                }
                else {
                    $name = $user->display_name;
                }




                $gravatar = get_avatar( $row['referer_id'] , 48, plugins_url('multilevel-marketing/assets/user.png') );

                $parent_id = get_user_meta($row['referer_id'],'_wp_membership_affiliate_referer',true);

                $user = null;

                $total += $row['amount'];
                if($row['payout']==0) {
                    $income += $row['amount'];
                }

                $status = "";
                if($row['payout']==0){
                    $status = "Available";
                }elseif($row['payout']==1){
                    $status = "Pending";
                }elseif($row['payout']=="2"){
                    $status = "Completed";
                }

                $tbl .= <<<EOD
                     <tr>
                        <td>{$i}</td>
                        <td>{$name}</td>
                        <td>{$row['depth']}</td>
                        <td>{$date}</td>
                        <td>{$row['product']}</td>
                        <td>{$row['amount']}</td>
                        <td>{$status}</td>
                    </tr>
EOD;
                           $i++;


                $ret[] = array(
                            'memberId' => $row['referer_id'],
                            'parentId' => $parent_id,
                            'amount' => $row['amount'],
                            'name' => $name,
                            'gravatar' => $gravatar,
                            'date' => $date,
                            'level_name' => $row['product'],
                            'status' => $status,
                            'p' => "false"
                        );



            endforeach;
            $tbl .= "</tbody></table>";
            $ret[0]['amount'] = $total;

            //check for earned amount
            //check for pending amount
            $pending = 0;
            $earned = 0;
            $table = $wpdb->prefix .'affiliate_payout';
            $query = "SELECT amount,status FROM `{$table}` WHERE user_id={$user_id}";
            $results = $wpdb->get_results($query,ARRAY_A);
            if($results !== NULL){
                foreach($results as $row){
                    if($row['status']==0){
                        $pending += $row['amount'];
                    }
                    elseif($row['status']==1){
                        $earned += $row['amount'];
                    }
                }
            }


        }
        $url2 = "";
        if(isset($_GET['updated'])){
            if($_GET['updated']==1) $url = "Payout Request Accepted Successfully";
            else if($_GET['updated']==2) $url = "Payout Request Failed";

            $url2 = <<< EOD
                  <div class="alert alert-warning alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                    {$url}
                  </div>  
EOD;

        }
        if(!isset($income) || $income == null) $income = 0;
        if(isset($pending) == '' || $pending == null) $pending = 0;
        if(isset($earned) == '' || $earned == null) $earned=0;
        $button = <<<EOR
    {$url2}
<div class="row">
<div class="col-md-4">
<div class="card dashboard-panel" id="prp">
  <div class="card-header">Balance</div><div class="card-body"><h3>
  <form method='post' id="payoutreq" class='pull-right'>
    <input type='hidden' name='affiliate_payout_request' value='1'>
    <button type='submit' class='btn btn-primary btn-xs' >Payout Request</button>
  </form>
  \${$income}
  </h3>
  </div>
</div>
</div>
<div class="col-md-4">
<div class="card dashboard-panel">
  <div class="card-header">
  Pending Payouts</div><div class="card-body"><h3>\${$pending}</h3>
</div>
</div>
</div>
<div class="col-md-4">
<div class="card dashboard-panel">
  <div class="card-header">Paid</div><div class="card-body"><h3>\${$earned}</h3>
</div>
</div>
</div>
</div>
<script>
jQuery(function($) {
  $('#payoutreq').submit(function(event) {
    event.preventDefault();
    WPDM.blockUI('#prp');
    $(this).ajaxSubmit({
    url: wpdm_url.ajax+'?action=ml_payout_req',
    success: function(response) {
      if(response.success === false)
          WPDM.notify("<b>Error!</b><br/>"+response.message, 'error', 'top-right', 7000);
      else
          WPDM.notify("<b>Success!</b><br/>"+response.message, 'success', 'top-right', 7000);
      WPDM.unblockUI('#prp');   
    }
    });
  })
});
</script>


                
EOR;

        return array(
                'js' => $this->styleForJs($ret),
                'btn' => $button,
                'table' => $tbl
            );

    }

    private function styleForJs($data = array()){
        if(empty($data)) return "";
        $ret = $this->loadCss();
        $ret .= $this->loadJs($data);
        $ret .= '<div class="tree" id="family_tree"></div>';

        return $ret;

    }

    private function loadJs($data){
        $data = json_encode($data);
        return <<< EOD
<script type="text/javascript">
var members = {$data};
jQuery(function($){
(function heya( parentId ){
    for(var i = 0; i < members.length; i++){
        
        var member = members[i];
        if(member.parentId == parentId && member.p=="false"){
           
            
             var   memberId = member.memberId,
                    //metaInfo = "<img src='"+testImgSrc+"'/>" + member.otherInfo + " ($" + member.amount + ")";
                    metaInfo = member.gravatar + member.level_name + " ($" + member.amount + ")";
            var parent = parentId ? $("#id_" + parentId) : $("#family_tree");  
            //console.log(parent.children().find('ul'));
            //alert(parent.children().find('ul'));
            
            //$(this).children
            if($("#id_" + parentId + " > ul ").length===0){
                //console.log('no ul ' + memberId + ' ' + parentId);
                parent.append("<ul><li id='id_" + memberId + "'><a href='#'>" + member.gravatar + "</a></li></ul>");
            }
            else {
                //console.log('ul found ' + memberId + ' ' + parentId);   
                $("#id_" + parentId + " > ul ").append("<li id='id_" + memberId + "'><a href='#'>" + member.gravatar + "</a></li>");
                //parent.children().find('ul').append("<li id='id_" + memberId + "'><a href='#'>" + memberId + "</a></li>");
            }
            var metaInfo = "<div class='metaInfo metaInfo_id_"+memberId+"'>Name: " + member.name + "<br>Package: " + member.level_name + "<br>Amount: " + member.amount + "<br>Payment Status: " + member.status +"</div>";
            $('#id_'+memberId).append(metaInfo);
            members[i].p = "true";
            heya(memberId);
        }
        
         
    }
    
 }( null ));

    $(".tree ul li").hover(function(){
        var id = $(this).attr('id');
        //alert(id);
        $('.metaInfo').hide();
        $(".metaInfo_" + id).show();
    },function(){
        //var id = $(this).attr('id');
        //alert(id);
        $(".metaInfo").hide();
    });
});
</script>        
        
EOD;
    }

    private function loadCss(){
        return <<< EOD
<style type="text/css" rel='stylesheet'>

.tree ul {
    padding-top: 20px; position: relative !important;
    display: flex;
    transition: all 0.5s;
    -webkit-transition: all 0.5s;
    -moz-transition: all 0.5s;
}

.tree li {
    float: left !important; text-align: center !important;
    list-style-type: none !important;
    position: relative !important;
    padding: 20px 5px 0 5px !important;
    margin: 0 !important;
    transition: all 0.5s;
    -webkit-transition: all 0.5s;
    -moz-transition: all 0.5s;
    
    z-index:   1;
}
        
.tree li:hover{
    z-index:   2;
}
   
.tree li .metaInfo{
    display:none;
    border:solid 1px #000;
    background:#fff;
    position:absolute;
    bottom:100%;
    left:50%;
    padding:5px;
    width:200px;    
}

        #family_tree img.avatar{

        border:0; padding:0; margin:0; box-shadow: none;

        }


/*We will use ::before and ::after to draw the connectors*/

.tree li::before, .tree li::after{
    content: '';
    position: absolute !important; top: 0 !important; right: 50% !important;
    border-top: 1px solid #ccc !important; 
    width: 50% !important; height: 20px !important;
}
.tree li::after{
    right: auto !important; left: 50% !important;
    border-left: 1px solid #ccc !important;
}

/*We need to remove left-right connectors from elements without 
any siblings*/
.tree li:only-child::after, .tree li:only-child::before {
    display: none !important;
}

/*Remove space from the top of single children*/
.tree li:only-child{ padding-top: 0 !important;}

/*Remove left connector from first child and 
right connector from last child*/
.tree li:first-child::before, .tree li:last-child::after{
    border: 0 none !important;
}
/*Adding back the vertical connector to the last nodes*/
.tree li:last-child::before{
    border-right: 1px solid #ccc !important;
    border-radius: 0 5px 0 0 !important;
    -webkit-border-radius: 0 5px 0 0 !important;
    -moz-border-radius: 0 5px 0 0 !important;
}
.tree li:first-child::after{
    border-radius: 5px 0 0 0 !important;
    -webkit-border-radius: 5px 0 0 0 !important;
    -moz-border-radius: 5px 0 0 0 !important;
}

/*Time to add downward connectors from parents*/
.tree ul ul::before{
    content: '';
    position: absolute !important; top: 0 !important; left: 50% !important;
    border-left: 1px solid #ccc !important;
    width: 0 !important; height: 20px !important;
}

.tree li a{
    border: 1px solid #ccc !important;
    padding: 5px 10px !important;
    text-decoration: none !important;
    color: #666 !important;
    font-family: arial, verdana, tahoma;
    font-size: 11px !important;
    display: inline-block !important;
    
    border-radius: 5px !important;
    -webkit-border-radius: 5px;
    -moz-border-radius: 5px;
    
    transition: all 0.5s;
    -webkit-transition: all 0.5s;
    -moz-transition: all 0.5s;
}

/*Time for some hover effects*/
/*We will apply the hover effect the the lineage of the element also*/
.tree li a:hover, .tree li a:hover+ul li a {
    background: #c8e4f8 !important; color: #000 !important; border: 1px solid #94a0b4 !important;
}
/*Connector styles on hover*/
.tree li a:hover+ul li::after, 
.tree li a:hover+ul li::before, 
.tree li a:hover+ul::before, 
.tree li a:hover+ul ul::before{
    border-color:  #94a0b4 !important;
}
</style>        
EOD;
    }




    public function calculateAffiliate($order_id,$user_id,$total){
        global $wpdb, $current_user;
        //$wpdb->show_errors();
        $data = get_option('ml_affiliate_settings');
        $udata = get_user_meta($current_user->ID, 'ml_affiliate_settings', true);
        if(is_array($udata))
            $data = $udata;

        if($data != ""){
            $depth = $data['depth'];
            $cost = $data['level_cost'];
            $now = 0;
            //$first = true;
            $ref_user_id = NULL;
            $current = $user_id;

            while($depth != 0 ){
                $ref_user_id = get_user_meta($current,'_wp_membership_affiliate_referer',true);



                if($ref_user_id == NULL || $ref_user_id == "") {
                    echo "No referer found for user with id $current <br>";
                    break;
                }
                else {
                    $amount = ($total * $cost[$now]) / 100;

                    $data = array(
                        'user_id' => $ref_user_id,
                        'referer_id' => $user_id,
                        'depth' => $now+1,
                        'product' => $order_id, //need to change with product id
                        'amount' => $amount
                    );

                    $format = array(
                        "%d" , "%d" , "%d" , "%d" , "%f"
                    );
                    if($wpdb->insert($this->table,$data,$format)){
                        //data insert successfull
                        //$wpdb->insert_id
                        //echo "Data Inserted Successfull with insert id {$wpdb->insert_id} <br>";
                        $this->trackbackSale($order_id, $ref_user_id, $user_id);
                        return true;

                    }
                    else {
                        //data not inserted
                        echo "Data Cannot be inserted :(";
                        $wpdb->print_error();
                        die();
                        return false;
                    }


                }
                $current = $ref_user_id;
                $now++;
                $depth--;
            }






        }
    }

    function trackbackSale($oid, $rid, $cid){
        $user = get_user_by('id', $cid);
        $track = get_user_meta($rid, '__wpdmaff_trackback', true);
        if(!isset($track['sale'])) return;
        $trackbacksale = $track['sale'];
        $order = new \WPDMPP\Libs\Order();
        $o = $order->GetOrder($oid);
        $trackbacksale = str_replace(array('{name}', '{email}', '{date}', '{tran_id}', '{amount}'), array( $user->display_name, $user->user_email, $o->date, $o->order_id, $o->total ), $trackbacksale);
        return wpdm_remote_get($trackbacksale);
    }

    public function showAll(){
        global $wpdb;
        $results = $wpdb->get_results('SELECT * FROM '.$this->table,ARRAY_A);
        if($results==NULL){
            $ret = "No Record found..";
        }
        else {
            //do the html
            //will do graphic later, now sending list of informations only
            $ret = <<< EOD
            <table class='table widefat'>
                <thead>
                    <tr>
                        <th>SL</th>
                        <th>User Name</th>
                        <th>Referer User</th>
                        <th>Depth</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Date</th>
                    </tr>
                </thead>
                <tfoot>
                    <tr>
                        <th>SL</th>
                        <th>User Name</th>
                        <th>Referer User</th>
                        <th>Depth</th>
                        <th>Order ID</th>
                        <th>Amount</th>
                        <th>Date</th>
                    </tr>
                </tfoot>
EOD;
            //echo "</pre>"; print_r($levels); echo "</pre>";
            $sl = 1;
            foreach($results as $row):
                $date = date("F j, Y g:i a", strtotime($row["updated"]));

                $user = get_user_by( 'id', $row['user_id'] );
                if($user->first_name != '' || $user->last_name != ''){
                    $name1 = $user->first_name . ' ' . $user->last_name;
                }
                else {
                    $name1 = $user->display_name;
                }
                $user = null;

                $user = get_user_by( 'id', $row['referer_id'] );
                if($user->first_name != '' || $user->last_name != ''){
                    $name2 = $user->first_name . ' ' . $user->last_name;
                }
                else {
                    $name2 = $user->display_name;
                }
                $user = null;


                $ret .= <<< EOD
                <tr>
                    <td>{$sl}</td>
                    <td>{$name1}</td>
                    <td>{$name2}</td>
                    <td>{$row['depth']}</td>
                    <td>{$row['product']}</td>
                    <td>{$row['amount']}</td>
                    <td>{$date}</td>
                </tr>        
EOD;
                $sl++;

            endforeach;
            $ret .= "</table>";
        }
        return $ret;

    }

    public function affiliateRequestForUser($user_id=null){
        if($user_id == null){
            global $current_user;
            $user_id = $current_user->ID;
        }
        if(!$user_id) return null;
        global $wpdb;
        $total = $wpdb->get_var($wpdb->prepare("SELECT sum(amount) as total FROM `{$this->table}` WHERE user_id=%d and payout=%d",array($user_id,0)));
        $previous = $wpdb->get_var($wpdb->prepare("SELECT 1 FROM `{$this->table}` WHERE user_id=%d and payout=%d",array($user_id,1)));
        if($total && $total > 0 && $previous != 1){
            $query = $wpdb->query($wpdb->prepare("UPDATE {$this->table} SET payout=%d WHERE user_id=%d and payout=%d",array(1,$user_id,0)));
            if($query){
                $data = array(
                            'user_id' =>$user_id,
                            'amount' => $total,
                            'status' => '0'
                        );
                $format = array("%d","%f","%d");
                if($wpdb->insert($wpdb->prefix .'affiliate_payout',$data,$format)){
                    //$url = add_query_arg(array('updated'=>'1'),  get_permalink());
                    //wp_redirect($url);
                    wp_send_json(['success' => true, 'message' => 'Payout Request Sent Successfully']);
                }
            }
            //$wpdb->show_errors();
            //$wpdb->print_error();
        }
        else{
            //$url = add_query_arg(array('updated'=>'2'),  get_permalink());
            //wp_redirect($url);
            wp_send_json(['success' => false, 'message' => 'Payout Request Failed. Not Enough Balance!']);
        }
        return null;

    }



}
