<?php
/**
 * Description of AffiliateLevel
 *
 * @author USER
 */
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die('direct call');
}
class AffiliateLevel {
    private $messages;
    private $error;
    public function __construct() {
        
        if(isset($_REQUEST['page']) && $_REQUEST['page']==='multilevel-marketing') {
           
            //$this->get_header();
            ob_start();
            if(isset($_REQUEST['add_new']) && $_REQUEST['add_new'] !== ''){
                $this->add_new();
            }
            elseif(isset($_REQUEST['edit']) && $_REQUEST['edit'] !== ''){
                $this->edit();
            }
            elseif(isset($_REQUEST['delete']) && $_REQUEST['delete'] !== ''){
                $this->delete();
            }
            else{
                $this->level_list();
            }
            $content = ob_get_contents();
            ob_end_clean();
            $this->get_header();
            echo $content;
            $this->get_footer();
            
        }
    }
    
    
    private function add_new(){
        global $wpdb;
        $wpdb->show_errors();
        if (! empty( $_POST ) && check_admin_referer( 'wp_membership_affiliate_level', 'affiliate_level' ) ) {
                // process form data, e.g. update fields
            $data = $_REQUEST['data'];
            //echo "<pre>";
            //print_r($data);
            //echo "</pre>";
            $error = false;
            if($data['level_name']==""){
                $this->error['level_name'] = 'Please specify a affiliate level name';
                $error = true;
            }
            
            if($data['depth']==""){
                $this->error['depth'] = 'Please select affiliate level depth';
                $error = true;
            }
            else {
                for($i = 0; $i<$data['depth']; $i++){
                    if($data['level_cost'][$i] == "" || !is_numeric($data['level_cost'][$i])){
                        $this->error['level_cost']='Please Check Depth Cost Filed(s)';
                        $error = true;
                        break;
                    }
                }
            }
            
            if($error==true){
                $this->add_new_html($data);
            }
            else {
                //send data to database...
                global $wpdb;
                $table = $wpdb->prefix . 'affiliate_level';
                $data['level_cost'] = serialize($data['level_cost']);
                $format = array("%s","%d","%s"); 
                if($wpdb->insert( $table, $data, $format )){
                    $this->messages[] = "Affiliate Level Added Successfully";
                }
                else {
                    $this->messages[] = "Something Went Wrong!!!";
                }
                
                $this->level_list();
                
            }
            
            
        }
        else {
            $this->add_new_html();
        }
        //$wpdb->print_error();
    }
    
    
    private function add_new_html($data = array()){
        if(empty($data)){
            $data = array(
                'level_name' => '',
                'depth' => '',
                'level_cost' => '',
            );
        }
        //echo "<pre>"; print_r($data); echo "</pre>";
?>
        <form method="post">
            <?php 
            if(isset($_REQUEST['edit'])) $title = 'Edit Affiliate Level';
            else $title = "Add New Affiliate Level";
            ?>
            <h3><?php echo $title; ?></h3>
        <table class="form-table wp-list-table widefat fixed posts">
            <?php wp_nonce_field( 'wp_membership_affiliate_level','affiliate_level' ); ?>
            
            <tr valign="top">
                <th scope="row">
                    <label for="name">Level Name</label>
                </th>
                <td>
                    <input type='text' name='data[level_name]' value="<?php echo $data['level_name']; ?>"  class="regular-text">
                    <p class='description'><?php echo isset($this->error['level_name']) ? $this->error['level_name'] : '';   ?></p>
                </td>
            </tr>
            
            <tr valign="top">
                <th scope="row">
                    <label for="depth">Level Depth</label>
                </th>
                <td>
                    <select name='data[depth]' id='depth'>
                        <option value='1' <?php selected($data['depth'],'1',true); ?>>1</option>
                        <option value='2' <?php selected($data['depth'],'2',true); ?>>2</option>
                        <option value='3' <?php selected($data['depth'],'3',true); ?>>3</option>
                        <option value='4' <?php selected($data['depth'],'4',true); ?>>4</option>
                        <option value='5' <?php selected($data['depth'],'5',true); ?>>5</option>
                        <option value='6' <?php selected($data['depth'],'6',true); ?>>6</option>
                    </select>
                    <p class='description'><?php echo isset($this->error['depth']) ? $this->error['depth'] : '';   ?></p>
                </td>
            </tr>
            
            
            
            <tr valign="middle" id='level_cost_row'>
                <th scope="row">
                    <label>Depth Cost</label>
                </th>
                <td id='level_cost_td'>
                    <label for='lavel_cost_1'>Level 1 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_1' value="<?php echo isset($data['level_cost'][0]) ? $data['level_cost'][0]:'';   ?>">%
                    <br>
                    <label for='lavel_cost_1'>Level 2 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_2' value="<?php echo isset($data['level_cost'][1]) ? $data['level_cost'][1]:'';   ?>">%
                    <br>
                    <label for='lavel_cost_1'>Level 3 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_3' value="<?php echo isset($data['level_cost'][2]) ? $data['level_cost'][2]:'';   ?>">%
                    <br>
                    <label for='lavel_cost_1'>Level 4 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_4' value="<?php echo isset($data['level_cost'][3]) ? $data['level_cost'][3]:'';   ?>">%
                    <br>
                    <label for='lavel_cost_1'>Level 5 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_5' value="<?php echo isset($data['level_cost'][4]) ? $data['level_cost'][4]:'';   ?>">%
                    <br>
                    <label for='lavel_cost_1'>Level 6 Cost</label>
                    <input type="text" name='data[level_cost][]' id='level_cost_6' value="<?php echo isset($data['level_cost'][5]) ? $data['level_cost'][5]:'';   ?>">%
                    
                    <p class='description'><?php echo isset($this->error['level_cost']) ? $this->error['level_cost'] : '';   ?></p>
                </td>
            </tr>
        </table>   
            
            <p class="submit">
                <input type="submit" name="submit" id="submit" class="button button-primary" value="<?php echo isset($_REQUEST['edit'])?"Edit Level":"Add Level"; ?>"/>
                <a class="button button-secondary" onclick="location.href='<?php echo admin_url('admin.php?page=' . $_GET['page']); ?>'">Cancel</a>
            </p>
         </form>
    
<script type='text/javascript'>
jQuery(document).ready(function($){
    function HelloWorld(){
        var depth = parseInt($('#depth').val());
        //alert(depth);
        for (var i = depth+1; i<=6; i++){
            //alert('#lavel_cost_' + i);
            $('#level_cost_' + i).prop('disabled', true);
        }
        var i = 1;
        while(i<=depth){
            $('#level_cost_' + i).prop('disabled', false);
            i++;
        }
        
    }
    HelloWorld();
    $('#depth').on('change',function(){
       HelloWorld(); 
    });
});    
</script>


<?php
    }
    
    
    private function edit(){
        global $wpdb;
        //$wpdb->show_errors();
        if (! empty( $_POST ) && check_admin_referer( 'wp_membership_affiliate_level', 'affiliate_level' ) ) {
            $data = $_REQUEST['data'];
            //echo "<pre>";
            //print_r($data);
            //echo "</pre>";
            
            $error = false;
            if($data['level_name']==""){
                $this->error['level_name'] = 'Please specify a affiliate level name';
                $error = true;
            }
            
            if($data['depth']==""){
                $this->error['depth'] = 'Please select affiliate level depth';
                $error = true;
            }
            else {
                for($i = 0; $i<$data['depth']; $i++){
                    if($data['level_cost'][$i] == "" || !is_numeric($data['level_cost'][$i])){
                        $this->error['level_cost']='Please Check Depth Cost Filed(s)';
                        $error = true;
                        break;
                    }
                }
            }
            
            if($error==true){
                $this->add_new_html($data);
            }
            
            else {
                //update database table
                $table = $wpdb->prefix . 'affiliate_level';
                $data['level_cost'] = serialize($data['level_cost']);
                $format = array("%s","%d","%s"); 
                $where_format = array('%d');
                $level_id = (int)$_REQUEST['edit'];
                $where = array('id'=>$level_id);
                if($wpdb->update( $table, $data, $where, $format, $where_format )){
                    $this->messages[] = "Affiliate Level Updated Successfully.";
                    $this->level_list();
                }
                else {
                    $this->messages[] = "Something Went Wrong!!!!";
                    $this->level_list();
                }
                
            }
        }
        else {
            //get data from database using $level_id
            
            $level_id = (int)$_REQUEST['edit'];
            $query = 'select * from `' . $wpdb->prefix . 'affiliate_level` WHERE id=' . $level_id;
            $data = $wpdb->get_row($query,ARRAY_A);
            if(is_array($data)){
                $data['level_cost'] = unserialize($data['level_cost']);
                $this->add_new_html($data);
            }
            
            //$wpdb->print_error();
            
        }
    }
    
    
    private function delete() {
        global $wpdb;
        if (!empty($_POST) && check_admin_referer('wp_membership_affiliate_level_delete', 'affiliate_level_delete')) {
            $level_id = (int) $_REQUEST['delete'];
            $table = $wpdb->prefix . 'affiliate_level';
            $where_format = array('%d');
            $where = array('id' => $level_id);
            if ($wpdb->delete($table, $where, $where_format)) {
                $this->messages[] = "Affiliate Level Deleted Successfully.";
                $this->level_list();
            } else {
                $this->messages[] = "Something Went Wrong!!!!";
                $this->level_list();
            }
        }
        else {
            $this->delete_html();
        }
    }

    private function delete_html(){
    ?>
        <h3>Are you sure you want to delete this affiliate level ? </h3>
        <form method="post">
            <?php wp_nonce_field( 'wp_membership_affiliate_level_delete','affiliate_level_delete' ); ?>
            <p class="submit">
                <input type='submit' value='Delete' class='button button-primary' />
                <a class="button button-secondary" onclick="location.href='<?php echo admin_url('admin.php?page=' . $_GET['page']); ?>'">Cancel</a>
            </p>
        </form>
    <?php
    }






    private function get_header(){
        echo "<div class='wrap'>";
        echo '<div id="icon-themes" class="icon32"></div><h2>Affiliate Level ';
        if((isset($_REQUEST['add_new']) && $this->messages =='') || (isset($_REQUEST['edit']) && $this->messages == '' ) || (isset($_REQUEST['delete'])  && $this->messages == '' ) ){
            echo "</h2>";
        }
        else {
            $add_new = add_query_arg(array('add_new'=>'1'),admin_url( 'admin.php?page=multilevel-marketing'));
            echo '<a href="'.$add_new.'" class="button-primary">Add New</a></h2>';
        }
        echo "<br>";
        if(isset($this->messages)):
            echo '<div class="updated fade">';
            foreach($this->messages as $key => $msg){
                echo '<p>' . $msg . '</p>';
            }
            echo '</div>';
        endif;
    }
    
    private function get_footer(){
        echo "</div>";
    }
    
    /*  level list   */
    private function level_list(){
        global $wpdb;
        $query = 'select * from `' . $wpdb->prefix . 'affiliate_level`';
        $data = $wpdb->get_results($query,ARRAY_A);
        echo $this->level_html($data);
    }
    
    private function level_html($data){
?>
    <table id="wp_membership_aff_level" class="widefat datatables">
        <thead>
            <tr>
                <th scope="col"><?php _e('SL','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Level Name','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Level Depth','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Levle Cost','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Date Created','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Actions','wp-memberhsip'); ?></th>
            </tr>
        </thead>
        
        <tfoot>
            <tr>
                <th scope="col"><?php _e('SL','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Level Name','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Level Depth','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Levle Cost','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Date Created','wp-memberhsip'); ?></th>
                <th scope="col"><?php _e('Actions','wp-memberhsip'); ?></th>
            </tr>
        </tfoot>

<?php
    $sl = 1;
    
    if(is_array($data) and !empty($data)):
    foreach($data as $row):
        $level_cost = unserialize($row['level_cost']);
        $level_cost = implode(', ', $level_cost);
        $date = date("F j, Y g:i a", strtotime($row["updated"])); 
        $edit = add_query_arg(array('edit'=>$row['id']),admin_url( 'admin.php?page=wpmp-affiliate-level'));
        $delete = add_query_arg(array('delete'=>$row['id']),admin_url( 'admin.php?page=wpmp-affiliate-level'));
        
        echo '<tr>';
        echo '<td>' . $sl++ . '</td>';
        echo '<td>' . $row['level_name'] . '</td>';
        echo '<td>' . $row['depth'] . '</td>';
        echo '<td>' . $level_cost . '</td>';
        echo '<td>' . $date . '</td>';
        echo '<td><span><a href="'.$edit.'" class="button button-secondary">Edit</a></span> <span><a href="'.$delete.'" class="button button-primary delete_level">Delete</a></span></td>';
        echo '</tr>';
    endforeach;
    
    else:
        echo "<tr><td colspan='5'>No Data Found....</td></tr>";
    endif;
?>
    </table>


<script type="text/javascript">
jQuery(document).ready(function($) {
    $('.delete_level').click(function(event){
        if(confirm('Are you sure, you want to delete ?')){
            return true;
        }
        else {
            return false;
        }
    });
    
    $('#wp_membership_aff_level').dataTable({
            "bStateSave": true,
            "bSort": false,
            "aoColumns": [  { "bSearchable": false },{},{},{ "bSearchable": false } ]
    });
    
    

});
</script>
            
<?php            
    
    }
    
}
