<?php

namespace PrivateMessage\PluginUpdate;

use PrivateMessage\__\__;

class PluginUpdateController
{
    private $plugin_id = 'private-message';

    function __construct()
    {
        add_filter("update_plugins_private-message", [$this, 'updatePlugin']);
    }

    /**
     * @param $update
     * @param $plugin_data
     * @param $plugin_file
     * @param $locales
     * @return array
     */
    function updatePlugin($update, $plugin_data, $plugin_file, $locales){
        $plugin = __::remote_get("https://wpdmcdn.s3-accelerate.amazonaws.com/private-message.json");
        $plugin = (array)json_decode($plugin);
        $latest_version = __::valueof($plugin, 'version');
        $licenseKey = PrivateMessage()->settings->license->licenseKey;
        $update = [];
        $update['id']           = 'private-message';
        $update['slug']         = 'private-message';
        $update['url']          = $plugin_data['PluginURI'];
        $update['tested']       = true;
        $update['version']      = $latest_version;
        $update['package']      = $licenseKey !== '' ? "https://www.wpdownloadmanager.com/?wpdmpp_file=private-message.zip&license={$licenseKey}" : '';
        return $update;
    }
}
