<?php

namespace PrivateMessage\Settings;

use PrivateMessage\__\__Session;
use PrivateMessage\Form\Form;

if(!defined("ABSPATH")) die("Shit happens!");


class License extends Section
{

    public $licenseKey;

    function __construct()
    {
        $this->section = 'license';
        $this->title = __('License', PM_TEXT_DOMAIN);
        $this->icon = 'fa fa-key';
        $this->settings_groups = [
            'wppmsg_lic_settings'      => __('License Key', PM_TEXT_DOMAIN)
        ];
        $this->success_msg = esc_attr__( 'Congratulations! Your license key is validated successfully.', PM_TEXT_DOMAIN );
        $this->settings_fields['__wppmsg_license_key'] = ['group' => 'wppmsg_lic_settings', 'validate_callback' => [$this, 'validateKey'], 'type' => 'text', 'label' => '', 'note' => __("Please enter your license key", "liveforms"), 'attrs' => ['placeholder' => __("License Key", "liveforms"), 'name' => '__wppmsg_license_key', 'id' => 'license_key', 'class' => 'form-control input-lg', 'value' => ($this->licenseKey =  get_option('__wppmsg_license_key', ''))]];

    }

    function verifyKey($licenseKey)
    {
        $license_server = "https://www.wpdownloadmanager.com/";
        $domain = $_SERVER['HTTP_HOST'];
        $productId = 'PRIVATEMESSAGE';
        $args = ['wpdmLicense' => 'validate', 'domain' => $domain, 'licenseKey' => $licenseKey];
        $request = array(
            'method' => 'POST',
            'timeout' => 45,
            'redirection' => 3,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => [],
            'body' => $args,
            'cookies' => array()
        );
        $response = wp_remote_post($license_server, $request);
        update_option("__wppmsg_last_check", time(), false);
        if (is_wp_error($response)) {
            __Session::set("settings_error", "Invalid License Key!");
            return false;
        } else {
            $response = json_decode($response['body']);
            if ($response->status === 'VALID') {
                update_option('__wppmsg_pro', json_encode($response));
                __Session::set("settings_success", "Congratulation! Your Private Message license activated successfully.");
                return $licenseKey;
            } else {
                delete_option('__wppmsg_pro');
                __Session::set("settings_error", "Invalid License Key.");
                return false;
            }
        }
    }

    function validateKey($key)
    {
        $ret = $this->verifyKey($key);
        if(!$ret)
            return  new \WP_Error( 'invalidkey', __( "Invalid or expired license key!", "liveforms" ) );
        else
            return $key;
    }
}
