<?php
/**
 * Plugin Name:  WPDM - Accordion
 * Plugin URI: https://www.wpdownloadmanager.com/download/wpdm-accordion/
 * Description: Display downloads using accordion
 * Author: Shaon
 * Version: 2.0.1
 * Author URI: https://www.wpdownloadmanager.com/
 */

// Exit if accessed directly
if (!defined('ABSPATH')) {
    exit;
}

static $acccount = 0;
function wpdmac_data(){
    global $wpdb;

    if(isset($_GET['wpdmactask']) && $_GET['wpdmactask']=='listsub'){
        check_ajax_referer( NONCE_KEY, '__wpdmacn' );
        $cats = maybe_unserialize(get_option('_fm_categories'));
        $parent = isset($_GET['parent'])?$_GET['parent']:"";
        $cats = get_terms('wpdmcategory', array('hide_empty' => false, 'parent' => $parent));
        $params = array("post_type" => "wpdmpro","posts_per_page"=>999999, 'tax_query' => array(array('taxonomy'=>'wpdmcategory', 'terms'=>array($parent),'field'=> 'id','include_children' => false )));
        if(in_array($_GET['orderby'], array('ID','title', 'date' , 'modified'))) {
            $params['orderby'] = esc_attr($_GET['orderby']);
            $params['order'] = esc_attr($_GET['order']);
        }
        if(in_array($_GET['orderby'], array('package_size_b', 'download_count' , 'view_count'))) {
            $params['orderby'] = 'meta_value_num';
            $params['meta_key'] = "__wpdm_".esc_attr($_GET['orderby']);
            $params['order'] = esc_attr($_GET['order']);
        }
        $params = apply_filters("wpdm_accordion_category_query_args", $params);
        $packs = new WP_Query($params);
        $sac = isset($_GET['sac'])&&$_GET['sac']!=''?esc_attr($_GET['sac']):'default';
        $acccount = isset($_GET['acccount'])&&$_GET['acccount']!=''?esc_attr($_GET['acccount']):1;

        if(isset($_GET['showsub']) && $_GET['showsub']==1){
      ?>

        <div id="accordion-<?php echo $parent ?>" class="panel-group accordion">
		<?php foreach($cats as $cat): if($cat->parent==$parent): ?>
            <div class="card"><div class="card-header">
            <a data-toggle="collapse" class="accord-handle" data-parent="#accordion-<?php echo $cat->parent; ?>" href="#z<?php echo $cat->term_id; ?>-<?php echo $acccount; ?>" rel="<?php echo $cat->term_id; ?>"><?php echo $cat->name; ?></a></div>
            <div id="z<?php echo $cat->term_id; ?>-<?php echo $acccount; ?>" class="panel-collapse collapse">
            <div class="card-body" id="ac-body-<?= $cat->term_id; ?>">
                <div id="<?php echo $cat->term_id; ?>"><i class="fa fa-spinner fa-spin"></i> Loading...</div>
            </div>
            </div>
            </div>
        <?php endif; endforeach; ?>
	    </div>
    <?php } ?>
	<ul class="list-group <?php echo count($cats) > 0 ? 'mt-2': ''; ?>" style="padding: 0 !important;">
		<?php  while($packs->have_posts()): global $post; $packs->the_post();

            $pack = (array)$post;
            $pack = wpdm_setup_package_data($pack);
            $template = isset($_GET['linktpl'])?esc_attr($_GET['linktpl']):'link-template-panel.php';
            if((get_option('_wpdm_hide_all', 0) == 1 && WPDM()->package->userCanAccess(get_the_ID())) || get_option('_wpdm_hide_all', 0) == 0){
		?>
        <li  class="list-group-item" style="padding: 10px"><?php echo FetchTemplate($template, $pack);  ?></li>

		<?php } endwhile; ?>
	</ul>
	<?php

        if($packs->post_count == 0 && count($cats) == 0 ) echo "<div class='alert alert-warning'>No Package Found!</div>";

		die();
	}
}

function wpdm_accordion($params = array()){
    global $acccount;
    $opts = array('hide_empty' => false, 'parent' => 0,'hierarchical'=>1);
    $hcls = array('.wpdm-hideme');
    if(isset($params['cats'])){
        $cat_ids = explode(",", $params['cats']);
        foreach($cat_ids as $cid){
            if($cid == '') continue;
            if(intval($cid) == 0)
            $cats[] = get_term_by("slug", $cid, "wpdmcategory");
            else
            $cats[] = get_term($cid, "wpdmcategory");
            $hcls[] = ".panel .panel-".$cid;
        }
    } else
        $cats = get_terms('wpdmcategory', $opts);


    $acccount++;

    $template = isset($params['template'])?$params['template']:'link-template-panel.php';

    $tac = isset($params['cat_style'])?$params['cat_style']:'primary';
    $sac = isset($params['subcat_style'])?$params['subcat_style']:'default';
    $orderby = isset($params['orderby'])?$params['orderby']:'name';
    $order = isset($params['order'])?$params['order']:'asc';
    ob_start();
    ?>
    <link rel="stylesheet" href="<?= WPDM_FONTAWESOME_URL; ?>" />



	<div id="accordion-groups-<?php echo $acccount; ?>" class="w3eden accordion-groups">
	<div id="accordion-<?php echo $acccount; ?>" class="accordion">
		<?php foreach($cats as $cat):
        if((get_option('_wpdm_hide_all', 0) == 1 && WPDM()->package->userCanAccess($cat->term_id, 'category')) || get_option('_wpdm_hide_all', 0) == 0){
            ?>
            <div class="card">
                <div class="card-header" id="card-header-<?php echo $cat->term_id; ?>">
                    <a class="accord-handle" data-toggle="collapse" data-parent="#accordion-<?php echo $acccount; ?>" href="#z<?php echo $cat->term_id; ?>-<?php echo $acccount; ?>" rel="<?php echo $cat->term_id; ?>"><?php echo $cat->name; ?></a>
                </div>
                <div id="z<?php echo $cat->term_id; ?>-<?php echo $acccount; ?>" class="collapse">
                    <div class="card-body" id="ac-body-<?php echo $cat->term_id; ?>">
                        <div id="<?php echo $cat->term_id; ?>-<?php echo $acccount; ?>"><i class="fa fa-spinner fa-spin"></i> Loading...</div>
                    </div>
                </div>
            </div>

		<?php } endforeach; ?>
	</div>
	</div>
    <style>
        .accordion {
            border-bottom: 1px solid rgba(0,0,0,.125);
            margin-bottom: -1px !important;
            border-radius: 4px;
        }
        .accordion-groups > .accordion > .card:not(.panel-default) > .card-header > a{
            font-size: 11pt;
            line-height: 20px;
            padding: 5px !important;
        }

        .accordion-groups .btn-lg{
            padding: 17px 25px;
        }
        img.acc-thumb{
            max-width: 48px;
            height: auto !important;
            margin-right: 10px;
            border-radius: 3px !important;
        }
        ul.list-group{
            margin-left: 0 !important;
            margin-bottom: 0 !important;
            padding: 0 !important;
        }
        #accordion-groups-<?php echo $acccount; ?> .list-group-item:empty{ display: none; }
        #accordion-groups-<?php echo $acccount; ?> blockquote{ margin: 0 !important; }
        .accordion-groups .panel-default small{ font-size: 11px; }
        #accordion-groups-<?php echo $acccount; ?> <?php echo implode(", #accordion-groups-". $acccount." ", $hcls); ?>{
            display: none;
        }
    </style>

    <script type="text/javascript">
        function wpdmac_handler()
        {
            var $ = jQuery;
            $('.accord-handle').unbind('click');
            $('.accord-handle').on('click', function (e) {
                e.preventDefault();
                var $target = $($(this).attr('href'));
                var cat_id = this.rel;
                var bootstrap_enabled = (typeof $().modal == 'function');
                if(!bootstrap_enabled)
                    $target.toggleClass('show');

                if($target.attr('data-status')!='loaded') {
                    $target.attr('data-status', 'loaded');
                    //$('#ac-body-'+cat_id).load("<?php echo home_url('/');?>?wpdmactask=listsub&__wpdmacn=<?php echo wp_create_nonce(NONCE_KEY); ?>&orderby=<?php echo $orderby;?>&order=<?php echo $order;?>&acccount=<?php echo $acccount;?>&sac=<?php echo $sac;?>&linktpl=<?php echo $template;?>&showsub=<?php echo $opts['hierarchical'];?>&parent="+parent);
                    var parent = $target.attr('id').replace('z','');
                    parent = parent.split('-');
                    parent = parent[0];
                    $.get("<?php echo home_url('/');?>", {
                        wpdmactask: 'listsub',
                        __wpdmacn: '<?php echo wp_create_nonce(NONCE_KEY); ?>',
                        orderby: '<?php echo $orderby;?>',
                        order: '<?php echo $order;?>',
                        acccount: '<?php echo $acccount;?>',
                        sac: '<?php echo $sac;?>',
                        linktpl: '<?php echo $template;?>',
                        showsub: '<?php echo $opts['hierarchical'];?>',
                        parent: parent
                    }, function (res){
                        $('#ac-body-'+cat_id).html(res);
                        wpdmac_handler();
                    });
                }

            });
        }
        jQuery(function($) {
            wpdmac_handler();
            /*$('#accordion-<?php echo $acccount; ?>').on('show.bs.collapse', function (e) {
                var parent = $(e.target).attr('id').replace('z','');
                parent = parent.split('-');
                parent = parent[0];
                if($(e.target).attr('data-status')!='loaded')
                    $(e.target).find('.card-body').load("<?php echo home_url('/');?>?wpdmactask=listsub&__wpdmacn=<?php echo wp_create_nonce(NONCE_KEY); ?>&orderby=<?php echo $orderby;?>&order=<?php echo $order;?>&acccount=<?php echo $acccount;?>&sac=<?php echo $sac;?>&linktpl=<?php echo $template;?>&showsub=<?php echo $opts['hierarchical'];?>&parent="+parent).attr('data-status','loaded');
            });*/
        });
    </script>
    <?php

    $data = ob_get_clean();
    return $data;
}

function wpdm_accordion_mce(){
    ?>

    <div class="panel panel-default">
        <div class="panel-heading">Accordion</div>
        <div class="panel-body">
            <b>Select Category:</b>
            <ul id="accrdcats" class="wpdm-cats" style="height: 100px">
                <?php
                wpdm_cblist_categories();
                ?>
            </ul>
            <em>Don't select any category if you want to show full accordion</em><br/><br/>
            <select style="margin-right: 5px;margin-bottom: 5px;" id="tac">
                <option value="default">Category Style:</option>
                <option value="default">Default</option>
                <option value="success">Success</option>
                <option value="primary">Primary</option>
                <option value="warning">Warning</option>
                <option value="danger">Danger</option>
                <option value="info">Info</option>

            </select>
            <select style="margin-right: 5px;margin-bottom: 5px;" id="sac">
                <option value="default">Sub-Category Style:</option>
                <option value="default">Default</option>
                <option value="success">Success</option>
                <option value="primary">Primary</option>
                <option value="warning">Warning</option>
                <option value="danger">Danger</option>
                <option value="info">Info</option>

            </select>
            <select style="margin-right: 5px;width: 150px" id="plnk_tpl_acrd">
                <option value="link-template-default.php"><?php echo __('Link Template:', 'wpdmpro'); ?></option>
                <?php
                $ctpls = scandir(WPDM_BASE_DIR.'/tpls/link-templates/');
                array_shift($ctpls);
                array_shift($ctpls);
                $ptpls = $ctpls;
                foreach ($ctpls as $ctpl) {
                    $tmpdata = file_get_contents(WPDM_BASE_DIR.'/tpls/link-templates/' . $ctpl);
                    if (preg_match("/WPDM[\s]+Link[\s]+Template[\s]*:([^\-\->]+)/", $tmpdata, $matches)) {

                        ?>
                        <option
                            value="<?php echo str_replace(".php","",$ctpl); ?>" ><?php echo $matches[1]; ?></option>
                        <?php
                    }
                }
                if ($templates = unserialize(get_option("_fm_link_templates", true))) {
                    foreach ($templates as $id => $template) {
                        ?>
                        <option
                            value="<?php echo $id; ?>" ><?php echo $template['title']; ?></option>
                    <?php }
                } ?>
            </select><br style="display: block;clear: both;margin-top: 5px"/>
            <select id="acrdordby" style="margin-right: 5px">
                <option value="title">Order By:</option>
                <option value="title">Title</option>
                <option value="download_count">Downloads</option>
                <option value="package_size_b">Package Size</option>
                <option value="view_count">Views</option>
                <option value="date">Publish Date</option>
                <option value="modified">Update Date</option>
            </select><select id="acrdord" style="margin-right: 5px">
                <option value="asc">Order:</option>
                <option value="asc">Asc</option>
                <option value="desc">Desc</option>
            </select>
            <button class="btn btn-primary btn-sm" id="insacrd">Insert Accordion to Post</button>
            <script>
                jQuery('#insacrd').click(function(){
                    var cts = '';
                    jQuery('#accrdcats input[type=checkbox]').each(function () {
                        if (this.checked) cts += jQuery(this).val() + ",";
                        //alert(jQuery(this).val());
                    });
                    var cats = cts!=''?' cats="' + cts + '" ':'';
                    var tac = ' cat_style="' + jQuery('#tac').val() + '" ';
                    var sac = ' subcat_style="' + jQuery('#sac').val() + '" ';
                    var linkt = ' template="' + jQuery('#plnk_tpl_acrd').val() + '" ';
                    var acob = ' orderby="' + jQuery('#acrdordby').val() + '" order="' + jQuery('#acrdord').val() + '"';
                    var win = window.dialogArguments || opener || parent || top;
                    win.send_to_editor('[wpdm-accordion' + cats + tac  + sac + linkt + acob + ']');
                    tinyMCEPopup.close();
                    return false;
                });
            </script>
        </div>

    </div>

    <?php
}

if(defined('WPDM_VERSION')) {
    add_shortcode('wpdm-accordion', 'wpdm_accordion');
    add_action('init', 'wpdmac_data');
    add_action('wpdm_ext_shortcode', 'wpdm_accordion_mce');
}
