<?php
/**
 * Created by PhpStorm.
 * User: shahnuralam
 * Date: 3/8/17
 * Time: 3:21 PM
 */

namespace WPDM;

if(defined('WPDM_Version')) {
    class BuddyPress
    {

        function __construct()
        {
            add_action('bp_setup_nav', array($this, 'add_wpdm_tabs'), 2);


        }

        function add_wpdm_tabs()
        {
            global $bp;
            //if(is_admin()) return;
            $main_menu_name = get_option('__wpdm_bp_menu_name', __('Downloads', 'wpdm-buddypress'));
            $main_menu_name = $main_menu_name ? $main_menu_name : __('Downloads', 'wpdm-buddypress');
            $main_menu_slug = get_option('__wpdm_bp_menu_slug', 'downloads');
            $main_menu_slug = $main_menu_slug ? $main_menu_slug : 'downloads';
            $menu_id = get_option('__wpdm_bp_menu');
            $menu_pos = get_option('__wpdm_bp_menu_position');
            $_menu_items = wp_get_nav_menu_items($menu_id);
            if (wpdm_query_var('action') == '' && is_array($_menu_items)) {
                foreach ($_menu_items as $menu_item) {
                    $menu_items[$menu_item->ID] = $menu_item;
                    if ($menu_item->type == 'post_type') {
                        $menu_item_post = get_post($menu_item->object_id);
                        if ($menu_item->menu_item_parent == 0) {
                            bp_core_new_nav_item(array(
                                'name' => $menu_item->title,
                                'slug' => $menu_item_post->post_name,
                                'parent_url' => $bp->displayed_user->domain,
                                'parent_slug' => $bp->profile->slug,
                                'screen_function' => array($this, 'page'),
                                'position' => $menu_pos,
                                'default_subnav_slug' => $menu_item_post->post_name
                            ));
                        } else {
                            $menu_parent = $menu_items[$menu_item->menu_item_parent];
                            $menu_parent_post = get_post($menu_parent->object_id);
                            bp_core_new_subnav_item(array(
                                'name' => $menu_item->title,
                                'slug' => $menu_item_post->post_name,
                                'parent_url' => trailingslashit(bp_displayed_user_domain() . $menu_parent_post->post_name),
                                'parent_slug' => $menu_parent_post->post_name,
                                'screen_function' => array($this, 'page'),
                                'position' => 100,
                                'user_has_access' => bp_is_my_profile()
                            ));
                        }
                    }
                }
            }
            /*
                    bp_core_new_subnav_item( array(
                        'name'              => 'Packages',
                        'slug'              => 'downloads',
                        'parent_url'        => trailingslashit( bp_displayed_user_domain() ),
                        'parent_slug'       => 'downloads',
                        'screen_function'   => array($this, 'my_items'),
                        'position'          => 100,
                        'user_has_access'   => bp_is_my_profile()
                    ) );

                    bp_core_new_subnav_item( array(
                        'name'              => 'Recent Downloads',
                        'slug'              => 'recent-downloads',
                        'parent_url'        => trailingslashit( bp_displayed_user_domain() . 'downloads' ),
                        'parent_slug'       => 'downloads',
                        'screen_function'   => array($this, 'recent_downloads'),
                        'position'          => 100,
                        'user_has_access'   => bp_is_my_profile()
                    ) );


                    bp_core_new_subnav_item( array(
                        'name'              => 'Favourites',
                        'slug'              => 'favourites',
                        'parent_url'        => trailingslashit( bp_displayed_user_domain() . 'downloads' ),
                        'parent_slug'       => 'downloads',
                        'screen_function'   => array($this, 'cats_screen'),
                        'position'          => 150,
                        'user_has_access'   => bp_is_my_profile()
                    ) );
            */

        }

        function __call($name, $arguments)
        {
            add_action('bp_template_content', array($this, 'page_content'));
            bp_core_load_template(apply_filters('bp_core_template_plugin', 'members/single/plugins'));
            //$component_slug = bp_current_component();

            //bp_core_load_template(WPDMBP_BASE_DIR.'tpls/menuitem-content');
        }


        function page()
        {
            add_action('bp_template_content', array($this, 'page_content'));
            bp_core_load_template(apply_filters('bp_core_template_plugin', 'members/single/plugins'));
        }

        function page_content()
        {
            $component_slug = bp_current_action();

            $page = get_page_by_path($component_slug);
            echo apply_filters("the_content", $page->post_content);
        }


        function my_items()
        {
            add_action('bp_template_content', array($this, 'page_content'));
            bp_core_load_template(apply_filters('bp_core_template_plugin', 'members/single/plugins'));
        }


        function recent_downloads()
        {
            add_action('bp_template_content', array($this, 'recent_downloads_content'));
            bp_core_load_template(apply_filters('bp_core_template_plugin', 'members/single/plugins'));
        }

        function recent_downloads_content()
        {
            echo 'Recent Downloads';
        }

    }

    new BuddyPress();
}
