<?php
/*
  Plugin Name: WPDM - BuddyPress
  Plugin URI: https://www.wpdownloadmanager.com/download/wpdm-buddypress-integration/
  Description: Buddypress Integration for WordPress Download Manager
  Author: W3 Eden, Inc.
  Version: 1.2.0
  Author URI: https://www.wpdownloadmanager.com/
 */
namespace WPDM\AddOn;
define('WPDMBP_BASE_DIR', dirname(__FILE__) . '/');
define('WPDMBP_BASE_URL', plugins_url('/wpdm-buddypress/'));
include "class.BuddyPress.php";
class BuddyPress {

    function __construct() {
        if(!function_exists('add_wdm_settings_tab')) return;
        $stabs = $GLOBALS['stabs'];
        add_action('wp_footer', array($this, 'wpdm_buddypress_add_script'));
        add_action('init', array($this, 'wpdm_buddypress_share'));
        add_filter('the_content', array($this, 'wpdm_buddypress_share_post'), 9999999);
        add_shortcode('wpdm_bp_share', array($this, 'wpdm_buddypress_share_post'), 9999999);
        add_action('wpdm_buddypres_settings', array($this, 'settings'));
        add_action('wp_ajax_wpdmbp_groups', array($this, 'get_groups'));


    }

    function settings() {
        include WPDMBP_BASE_DIR.'tpls/settings.php';
    }


    function get_groups(){
        global $wpdb;
        $uid =  bp_loggedin_user_id();
        $groups = $wpdb->get_results("select group_id from {$wpdb->prefix}bp_groups_members where user_id='$uid' and is_confirmed = 1");

        $groups_list = "<div class='list-group'>";
        foreach ($groups as $group){
            $group = $wpdb->get_row("select * from {$wpdb->prefix}bp_groups where id='{$group->group_id}'");
            $groups_list .= "<label class='list-group-item'><input class='wpdm-custom-checkbox' type='checkbox' name='groups[]' value='{$group->id}'> ".$group->name."</label>";
        }
        $groups_list.= "</div>";
        ?>
        <form id='group-share-form' method='post' action="<?php echo home_url('/'); ?>">
        <input type="hidden" name="wpdm-buddypress-task" value="group-share" />
        <input type="hidden" name="pid" value="<?php echo wpdm_query_var('pid', 'int') ?>" />
            <?php echo $groups_list; ?>
            <button type='submit' class='btn btn-block btn-primary'>Post to selected groups</button>
        </form>
        <?php
        die();
    }


    function wpdm_buddypress_share_post($content = '') {
        global $post;
        if (is_singular('wpdmpro') && is_user_logged_in() && class_exists('BuddyPress')) {
            $wpdmpro_buddypress_permalink = get_permalink($post->ID);
            $wpdm_post_title = $post->post_title;
            ob_start();
            include __DIR__.'/tpls/dropdown-menu'.WPDM()->bsversion.'.php';
            $data = ob_get_clean();

            $content = $content . $data;
        }
        return $content;
    }

    function wpdm_buddypress_add_script() {
        ?>
        <style>

            #share-ul li:not(:last-child),
            #share-ul .dropdown-item:not(:last-child){
                border-bottom: 1px solid #dddddd;
                padding-bottom: 10px;
                margin-bottom: 5px;
            }
            #share-ul a{
                font-size: 10pt;
                color: var(--color-secondary);
                transition: all ease-in-out 300ms;
            }
            #share-ul a:hover{
                color: var(--color-primary);
                transition: all ease-in-out 300ms;
            }
        </style>
        <script>

            jQuery(document).ready(function($) {
                <?php if(is_singular('wpdmpro') && is_user_logged_in()){ ?>
                var permalink = $('#dmbs-share-button').data('rel');
                var title = $('#dmbs-share-button').data('title');
                var pid = $('#dmbs-share-button').data('pid');
                $('#dbms-group-wall').on('click', function (e) {
                    e.preventDefault();
                    WPDM.bootAlert("Share with Groups", "<div id='wpdmbpgroups'><i class='fa fa-sun fa-spin mr-2'></i> Loading Groups...</div>");
                    $('#wpdmbpgroups').load(wpdm_url.ajax, {action: 'wpdmbp_groups', pid: $('#dmbs-share-button').data('pid')});
                });

                $('body').on('submit', '#group-share-form', function (e) {
                    e.preventDefault();
                    WPDM.blockUI('#group-share-form');
                    $(this).ajaxSubmit({
                        success: function (res) {
                            WPDM.notify("<strong>Action Completed!</strong><br/>Packages is shared to the selected groups successfully.", 'success', 'top-right', 7000);
                            WPDM.unblockUI('#group-share-form');
                            jQuery("#__bootModal").modal('hide');
                        }
                    });
                });

                $('#dbms-private-message').on('click', function(event) {
                    $('#dmbs-spiner-private').removeClass('hide');
                    $.ajax({
                        type: 'POST',
                        url: '<?php echo home_url("/?wpdm-buddypress-task=share-private&url=") ?>' + permalink + '&title=' + title+'&pid='+pid,
                        success: function(result) {
                            $('#dmbs-spiner-private').addClass('hide');
                            WPDM.notify("<strong>Action Completed!</strong><br/>Packages is shared successfully.", 'success', 'top-right', 7000);
                            setTimeout("jQuery('#tfs').fadeOut();", 2000);
                            $('.btn-share').removeClass('open');

                        }});
                    return false;
                });

                $('#dbms-post-wall').on('click', function(event) {

                    $('#dmbs-spiner-wall').removeClass('hide');
                    $.ajax({
                        type: 'POST',
                        url: '<?php echo home_url("/?wpdm-buddypress-task=share-wall&url=") ?>' + permalink + '&title=' + title+'&pid='+pid,
                        success: function(result) {
                            $('#dmbs-spiner-wall').addClass('hide');
                            WPDM.notify("<strong>Action Completed!</strong><br/>Packages is shared successfully.", 'success', 'top-right', 7000);
                            setTimeout("jQuery('#tfs').fadeOut();", 2000);
                            $('.btn-share').removeClass('open');
                        }});
                    return false;
                });

                $('#dbms-post-wall-m').on('click', function(event) {

                    $('#dmbs-spiner-wall').removeClass('hide');
                    $.ajax({
                        type: 'POST',
                        url: '<?php echo home_url("/?wpdm-buddypress-task=share-wall-m&url=") ?>' + permalink + '&title=' + title+'&pid='+pid,
                        success: function(result) {
                            $('#dmbs-spiner-wall').addClass('hide');
                            WPDM.notify("<strong>Action Completed!</strong><br/>Packages is shared successfully.", 'success', 'top-right', 7000);
                            setTimeout("jQuery('#tfs').fadeOut();", 2000);
                            $('.btn-share').removeClass('open');
                        }});
                    return false;
                });
                <?php } ?>
                $('.wpdm-bp-embed').each(function () {
                    var pid = $(this).attr('class').replace('wpdm-bp-embed wpdm-bp-pid-', '');
                    if(pid != '' || pid != undefined) {
                        var url = this.href;
                        $(this).after("<br/><iframe src='"+url+"/embed/' class='wp-embedded-content' width='600' height='550'><iframe>");
                    }
                });

            });
        </script>
        <?php
    }

    function wpdm_buddypress_share() {
        global $wpdb, $current_user;

        if (isset($_REQUEST['wpdm-buddypress-task'])) {
            $pid = wpdm_query_var('pid', 'int');
            $pack = get_post($pid);
            $title = $pack->post_title;
            $url = get_permalink($pack);
        }


        if (isset($_REQUEST['wpdm-buddypress-task']) && $_REQUEST['wpdm-buddypress-task'] == 'share-private') {

            $wpdmbs_group_members = array();
            $wpdmbs_all_group_members = array();
            $group_memeber_table_name = $wpdb->prefix . 'bp_groups_members';
            $group_messages_table_name = $wpdb->prefix . 'bp_messages_messages';
            $group_messages_recipients_table_name = $wpdb->prefix . 'bp_messages_recipients';
            $wpdmbs_current_user = wp_get_current_user();
            $wpdmbs_group_ids = $wpdb->get_results('SELECT group_id FROM ' . $group_memeber_table_name . ' WHERE user_id = ' . $wpdmbs_current_user->ID);
            foreach ($wpdmbs_group_ids as $key => $id) {
                $wpdmbs_group_members[] = $wpdb->get_results('SELECT user_id FROM ' . $group_memeber_table_name . ' WHERE group_id = ' . $id->group_id . ' AND user_id !=' . $wpdmbs_current_user->ID);
            }
            foreach ($wpdmbs_group_members as $key => $wpdmbs_group_member) {
                foreach ($wpdmbs_group_member as $key => $member) {
                    $wpdmbs_all_group_members[] = $member->user_id;
                }
            }
            $wpdmbs_all_group_members = array_unique($wpdmbs_all_group_members);
            foreach ($wpdmbs_all_group_members as $key => $member) {
                $member_info = get_user_by('id', $member);
                $member_login = $member_info->user_login;
                $message = get_option('__wpdm_buddypress_share_private_message');
                $message = str_replace('[link]', "<a href='$url' class='wpdm-bp-embed wpdm-bp-pid-{$pid}' data-pid='{$pid}'>$title<a/>", $message);
                $message = str_replace('[title]', $title, $message);
                $message = str_replace('[friend]', $member_login, $message);
                $buddypress_thread_id = (int) $wpdb->get_var('SELECT MAX(thread_id) FROM ' . $group_messages_table_name) + 1;
                $private_message_title = get_option('__wpdm_buddypress_share_private_message_subject') ? get_option('__wpdm_buddypress_share_private_message_subject') : 'Download Manager Share Link';
                if (!$wpdb->query($wpdb->prepare('INSERT INTO ' . $group_messages_table_name . ' ( thread_id, sender_id, subject, message, date_sent ) VALUES ( %d, %d, %s, %s, %s )', $buddypress_thread_id, $wpdmbs_current_user->ID, $private_message_title, stripslashes($message), current_time('mysql', true))))
                    return false;
                $wpdb->query($wpdb->prepare('INSERT INTO ' . $group_messages_recipients_table_name . ' ( user_id, thread_id, unread_count ) VALUES ( %d, %d, 1 )', $member, $buddypress_thread_id));
                $wpdb->query($wpdb->prepare('INSERT INTO ' . $group_messages_recipients_table_name . ' ( user_id, thread_id, sender_only ) VALUES ( %d, %d, 1 )', $wpdmbs_current_user->ID, $buddypress_thread_id));
            }
            die('Send messages successfully');
        }
        if (isset($_REQUEST['wpdm-buddypress-task']) && $_REQUEST['wpdm-buddypress-task'] == 'share-wall') {

            $friends = explode(",", bp_get_friend_ids(get_current_user_id()));
            $message = get_option('__wpdm_buddypress_share_message');
            $message = str_replace('[link]', "<a href='$url' class='wpdm-bp-embed wpdm-bp-pid-{$pid}' data-pid='{$pid}'>$title<a/>", $message);
            $message = str_replace('[title]', $title, $message);
            $profile = bp_core_get_userlink(get_current_user_id());
            foreach ($friends as $friend){
                $friendlink = bp_core_get_userlink($friend);
                bp_activity_add( array('action' => "$profile Recommended <a href='$url'>{$title}</a> for $friendlink", 'content' => $message, 'user_id' => $friend, 'component' => 'wpdmpro', 'type' => 'share') );
            }

            die('Saved as post successfully');
        }
        if (isset($_REQUEST['wpdm-buddypress-task']) && $_REQUEST['wpdm-buddypress-task'] == 'group-share') {

            $groups = wpdm_query_var('groups');
            $message = get_option('__wpdm_buddypress_share_message');
            $message = str_replace('[link]', "<a href='$url' class='wpdm-bp-embed wpdm-bp-pid-{$pid}' data-pid='{$pid}'>$title<a/>", $message);
            $message = str_replace('[title]', $title, $message);
            $profile = bp_core_get_userlink(get_current_user_id());
            foreach ($groups as $group){
                $group_link = bp_get_group_link($group);
                bp_activity_add( array('action' => "$profile Recommended <a href='$url'>{$title}</a> for $group_link", 'content' => $message, 'user_id' => get_current_user_id(), 'component' => 'groups', 'type' => 'activity_update', 'item_id' => $group) );
            }

            die('Saved as post successfully');
        }
        if (isset($_REQUEST['wpdm-buddypress-task']) && $_REQUEST['wpdm-buddypress-task'] == 'share-wall-m') {
            $profile = bp_core_get_userlink(get_current_user_id());
            $message = get_option('__wpdm_buddypress_share_message');
            $message = str_replace('[link]', "<a href='$url' class='wpdm-bp-embed wpdm-bp-pid-{$pid}' data-pid='{$pid}'>$title<a/>", $message);
            $message = str_replace('[title]', $title, $message);
            bp_activity_add( array('action' => "$profile Recommended <a href='$url'>{$title}</a>", 'content' => $message, 'component' => 'wpdmpro', 'type' => 'share') );
            die('Done!');
        }
    }



}

new BuddyPress();
