<?php

//include('templates/import-post.php');

require_once dirname(dirname(__FILE__))."/classes/vendor/autoload.php";
if (! ini_get("auto_detect_line_endings")) {
    ini_set("auto_detect_line_endings", '1');
}
class process_file {

    public $defCols = array(
        'post_title' => null,
        'post_content' => null,
        'post_excerpt' => null,
        'post_date' => null,
        'post_modified' => null,
        'post_name' => null,
        'post_tag' => null,
        'post_category' => null,
        'post_author' => null,
        'featured_image' => null,
        'post_parent' => 0,
        'post_status' => 0,
        'post_format' => 0,
        'post_slug' => null,
        'menu_order' => 0,
    );
    public $defDownManCol = array(
        '0' => 'version',
        '1' => 'download_count',
        '2' => 'view_count',
        '3' => 'template',
        '4' => 'page_template',
        '5' => 'quota',
        '6' => 'access',
        '7' => 'link_label',
        '8' => 'package_size',
        '9' => 'individual_file_download',
        '10' => 'linkedin_lock',
        '11' => 'facebook_lock',
        '12' => 'tweet_lock',
        '13' => 'gplusone_lock',
        '14' => 'password_lock',
        '15' => 'password',
        '16' => 'password_usage_limit',
        '17' => 'email_lock',
        '18' => 'files',
        '19' => 'icon',
        '20' => 'additional_previews',
        '21' => 'user_access'
    );

    public function custom_types() {
        $custom_post_types = get_post_types();
        return $custom_post_types;
    }

    public function mapping_options() {
        $h = new CSV_HELPER();
        $fileurl = $_REQUEST['file-url'];
        $filename = $_REQUEST['file-name'];

        $reader = \League\Csv\Reader::createFromPath($fileurl);

        $reader->setFlags(SplFileObject::READ_AHEAD|SplFileObject::SKIP_EMPTY);

        foreach ($reader as $index => $row) {
           $alldata[] = $row;
        }


        $handle = $h->fopen($fileurl, 'r');
        $post_count = 0;
        if ($handle == false) {
            echo '<p><strong>' . __('Failed to open file.', 'wpdm-csv-importer') . '</strong></p>';
            return false;
        }
        $is_first = true;
        $this->post_fields = array();
        $post_type_array = array();
        $post_id_array = array();
        $this->post_name_array = array();
        $post_author_array = array();
        $post_date_array = array();
        $post_title_array = array();
        $post_status_array = array();
        $post_content_array = array();
        $post_excerpt_array = array();
        $post_parent_array = array();
        $menu_order_array = array();
        $this->post_category_array = array();
        $this->post_tags_array = array();
        $this->post_thumbnail_array = array();
        $this->post_thumbnail_remote_file = array();
        $this->meta_array = array();
        $this->tax_array = array();
        $this->post_tags_add_array = array();
        foreach ($reader as $index => $data){

            if ($is_first) {
                $this->post_fields = $h->parse_columns($this, $data);
                $_SESSION['csv_header_fields'] = $this->post_fields;
                $is_first = false;
            } else {
                $post_count = $post_count + 1;
                $this->post[$post_count] = array();
                $this->is_update = false;
                $this->error = new WP_Error();

                $post_id = $h->get_data($this, $data, 'ID');
                $post_id = ($post_id) ? $post_id : $h->get_data($this, $data, 'post_id');
                if ($post_id) {
                    $post_exist = get_post($post_id);
                    if (is_null($post_exist)) { // if the post id is not exists
                        $this->post[$post_count]['import_id'] = $post_id;
                        $post_id_array[] = $post_id;
                    } else {
                        if (!$post_type || $post_exist->post_type == $post_type) {
                            $this->post[$post_count]['ID'] = $post_id;
                            $post_id_array[] = $post_id;
                            $this->is_update = true;
                        } else {
                            $this->error->add('post_type_check', sprintf(__('The post type value from your csv file does not match the existing data in your database. post_id: %d, post_type(csv): %s, post_type(db): %s', 'rs-csv-importer'), $post_id, $post_type, $post_exist->post_type));
                        }
                    }
                }

                $post_name = $h->get_data($this, $data, 'post_name');
                if ($post_name) {
                    $this->post[$post_count]['post_name'] = $post_name;
                    $this->post_name_array[] = $post_name;
                }

                $post_slug = $h->get_data($this, $data, 'post_slug');
                if ($post_slug) {
                    $this->post[$post_count]['post_name'] = $post_slug;
                    $this->post_name_array[] = $post_slug;
                }

                $post_author = $h->get_data($this, $data, 'post_author');
                if ($post_author) {
                    if (is_numeric($post_author)) {
                        $user = get_user_by('id', $post_author);
                    } else {
                        $user = get_user_by('login', $post_author);
                    }
                    if (isset($user) && is_object($user)) {
                        $this->post[$post_count]['post_author'] = $user->ID;
//                        $post_author_array[] = $post['post_author'];
                        unset($user);
                    }
                }

                $post_date = $h->get_data($this, $data, 'post_date');
                if ($post_date) {
                    $this->post[$post_count]['post_date'] = date("Y-m-d H:i:s", strtotime($post_date));
//                    $post_date_array[] = $post['post_date'];
                }

                $post_status = $h->get_data($this, $data, 'post_status');
                if ($post_status) {
                    $this->post[$post_count]['post_status'] = $post_status;
                    $post_status_array[] = $post_status;
                } else {
                    $this->post[$post_count]['post_status'] = 'publish';
                    $post_status_array[] = 'publish';
                }

                $post_title = $h->get_data($this, $data, 'post_title');
                if ($post_title) {
                    $this->post[$post_count]['post_title'] = $post_title;
                    $post_title_array[] = $post_title;
                }

                $post_content = $h->get_data($this, $data, 'post_content');
                if ($post_content) {
                    $this->post[$post_count]['post_content'] = $post_content;
                    $post_content_array[] = $post_content;
                }

                $post_excerpt = $h->get_data($this, $data, 'post_excerpt');
                if ($post_excerpt) {
                    $this->post[$post_count]['post_excerpt'] = $post_excerpt;
                    $post_excerpt_array[] = $post_excerpt;
                }

                $post_parent = $h->get_data($this, $data, 'post_parent');
                if ($post_parent) {
                    $this->post[$post_count]['post_parent'] = $post_parent;
                    $post_parent_array[] = $post_parent;
                }

                $menu_order = $h->get_data($this, $data, 'menu_order');
                if ($menu_order) {
                    $this->post[$post_count]['menu_order'] = $menu_order;
                    $menu_order_array[] = $menu_order;
                }

                $this->post_categories = array();
                $post_category = $h->get_data($this, $data, 'post_category');
                if ($post_category) {
                    $this->post_category_array[] = $post_category;
//                    $categories = preg_split("/,+/", $post_category);
                    $this->post_categories = explode(',', $post_category);
                    if ($post_category) {
//                        $this->post[$post_count]['post_category'] = wp_create_categories($categories);
                        $this->post[$post_count]['post_category'] = $this->post_categories;
                    }
                }

                $tag_array = array();
                $post_tags = $h->get_data($this, $data, 'post_tag');
                if ($post_tags) {
//                    $this->post[$post_count]['tags_input'] = explode(',', $post_tags);
                    $tag_array = explode(',', $post_tags);
                    $this->post_tags_array[] = $post_tags;
                }
                $this->post_tags_add_array[] = $tag_array;

                $post_thumbnail = $h->get_data($this, $data, 'featured_image');
                $this->post[$post_count]['featured_image'] = $post_thumbnail;
                $this->post_thumbnail_array[] = $post_thumbnail;
                if (parse_url($post_thumbnail, PHP_URL_SCHEME)) {
                    $post_thumbnail = remote_get_file($post_thumbnail);
                    $this->post_thumbnail_remote_file[] = $post_thumbnail;
                }


                $meta = array();
                $tax = array();

                foreach ($data as $key => $value) {
                    if ($value !== false && isset($this->column_keys[$key])) {
                        if (substr($this->column_keys[$key], 0, 4) == 'tax_') {
                            // (string, comma divided) name of custom taxonomies 
                            $customtaxes = preg_split("/,+/", $value);
                            $taxname = substr($this->column_keys[$key], 4);
                            $tax[$taxname] = array();
                            foreach ($customtaxes as $key => $value) {
                                $tax[$taxname][] = $value;
                            }
                        } else {
                            $meta[$this->column_keys[$key]] = $value;
                        }
                    }
                }
                $this->meta_array[] = $meta;
                $this->tax_array[] = $tax;
            }
        }
//        print_r($this->post);
//        print_r($this->meta_array);
        $_SESSION['posts_data'] = $this->post;
        $_SESSION['posts_tag'] = $this->post_tags_add_array;
        $_SESSION['meta_data'] = $this->meta_array;
        $_SESSION['tax_data'] = $this->tax_array;
        $_SESSION['error'] = $this->error;
        $_SESSION['update'] = $this->is_update;
        $_SESSION['post_thumbnail'] = $this->post_thumbnail_remote_file;
        $this->total_posts = $post_count;
    }

    function mapping_ui() {
        $this->custom_field_array = array();
        ?>
        <style>
            .dmcf-inline-class{
                display: inline !important;
            }
            .panel-heading a,
            .panel-heading a:focus,
            .panel-heading a:hover{
                text-decoration: none !important;
                color: #336699;
                outline: none;
            }
            .panel-heading a:before{
                content: "\f056";
                font-family: 'FontAwesome';
                padding-right: 5px;
                color: #336699;
            }
            .panel-heading a.collapsed{
                color: #222222;
            }
            .panel-heading a.collapsed:before{
                content: "\f055";
                font-family: 'FontAwesome';
                padding-right: 5px;
                color: #222222;
            }
            /*
            .panel-primary .panel{
                box-shadow: none !important;
                border-radius: 0 !important;
            }
            .panel-primary .panel + .panel{
                border-top: 0 !important;
                margin-top: 0 !important;
            }
            .panel-acf-group > .panel-heading{
                background: #dddddd !important;
                border-radius: 0;
            }
            */
        </style>
        <style>

            input{
                padding: 7px;
            }
            #wphead{
                border-bottom:0px;
            }
            #screen-meta-links{
                display: none;
            }
            .wrap{
                margin: 0px;
                padding: 0px;
            }
            #wpbody{
                margin-left: -19px;
            }
            select{
                min-width: 150px;
            }

            .wpdm-loading {
                background: url('<?php echo plugins_url('download-manager/images/wpdm-settings.png'); ?>') center center no-repeat;
                width: 16px;
                height: 16px;
                /*border-bottom: 2px solid #2a2dcb;*/
                /*border-left: 2px solid #ffffff;*/
                /*border-right: 2px solid #c30;*/
                /*border-top: 2px solid #3dd269;*/
                /*border-radius: 100%;*/

            }

            .w3eden .btn{
                border-radius: 0.2em !important;
            }

            .w3eden .nav-pills a{
                background: #f5f5f5;
            }

            .w3eden .form-control,
            .w3eden .nav-pills a{
                border-radius: 0.2em !important;
                box-shadow: none !important;
                font-size: 9pt !important;
            }

            .wpdm-spin{
                -webkit-animation: spin 2s infinite linear;
                -moz-animation: spin 2s infinite linear;
                -ms-animation: spin 2s infinite linear;
                -o-animation: spin 2s infinite linear;
                animation: spin 2s infinite linear;
            }

            @keyframes "spin" {
                from {
                    -webkit-transform: rotate(0deg);
                    -moz-transform: rotate(0deg);
                    -o-transform: rotate(0deg);
                    -ms-transform: rotate(0deg);
                    transform: rotate(0deg);
                }
                to {
                    -webkit-transform: rotate(359deg);
                    -moz-transform: rotate(359deg);
                    -o-transform: rotate(359deg);
                    -ms-transform: rotate(359deg);
                    transform: rotate(359deg);
                }

            }

            @-moz-keyframes spin {
                from {
                    -moz-transform: rotate(0deg);
                    transform: rotate(0deg);
                }
                to {
                    -moz-transform: rotate(359deg);
                    transform: rotate(359deg);
                }

            }

            @-webkit-keyframes "spin" {
                from {
                    -webkit-transform: rotate(0deg);
                    transform: rotate(0deg);
                }
                to {
                    -webkit-transform: rotate(359deg);
                    transform: rotate(359deg);
                }

            }

            @-ms-keyframes "spin" {
                from {
                    -ms-transform: rotate(0deg);
                    transform: rotate(0deg);
                }
                to {
                    -ms-transform: rotate(359deg);
                    transform: rotate(359deg);
                }

            }

            @-o-keyframes "spin" {
                from {
                    -o-transform: rotate(0deg);
                    transform: rotate(0deg);
                }
                to {
                    -o-transform: rotate(359deg);
                    transform: rotate(359deg);
                }

            }

            .panel-heading h3.h{
                font-size: 11pt;
                font-weight: 700;
                margin: 0;
                padding: 5px 10px;
                font-family: 'Open Sans';
            }

            .btn-primary {
                background-color: #2081D5;
                background-image: linear-gradient(to bottom, #2081D5 0px, #1B6CB2 100%);
                background-repeat: repeat-x;
                border-color: #1D76C3 #1B6CB2 #134B7C !important;
                color: #FFFFFF;
            }

            .panel-heading .btn.btn-primary{

                border-radius: 3px;
                border:1px solid rgba(255,255,255,0.8) !important;
                -webkit-transition: all 400ms ease-in-out;
                -moz-transition: all 400ms ease-in-out;
                -o-transition: all 400ms ease-in-out;
                transition: all 400ms ease-in-out;
            }

            .panel-heading .btn.btn-primary:hover{

                border-radius: 3px;
                border:1px solid rgba(255,255,255,1) !important;

            }
            .btn-info {
                background-color: #5AA2D3 !important;
                background-image: linear-gradient(to bottom, #5AA2D3 0px, #3A90CA 100%) !important;
                background-repeat: repeat-x;
                border-color: #4A99CF #3A90CA #2A6E9D !important;
                color: #FFFFFF;
            }

            .btn-danger {
                background-color: #DE090B !important;
                background-image: linear-gradient(to bottom, #DE090B 0px, #B70709 100%) !important;
                background-repeat: repeat-x;
                border-color: #CA080A #B70709 #7C0506 !important;
                color: #FFFFFF;
            }

            .btn-success {
                background-color: #5D9C22 !important;
                background-image: linear-gradient(to bottom, #5D9C22 0px, #497B1B 100%) !important;
                background-repeat: repeat-x;
                border-color: #538B1E #497B1B #2B4810 !important;
                color: #FFFFFF;
            }

            .btn-default {
                background-color: #FFFFFF;
                background-image: linear-gradient(to bottom, #FFFFFF 0px, #EBEBEB 100%) !important;
                background-repeat: repeat-x;
                border-color: #EBEBEB #E0E0E0 #C2C2C2 !important;
                color: #555555;
            }

            .alert-info {
                background-color: #DFECF7 !important;
                border-color: #B0D1EC !important;
            }

            ul.nav li a:active,
            ul.nav li a:focus,
            ul.nav li a{
                outline: none !important;
            }

            .w3eden .nav-pills li.active a,
            .btn-primary,
            .w3eden .panel-primary > .panel-heading{
                background-image: linear-gradient(to bottom, #2081D5 0px, #1B6CB2 100%) !important;
            }
            .w3eden .panel-default > .panel-heading {
                background-image: linear-gradient(to bottom, #F5F5F5 0px, #E1E1E1 100%);
                background-repeat: repeat-x;
            }


        </style>
        <div class="w3eden">
            <div class="panel panel-primary" style="margin: 30px">
                <div class="panel-heading">
                    <b style="font-size: 12pt;line-height:28px"><i class="fa fa-magic"></i> &nbsp; <?php echo __("Advanced CSV Importer", "wpdmpro"); ?></b>

                    <div style="clear: both"></div>
                </div>
                <form id="map-and-insert" class="form" method="post">
                    <div class="panel-body">
                        <input type="hidden" name="start" id="start" value="0" />
                        <input type="hidden" name="action" value="save_eci_settings" />
                        <?php for ($processpost = 1; $processpost <= $this->total_posts; $processpost++) { ?>
                            <table id="table-<?php echo $processpost; ?>" class="table">
                                <thead>
                                    <tr>
                                        <th style="width: 150px;">CSV Header</th>
                                        <th style="width: 230px;">WP Fields</th>
                                        <th>CSV Data</th>
                                    </tr>
                                </thead> 
                                <tbody>
                                    <?php foreach ($this->post_fields as $key => $field) { ?>                            
                                        <tr>
                                            <td><?php echo $field; ?></td>
                                            <td>
                                                <select id="map-dropdown-<?php echo $field ?>" name="map-post-field[]" class="form-control">
                                                    <option value="default">----Select----</option>
                                                    <?php foreach ($this->defCols as $keyI => $col) { ?>
                                                        <option value="<?php echo $keyI ?>"><?php echo $keyI; ?></option>
                                                        <?php
                                                    }
                                                    foreach ($this->defDownManCol as $keyACF => $value) {
                                                        ?>
                                                        <option value="__wpdm_<?php echo $value ?>"><?php echo 'WPDM:' . $value; ?></option>
                                                        <?php
                                                    }
                                                    foreach ($this->custom_types() as $keyIn => $col) {
                                                        ?>
                                                        <option value="<?php echo 'CF:' . $col; ?>"><?php echo 'CF:' . $col; ?></option>
                                                    <?php } ?>
                                                    <option value="cf">Add Custom Field</option>    
                                                </select>
                                            </td>
                                            <td>
                                                <?php
                                                if ($field == 'featured_image') {
                                                    if (array_key_exists($field, $this->post_thumbnail_array))
                                                        echo strlen($this->post_thumbnail_array[$processpost - 1]) > 80 ? substr($this->post_thumbnail_array[$processpost - 1], 0, 80) . '...' : $this->post_thumbnail_array[$processpost - 1];
                                                    else
                                                        echo '';
                                                } else if ($field == 'post_category') {
                                                    if (strlen($this->post_category_array[$processpost - 1]) !== 0)
                                                        echo strlen($this->post_category_array[$processpost - 1]) > 80 ? substr($this->post_category_array[$processpost - 1], 0, 80) . '...' : $this->post_category_array[$processpost - 1];
                                                    else
                                                        echo '';
                                                } else if ($field == 'post_name' || $field == 'post_slug') {
                                                    if (array_key_exists($field, $this->post_name_array))
                                                        echo strlen($this->post_name_array[$processpost - 1]) > 80 ? substr($this->post_name_array[$processpost - 1], 0, 80) . '...' : $this->post_name_array[$processpost - 1];
                                                    else
                                                        echo '';
                                                } else if ($field == 'post_tag' || $field == 'post_tags') {
                                                    if (array_key_exists($field, $this->post_tags_array))
                                                        echo strlen($this->post_tags_array[$processpost - 1]) > 80 ? substr($this->post_tags_array[$processpost - 1], 0, 80) . '...' : $this->post_tags_array[$processpost - 1];
                                                    else
                                                        echo '';
                                                } else if ($field != 'post_title' && $field != 'post_content' && $field != 'post_excerpt' && $field != 'post_date' && $field != 'post_name' && $field != 'post_tag' && $field != 'post_category' && $field != 'post_author' && $field != 'featured_image' && $field != 'post_parent' && $field != 'post_status' && $field != 'post_format' && $field != 'post_slug' && $field != 'menu_order') {
                                                    echo '<input type="text" name="custom-field-modify[' . $key . ']" id="custom-field-' . $field . '" class="hide form-control" />';
                                                    if (array_key_exists($field, $this->meta_array[$processpost - 1]))
                                                        echo strlen($this->meta_array[$processpost - 1][$field]) > 80 ? substr($this->meta_array[$processpost - 1][$field], 0, 80) . '...' : $this->meta_array[$processpost - 1][$field];
                                                    else
                                                        echo '';
                                                    $this->custom_field_array[] = $field;
                                                } else {
                                                    if (array_key_exists($field, $this->post[$processpost]))
                                                        echo strlen($this->post[$processpost][$field]) > 80 ? substr($this->post[$processpost][$field], 0, 80) . '...' : $this->post[$processpost][$field];
                                                    else
                                                        echo '';
                                                }
                                                ?>
                                            </td>
                                        </tr>
                                        <?php
                                    }
                                    ?>    
                                </tbody>
                            </table>
                            <div class="hide form-group">

                            </div>
                            <?php
                            $_SESSION['new_custom_fields'] = $this->custom_field_array;
                            break;
                        }
                        ?>
                        <div class="form-group success-error-message">
                            <ol id="success-error-message">

                            </ol>
                        </div>
                    </div>
                    <div class="panel-footer">
                        <input type="button" style="width: 130px; margin-right: 5px;" class="btn btn-danger clear-map" value="Clear Mapping" />
                        <button type="submit" class="btn btn-success pull-right">Continue <i class="fa fa-chevron-right"></i></button>
                        <div id="loading-spinner" style="margin-top: 10px;" class="hide">
                            <span><i class="fa fa-spinner fa-spin"></i> Please wait...</span>
                        </div>
                        <!--<input type="hidden" name="flag-insert" value="1" />-->
                    </div>
                </form>    
            </div>
        </div>
        <?php
    }

}

$classRef = new process_file();
$classRef->mapping_options();
$classRef->mapping_ui();
?>
<script>
    jQuery(document).ready(function($) {
        $('#map-and-insert').submit(function() {
            $('#loading-spinner').removeClass('hide');
            $(this).ajaxSubmit({
                url: ajaxurl,
                success: function(res) {
                    res = JSON.parse(res);
                    console.log(res);
                    $('#loading-spinner').addClass('hide');
                    $('#success-error-message').html($('#success-error-message').html()+res.result);
                    var start = parseInt($('#start').val())+20;
                    if(res.total > start) {
                        $('#start').val(start);
                        $('#map-and-insert').submit();
                    }
                    else
                        $('#success-error-message').html($('#success-error-message').html()+"<li class='text-success'><b>Completed!</b></li>");
                }
            });
            return false;
        });
<?php
if (!empty($classRef->custom_field_array)) {
    foreach ($classRef->custom_field_array as $key => $field) {
        ?>
                $("#map-dropdown-<?php echo $field; ?>").change(function() {
                    if ($(this).val() == "cf") {
                        $('#custom-field-<?php echo $field; ?>').val('');
                        $('#custom-field-<?php echo $field; ?>').removeClass('hide');
                        $('#custom-field-<?php echo $field; ?>').val($('#custom-field-<?php echo $field; ?>').val() + '<?php echo $field ?>');
                    } else {
                        $('#custom-field-<?php echo $field; ?>').addClass('hide');
                    }
                });
        <?php
    }
}
?>

        $(document).on('click', '.clear-map', function(event) {
            event.preventDefault();
<?php
foreach ($classRef->post_fields as $key => $field) {
    if ($field != 'post_title' && $field != 'post_content' && $field != 'post_excerpt' && $field != 'post_date' && $field != 'post_name' && $field != 'post_tag' && $field != 'post_category' && $field != 'post_author' && $field != 'featured_image' && $field != 'post_parent' && $field != 'post_status' && $field != 'post_format' && $field != 'post_slug' && $field != 'menu_order') {
        ?>
                    $('#custom-field-<?php echo $field; ?>').addClass('hide');
    <?php } ?>
                $('#map-dropdown-<?php echo $field; ?>').find('option:first').attr('selected', 'selected');
<?php } ?>
        });
    });
</script>