<?php

/*
  Plugin Name: WPDM - Advanced CSV Importer
  Plugin URI: http://www.wpdownloadmanager.com/
  Description: Advanced CSV Imported Add-on for WordPress Download Manager
  Author: Shaon
  Version: 2.6.0
  Author URI: http://www.wpdownloadmanager.com/
 */

define('WPDMCI_BASE_DIR', dirname(__FILE__) . '/');
define('ECI_BASE_URL', plugins_url('/wpdm-csv-importer/'));

set_include_path(dirname(__FILE__) . '/');

require_once ABSPATH . 'wp-admin/includes/import.php';
require_once ABSPATH . 'wp-admin/includes/media.php';
require_once ABSPATH . 'wp-admin/includes/file.php';
require_once ABSPATH . 'wp-admin/includes/image.php';
require_once ABSPATH . 'wp-admin/includes/taxonomy.php';

require(WPDMCI_BASE_DIR . 'classes/csv-helper.php');
require(WPDMCI_BASE_DIR . 'classes/csv-post-helper.php');
require('templates/import-post.php');

if (!isset($_SESSION)) {
    session_start();
}

class eden_csv_importer {

    public $column_indexes = array();
    public $column_keys = array();

    function __construct() {
        add_action('admin_menu', array($this, 'csv_importer'));
        add_action('save_csv_post', array($this, 'save_post'));
        add_action('admin_enqueue_scripts', array($this, 'eci_admin_enqueue_scripts'));
        add_action('wp_ajax_save_eci_settings', array(new import_post(), 'map_post'));
        add_action('wp_ajax_nopriv_save_eci_settings', array(new import_post(), 'map_post'));
        add_Action("wp_ajax_wpdm_csv_upload",array($this, "upload_csv"));
    }
    

    function eci_admin_enqueue_scripts($hook) {
        if($hook!='wpdmpro_page_wpdm-csv-importer') return;
        wp_enqueue_script('jquery');
        wp_enqueue_script('jquery-form');
        wp_enqueue_script('plupload');
        wp_enqueue_media();
        wp_enqueue_style('eci-admin-bootstrap-css', WPDM_BASE_URL . 'assets/bootstrap/css/bootstrap.css');
        wp_enqueue_style('eci-admin-font-awesome-css', WPDM_BASE_URL . 'assets/font-awesome/css/font-awesome.min.css');
        wp_enqueue_script('eci-admin-bootstrap-js', WPDM_BASE_URL . 'assets/bootstrap/js/bootstrap.min.js');
    }

    function eci_get_wp_version() {
        global $wp_version;
        return $wp_version;
    }

    function save_post($post, $meta, $terms, $thumbnail, $is_update) {
        $ph = new wp_eden_post_helper($post);

        foreach ($meta as $key => $value) {
            $is_cfs = 0;
            $is_acf = 0;
            $cfs_prefix = 'cfs_';
            if (strpos($key, $cfs_prefix) === 0) {
                $ph->add_cfs_field(substr($key, strlen($cfs_prefix)), $value);
                $is_cfs = 1;
            } else {
                if (function_exists('get_field_object')) {
                    if (strpos($key, 'field_') === 0) {
                        $fobj = get_field_object($key);
                        if (is_array($fobj) && isset($fobj['key']) && $fobj['key'] == $key) {
                            $ph->add_field($key, $value);
                            $is_acf = 1;
                        }
                    }
                }
            }
            if (!$is_acf && !$is_cfs)
                $ph->add_meta($key, $value, true);
        }

        foreach ($terms as $key => $value) {
            $ph->add_terms($key, $value);
        }

        if ($thumbnail)
            $ph->add_media($thumbnail, '', '', '', true);

        if ($is_update)
            $result = $ph->update();
        else
            $result = $ph->insert();

        unset($ph);

        return $result;
    }

    function csv_importer() {
        add_submenu_page("edit.php?post_type=wpdmpro",__('CSV Importer', 'wpdm-csv-importer'), __('CSV Importer', 'wpdm-csv-importer'), 'manage_options', 'wpdm-csv-importer', array($this, 'eden_csv_import_ui'));
    }

    function eden_csv_import_ui() {
        include(WPDMCI_BASE_DIR . 'modules/post/integration.php');
    }
    
    function upload_csv(){
        $upload_dir = wp_upload_dir();
        $upload_path = $upload_dir['path'];
        $file = $upload_path.uniqid().".csv";
        move_uploaded_file($_FILES['csvfile']['tmp_name'], $file);
        echo $file;
        die();
    }
}

new eden_csv_importer();
