<?php
/*
Plugin Name: WPDM - iContact
Plugin URL: http://www.wpdownloadmanager.com/
Description: iContant Addons for Download Manager Plugin 
Version: 1.0
Author: Shaon
Author URI: http://www.wpdownloadmanager.com/
*/

if ( ! defined( 'WPINC' ) ) {
    die;
}

class WpdmEmailIcontact{
    private static $instance;
    private $dir, $url, $api;
    
    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
            if(!class_exists('iContactApi'))
                require_once self::$instance->dir . '/iContactApi.php' ;
            $options = get_option('wpdm_email_i_contact');
            $appId = isset($options['appId']) ? $options['appId'] : '';
            $apiUsername = isset($options['apiUsername']) ? $options['apiUsername'] : '';
            $apiPassword = isset($options['apiPassword']) ? $options['apiPassword'] : '';
            if($appId != '' && $apiUsername != '' && $apiUsername != '') {
                // Give the API your information
                iContactApi::getInstance()->setConfig(array(
                        'appId'       => $appId, 
                        'apiPassword' => $apiPassword, 
                        'apiUsername' => $apiUsername
                ));

                // Store the singleton
                self::$instance->api = iContactApi::getInstance();
            }
            else {
                self::$instance->api = null;
            }
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function actions() {
        //echo "Hello World";
        
        register_activation_hook(__FILE__, array($this,'activate'));
        register_deactivation_hook(__FILE__, array($this,'deactivate'));
        
        if(is_admin()){
            add_wdm_settings_tab("i_contact", "iContact", array($this,'settings'));
        }
        if(!is_admin()){
            
        }
        
        add_action('wpdm_before_email_download_link',array($this,'subscribeHook'),10,2);
    }
    
    public function activate(){
//        if(false == get_option('wpdm_email_mailchimp')){
//            $option = array('key'=>'', 'list_id' => '');
//            add_option('wpdm_email_mailchimp',$option);
//        }
    }
    
    public function deactivate(){
        
    }
    
    
    public static function getDir(){
        return self::$instance->dir;
    }
    
    public static function getUrl(){
        return self::$instance->url;
    }
    
    
    public function settings(){
        
        if(isset($_POST['ic_appId'])){
            $options['appId'] = stripslashes(trim($_POST['ic_appId']));
            $options['apiPassword'] = stripslashes(trim($_POST['ic_apiPassword']));
            $options['apiUsername'] = stripslashes(trim($_POST['ic_apiUsername']));
            $options['list_id'] = isset($_POST['ic_list_id']) ? stripslashes(trim($_POST['ic_list_id'])) : '';
            update_option('wpdm_email_i_contact',$options);
            die('Settings Saved Successfully.');
        }
        
        $options = get_option('wpdm_email_i_contact',array());
        $appId = isset($options['appId']) ? $options['appId'] : '';
        $apiUsername = isset($options['apiUsername']) ? $options['apiUsername'] : '';
        $apiPassword = isset($options['apiPassword']) ? $options['apiPassword'] : '';
        $list_id = isset($options['list_id']) ? $options['list_id'] : '';
        
        if($this->api !== null) {
            //$list = $this->api->getContacts($cc_access_token);
            try {
                $lists = $this->api->getLists();
                //print_r($lists);
            } catch (Exception $oException) { // Catch any exceptions
                // Dump errors
                var_dump($this->api->getErrors());
                // Grab the last raw request data
                var_dump($this->api->getLastRequest());
                // Grab the last raw response data
                var_dump($this->api->getLastResponse());
            }
            
        }
        
        
?>
        <div class="panel panel-default">
            <div class="panel-heading">Constant Contact Account Settings</div>
            <div class="panel-body">
                <div class="form-group">
                    <label for="ic_appId">App ID</label>
                    <input type="text" name="ic_appId" class="form-control" id="ic_appId" value="<?php echo $appId; ?>">
                </div>
                <div class="form-group">
                    <label for="ic_apiUsername">User Name</label>
                    <input type="text" name="ic_apiUsername" class="form-control" id="ic_apiUsername" value="<?php echo $apiUsername; ?>">
                </div>
                <div class="form-group">
                    <label for="ic_apiPassword">API Password</label>
                    <input type="password" name="ic_apiPassword" class="form-control" id="ic_apiPassword" value="<?php echo $apiPassword; ?>">
                </div>
                
                <?php if(is_array($lists) && !empty($lists)): ?>
                <div class="form-group">
                    <label for="ic_list_id">iContact List</label>
                    <select name="ic_list_id" id="ic_list_id" class="form-control">
                        <?php 
                        if($lists):
                            foreach ($lists as $key => $value):
                                //print_r($value);
                                echo "<option value='{$value->listId}' ". selected($list_id,$value->listId,false) .">{$value->name}</option>";
                            endforeach;
                        endif;
                        ?>
                    </select>
                </div>
                <?php endif; ?>
            </div>
        </div>
<?php
        
    }
       
    public function subscribeHook($post, $file){
        $name = stripslashes($post['custom_form_field']['name']);
        $email = stripslashes($post['email']);
        $option = get_option('wpdm_email_i_contact');
        $list_id = $option['list_id'];
        //if email is valid subscribe
        if(is_email($email) && $list_id){
            try {
            //add email to contact 
            $contact = $this->api->addContact($email, null, null, $name);
            //add contact to list
            //print_r($contact);
            //echo $list_id . ' ';
            $ret = $this->api->subscribeContactToList($contact->contactId, $list_id, 'normal');
            //print_r($ret);
            } catch (Exception $oException) { // Catch any exceptions
                
            }
            
        }
        
    }
}

WpdmEmailIcontact::getInstance();
