<?php
/*
  Plugin Name: WPDM - Mad Mimi Email Subscription
  Plugin URL: http://www.wpdownloadmanager.com/
  Description: MadMimi Email Subscription Leads generation Addon for Download Manager Plugin
  Version: 1.0.0
  Author: Jesmeen
  Author URI: http://www.wpdownloadmanager.com/

 */

if (!defined('WPINC')) {
    die;
}

class WpdmMadMimi {

    private static $instance;
    private $dir, $url;

    public static function getInstance() {
        if (self::$instance === null) {
            self::$instance = new self;
            self::$instance->actions();
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
        }
        return self::$instance;
    }

    private function actions() {
        register_activation_hook(__FILE__, array($this, 'activate'));
        register_deactivation_hook(__FILE__, array($this, 'deactivate'));

        if (is_admin()) {
            add_filter('add_wpdm_settings_tab', array($this, 'settings_tab_madmimi'));
        }
        if (!is_admin()) {
            
        }
        add_action('wpdm_before_email_download_link', array($this, 'pushTomadmimi'), 10, 2);
    }

    function settings_tab_madmimi($tabs) {
        $tabs['madmimi'] = wpdm_create_settings_tab('madmimi', 'MadMimi', array($this, 'settings'), 'fa fa-envelope');
        return $tabs;
    }

    public function activate() {
        if (false == get_option('wpdm_madmimi')) {
            $option = array('key' => '');
            add_option('wpdm_madmimi', $option);
        }
    }

    public function deactivate() {
        
    }

    public static function getDir() {
        return self::$instance->dir;
    }

    public static function getUrl() {
        return self::$instance->url;
    }

    public function settings() {

        if (isset($_POST['api_key'])) {
            $options['token'] = stripslashes($_POST['api_key']);
            $options['source'] = stripslashes($_POST['email_id']);
            $options['listname'] = stripslashes($_POST['list_name']);


            update_option('wpdm_madmimi', $options);
            die('Settings Saved Successfully.');
        }

        $options = get_option('wpdm_madmimi');
        $api_key = isset($options['token']) ? $options['token'] : '';
        $email_id = isset($options['source']) ? $options['source'] : '';
        $listname = isset($options['listname']) ? $options['listname'] : '';
        ?>
        <div class="panel panel-default">
            <div class="panel-heading">Mad Mimi Authentication Token</div>
            <div class="panel-body">
                <div class="form-group">
                    <label for="email_id">Email ID</label>
                    <input class="form-control" type="text" name="email_id" id="email_id" value="<?php echo $email_id; ?>" placeholder="Enter a Lead Source Name">
                    <p class="help-block">Obtaining your Mad Mimi Newsletter Email ID <a href="https://madmimi.com/user/edit?account_info_tabs=account_info_personal" target="_blank">HERE</a></p>

                </div>
                <div class="form-group">
                    <label for="api_key">Api Key</label>
                    <input class="form-control" type="text" name="api_key" id="api_key" value="<?php echo $api_key; ?>" placeholder="Enter Mad Mimi Auth Token">
                    <p class="help-block">Where Can you Find your Mad Mimi API Key?<a href="https://help.madmimi.com/where-can-i-find-my-api-key/" target="_blank">HERE</a></p>
                </div>
                <div class="form-group">
                    <label for="list_name">List name</label>
                    <input class="form-control" type="text" name="list_name" id="list_name" value="<?php echo $listname; ?>" placeholder="Enter list name">
                    <p class="help-block">Where Can you Find your Mad Mimi list name?<a href="https://madmimi.com/audience_members" target="_blank">HERE</a></p>
                </div>
            </div>
        </div>
        <?php
    }

    public function pushToMadMimi($post, $file) {
        $name = $post['custom_form_field']['name'];
        $names = explode(' ', $name);
        $first_name = $names[0];
        $last_name = $names[1];

        $email = $post['email'];

        if (is_email($email)) {
            $option = get_option('wpdm_madmimi');
            $authtoken = $option['token'];
            $email_id = $option['source'];
            $listname = $option['listname'];

            $data = array('email' => $email_id);

            $url = 'https://api.madmimi.com/audience_lists/'.$listname.'/add';

            // Converted to wp_remote_post from curl in 1.4 for better compatibility
            $body = array('username' => $email_id, 'api_key' => $authtoken, 'email' => $email);
            $response = wp_remote_post($url, array('body' => $body));

            if (!empty($this->debug) && current_user_can('manage_options') && !is_admin()) {
                echo '<pre>' . print_r(array(__('Form Submission Data', 'mad-mimi') => $_POST, __('Mad Mimi URL', 'mad-mimi') => $url, __('What was sent to Mad Mimi', 'mad-mimi') => $body, __('What did Mad Mimi send back?', 'mad-mimi') => $response), true) . '</pre>';
                echo '<p>' . __('(You are seeing this data because you have the `Debug Mad Mimi` setting checked and are logged in as an administrator.)', 'mad-mimi') . '</p>';
            }

            if (!is_wp_error($response) && $response['response']['code'] == 200) {
                return true;
            }
        }
    }

}

WpdmMadMimi::getInstance();
