jQuery(function ($) {
    //console.log(wpdm_mailchimp_options)
    //console.log(mailchimp_list);

    $('#addmap').on('click', function() {
        var clone = $('#maptable tbody tr:last-child').clone();
        $('#maptable tbody').append(clone);
        return false;
    });

    var $body = $('body');

    $body.on('click', '.toggle-on-click', function() {
        if ($(this).is(':checked')) {
            $($(this).data('toggle')).slideDown();
        } else {
            $($(this).data('toggle')).slideUp();
        }
    });
    $body.on('change', '.show-if', function() {
        if ($(this).val() === 'when') {
            $($(this).data('toggle')).show();
        } else {
            $($(this).data('toggle')).hide();
        }
    });

    $body.on('click', '#loadf', function() {
        WPDM.blockUI('#mapa');
        $.get(ajaxurl, {
            action: 'wpdm_maichimp_load_list_mapping_forms',
            list_id: $('#mlist').val()
        }, function(response) {
            $('#maptable').html(response);
            WPDM.unblockUI('#mapa');
        });
    });

    $body.on('click', '.btn-data-map', function() {
        if($('#'+$(this).data('feature')+'_list').val() === ''){
            WPDM.bootAlert("Data Mapping", "Please select a list fist");
            return false;
        }
        var mapwindow = WPDM.bootAlert("Data Mapping", $('#mapfields').html(), 750);
        mapwindow.find('#maptable').append("<i class=\"fa fa-sun fa-spin\"></i> Loading...");
        WPDM.blockUI(mapwindow.find('.modal-body'));
        $.get(ajaxurl, {
            action: 'wpdm_maichimp_load_list_mapping_forms',
            feature: $(this).data('feature'),
            list_id: $('#'+$(this).data('feature')+'_list').val()
        }, function(response) {
            mapwindow.find('#maptable').html(response);
            WPDM.unblockUI(mapwindow.find('.modal-body'));
        });
    });

    $body.on('submit', '#data_mapping_form', function (event) {
        event.preventDefault();
        WPDM.blockUI('#data_mapping_form');
        var button_label = $('#data_mapping_form button[type=submit]').html();
        $('#data_mapping_form button[type=submit]').html('<i class="fa fa-sun fa-spin"></i> Saving...').attr('disabled', 'disabled');
        $(this).ajaxSubmit({
            url: ajaxurl,
            success: function(response){
                WPDM.unblockUI('#data_mapping_form');
                $('#data_mapping_form button[type=submit]').html(button_label).removeAttr('disabled');
                WPDM.notify("<i class='fa fa-check-double'></i> <b>Done!</b><br/>Changes are saved successfully.", "success", "top-right", 7000);
            }
        });
    });

    function initializeMailchimpSelection() {
        $('.mailchimp_selection').each(function (index) {
            var featureID = $(this).data('feature');
            var categoryID = getSavedCategoryID(featureID);
            if (categoryID) {
                getEnableInterestEl(featureID).prop('checked', true);
                $($(getEnableInterestEl(featureID)).data('toggle')).show();
                refreshCategoryAndInterest(featureID);
            } else {
                emptyAndHideCategoryAndInterest(featureID);
            }
        });
    }



    function refreshCategoryAndInterest(featureID) {
        var listEl = getListElOf(featureID);
        var categoryEl = getCategoryElOf(featureID);
        var interestEl = getInterestElOf(featureID);
        var isEnableInterest = getEnableInterestEl(featureID).prop('checked') == true;

        var selectedListID = listEl.val();
        if (!selectedListID || !isEnableInterest) return;

        var selectedCategoryID = getSavedCategoryID(featureID);
        var selectedInterestIDs = getSavedInterestIDs(featureID);
        console.log(selectedCategoryID);

        categoryEl.empty();
        interestEl.empty();
        categoryEl.append($('<option>', {
            value: null,
            text: 'Select Category',
        }));
        WPDM.blockUI('#' + categoryEl.attr('id') + '_chosen');
        jQuery.get("admin-ajax.php", {
            action: "wpdm_mailchimp",
            list_id: selectedListID
        }, function (data, status) {
            console.log(data);
            var t = data.length;
            $.each(data, function (key, val) {
                //console.log(key, val);
                isOptionSelected = (selectedCategoryID === key) ? true : false;
                categoryEl.append($('<option>', {
                    value: key,
                    text: val,
                    selected: isOptionSelected
                }));
                if (!--t) {
                    categoryEl.trigger('chosen:updated');
                    WPDM.unblockUI('#' + categoryEl.attr('id') + '_chosen');
                }
            }); //.promise().done( function(){ alert("All was done"); } );;

            refreshInterests(featureID);

        });
    }


    function refreshInterests(featureID) {
        var listEl = getListElOf(featureID);
        var categoryEl = getCategoryElOf(featureID);
        var interestEl = getInterestElOf(featureID);

        var selectedListID = listEl.val();
        var selectedCategoryID = categoryEl.val();
        var selectedInterestIDs = getSavedInterestIDs(featureID);

        interestEl.empty();
        interestEl.append($('<option>', {
            value: null,
            text: 'Select Interest',
        }));
        WPDM.blockUI('#' + interestEl.attr('id') + '_chosen');
        jQuery.get("admin-ajax.php", {
            action: "wpdm_mailchimp",
            list_id: selectedListID,
            category_id: selectedCategoryID
        }, function (data, status) {
            console.log(data);
            var t = data.length;
            $.each(data, function (key, val) {
                //console.log(key, val);
                var isOptionSelected = (selectedInterestIDs && selectedInterestIDs.includes(key)) ? true : false;

                interestEl.append($('<option>', {
                    value: key,
                    text: val,
                    selected: isOptionSelected
                }));
                if (!--t) {
                    interestEl.trigger('chosen:updated');
                    WPDM.unblockUI('#' + interestEl.attr('id') + '_chosen');
                }
            });
        });
    }





    $('.mailchimp_list').change(function (e) {
        var featureID = $(this).data('feature');
        refreshCategoryAndInterest(featureID);
    });

    $('.mailchimp_category').change(function (e) {
        var featureID = $(this).data('feature');
        refreshInterests(featureID);
    });


    $('.mailchimp_enable_interests').change(function (e) {
        var featureID = $(this).data('feature');

        if ($(this).is(':checked')) {
            $($(this).data('toggle')).slideDown();
            refreshCategoryAndInterest(featureID, $(this).data('toggle'));

        } else {
            //emptyAndHideCategoryAndInterest(feature);
            $($(this).data('toggle')).slideUp();
        }
    });

    function emptyAndHideCategoryAndInterest(featureID) {
        var categoryEl = getCategoryElOf(featureID);
        var interestEl = getInterestElOf(featureID);
        categoryEl.empty();
        interestEl.empty();
        categoryEl.hide();
        interestEl.hide();
    }


    function showCategoryAndInterest(featureID) {
        getCategoryElOf(featureID).show();
        getInterestElOf(featureID).show();
    }

    // JQUERY ELEMENTS

    function getListElOf(featureID) {
        return $("#" + featureID + "_list");
    }

    function getCategoryElOf(featureID) {
        return $("#" + featureID + "_category");
    }

    function getInterestElOf(featureID) {
        return $("#" + featureID + "_interests");
    }

    function getEnableInterestEl(featureID) {
        return $("#" + featureID + "_enable_interests");
    }


    // DB data

    function getSavedListID(featureID) {
        if(wpdm_mailchimp_options[featureID] === undefined) return '';
        return wpdm_mailchimp_options[featureID].list_id;
    }

    function getSavedCategoryID(featureID) {
        if(wpdm_mailchimp_options[featureID] === undefined) return '';
        return wpdm_mailchimp_options[featureID].category_id;
    }

    function getSavedInterestIDs(featureID) {
        if(wpdm_mailchimp_options[featureID] === undefined) return '';
        return wpdm_mailchimp_options[featureID].interest_ids;
    }




    initializeMailchimpSelection();

    $('.mailchimp_list_user_role').select2({
        width: '350px'
    });


});


