<script>
    // this values used in the admin.js
    var wpdm_mailchimp_options = <?php echo json_encode($options); ?>;
    var mailchimp_list = <?php echo json_encode($lists); ?>;
</script>

<div class="panel panel-default" id="mailchimp-panel">
    <div class="panel-heading">MailChimp API Configuration</div>
    <?php global $wpdm_mailchimp; ?>
    <?php $wpdm_mailchimp->render_manager->render_connection_alert(['is_connected' => $is_connected]); ?>
    <div class="panel-body">
        <label for="mailchimp_api_key">MailChimp API Key</label>
        <input class="form-control" type="text" name="<?= WPDM_MAILCHIMP_OPTION_KEY . "[api_key]" ?>" id="<?= WPDM_MAILCHIMP_ID_PREFIX . 'api_key' ?>" value="<?= $wpdm_mailchimp->data_manager->get_single_data('api_key') ?>" placeholder="Enter MailChimp API Key">
        <em class="note"><a target="_blank" href="https://kb.mailchimp.com/integrations/api-integrations/about-api-keys">How To Generate MailChimp API Key?</a></em>
    </div>
</div>
<?php if ($is_connected) : ?>
<div class="panel panel-default" id="mailchimp-panel">
    <div class="panel-heading">MailChimp List Mapping</div>
    <div class="panel-body">

        <!-- Mailchimp API Key -->


            <!-- Email Lock Mailchimp List selection-->
            <?php foreach ($constant_features as $feature) : ?>
                <div class="form-group mailchimp">
                    <label for="mailchimp_list"><?= $feature['title'] ?></label>
                    <div class="row">
                        <div class="col-md-8">
                            <?php $wpdm_mailchimp->render_manager->render_mailchimp_selection(['feature' => $feature, 'lists' => $lists, 'info' => $wpdm_mailchimp->data_manager->get_feature_data($feature['name'])]) ?>
                        </div>
                        <div class="col-md-4">
                            <button type="button" class="btn btn-info btn-block btn-data-map" data-feature="<?php echo $feature['id']; ?>"><i class="fa fa-cog"></i> Data Mapping</button>
                        </div>
                    </div>
                    <em class="note"><?= $feature['note'] ?></em>
                </div>
            <?php endforeach; ?>


            <!-- User Role mailchimp selection-->
            <table class="table table-striped roles-table" style="border: 1px solid #ddd;">
                <tr>
                    <th colspan="3">MailChimp List For User Sign Up ( Role Based ) & Pro Membership Levels</th>
                </tr>
                <tr>
                    <th style="width: 150px;">User Role</th>
                    <th>MailChimp List</th>
                    <th style="width: 100px">Data Mapping</th>
                </tr>
                <?php foreach ($user_role_features as $feature) : ?>
                    <tr>
                        <td><?= $feature['title'] ?></td>
                        <td>
                            <?php $wpdm_mailchimp->render_manager->render_mailchimp_selection(['feature' => $feature, 'lists' => $lists, 'info' => $wpdm_mailchimp->data_manager->get_feature_data($feature['name'])]) ?>
                        </td>
                        <td>
                            <button type="button" class="btn btn-info btn-block btn-data-map" data-feature="<?php echo $feature['id']; ?>"><i class="fa fa-cog"></i> Configure</button>
                        </td>
                    </tr>
                <?php endforeach; ?>
            </table>

            <!-- Double Optin checkbox -->
            <div class="form-group">
                <label for="<?= WPDM_MAILCHIMP_ID_PREFIX . 'enable_double_optin' ?>">
                    <input type="checkbox" name="<?= WPDM_MAILCHIMP_OPTION_KEY . "[enable_double_optin]" ?>" id="<?= WPDM_MAILCHIMP_ID_PREFIX . 'enable_double_optin' ?>" value="1" <?php checked(1, $wpdm_mailchimp->data_manager->get_single_data('enable_double_optin')); ?>>
                    Enable Double Opt-in</label>
            </div>


    </div>


</div>
<?php endif ?>
<!-- Field Mapping Section -->
<div  id="mapfields" class="hide">
    <?php $wpdm_mailchimp->render_manager->render_list_settings_tab(); ?>
</div>
