<?php

/**
 * Base: wpdmpro
 * Developer: shahjada
 * Team: W3 Eden
 * Date: 26/6/20 18:00
 */
if (!defined("ABSPATH")) die();

global $wpdm_mailchimp;
?>
<form method="post" id="data_mapping_form">
<?php
if (count($merge_fields) > 0) : ?>
    <div class="panel panel-default panel-light">
        <div class="panel-heading">
            Custom Fields
        </div>
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>Form Field</th>
                    <th>Data Source</th>
                    <th>Data Name</th>

                </tr>
            </thead>
            <tbody id="fields">

                <?php

                // TODO move it to data manager
                $data_sources = [
                    ['id' => 'form', 'name' => 'Form'],
                    ['id' => 'user', 'name' => 'User'],
                    ['id' => 'package', 'name' => 'Package'],
                    ['id' => 'server', 'name' => 'Package'],
                ];
                ?>
                <?php foreach ($merge_fields as $field) : ?>
                    <tr>
                        <td><?= $field['name'] ?></td>
                        <td>
                            <?php
                            //TODO should do in a better way
                            try {
                                $selected_source_id = $saved_settings['merge_fields'][$field['tag']]['source'];
                            } catch (Exception $e) {
                                $selected_source_id = null;
                            }

                            ?>

                            <select class="form-control wpdm-custom-select system-ui" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[merge_fields][{$field['tag']}][source]"; ?>">
                                <option value="">Select Data Source</option>
                                <?php foreach ($data_sources as $source) : ?>
                                    <option value="<?= $source['id']; ?>" <?= $source['id'] == $selected_source_id ? 'selected="selected"' : ''; ?>> <?= $source['name']; ?></option>
                                <?php endforeach; ?>
                            </select>
                        </td>
                        <td>
                            <div class="input-group">
                                <input type="text" class="form-control" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[merge_fields][{$field['tag']}][field]"; ?>" />
                                <div class="input-group-btn">
                                    <button type="button" style="height: 34px !important;padding: 0 15px;line-height: 34px" class="btn btn-secondary"><i class="fa fa-bars"></i></button>
                                </div>
                            </div>
                        </td>

                    </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
    </div>
<?php endif ?>


<?php if (count($interest_categories) > 0) : ?>

    <div class="panel panel-default panel-light mcgroups-panel">
        <div class="panel-heading">Groups</div>
        <table class="table table-striped" id="maptable">
            <thead>
                <tr>
                    <th width="150px">Interest Groups</th>
                    <th>Interests</th>
                </tr>
            </thead>
            <?php
            foreach ($interest_categories as $category) :
                $interests = $wpdm_mailchimp->data_manager->api->get_interests($list['id'], $category['id']);
                //var_dump($interests);
            ?>
                <tr>
                    <td style="vertical-align: top !important;"><?php echo $category['title']; ?></td>
                    <td>
                        <?php foreach ($interests as $interest) : ?>
                            <div class="interest" id="interest_<?= $interest['id']; ?>">
                                <!-- interest checkbox -->
                                <label>
                                    <?php $is_checked =  in_array($interest['id'], $saved_settings['interests']); ?>
                                    <input type="checkbox" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[interests][]" ?>" value="<?= $interest['id']; ?>" <?= $is_checked ? 'checked' : '' ?> class="toggle-on-click" data-toggle="#cond-interest_<?= $interest['id']; ?>"> <?php echo $interest['name']; ?>
                                </label>

                                <!-- interest conditions -->
                                <div class="panel panel-default panel-light" id="cond-interest_<?= $interest['id']; ?>" <?php if(!$is_checked) { ?>style="display:none;"<?php } ?>>
                                    <div class="panel-heading">Assign To Group:</div>
                                    <div class="panel-body">
                                        <div class="row">
                                            <div class="col-md-3">
                                                <select name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[assign_interest][{$interest['id']}][show]" ?>" class="wpdm-custom-select system-ui form-control show-if" data-toggle=".condc-interest_<?= $interest['id']; ?>">
                                                    <option value="always">Always</option>
                                                    <option value="when" <?php selected('when', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/show")); ?> >When</option>
                                                </select>
                                            </div>
                                            <div class="col-md-3 condc-interest_<?= $interest['id']; ?>" style="padding-left: 0;<?php if(wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/show") !== 'when') { ?>display: none<?php } ?>">
                                                <select class="wpdm-custom-select system-ui form-control" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[assign_interest][{$interest['id']}][field_name]" ?>">
                                                    <option value="first_name">First Name</option>
                                                    <option value="last_name" <?php selected('last_name', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/field_name")); ?>>Last Name</option>
                                                    <option value="package_name" <?php selected('package_name', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/field_name")); ?>>Package Name</option>
                                                    <option value="package_category" <?php selected('package_category', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/field_name")); ?>>Package Category</option>
                                                    <option value="tags" <?php selected('tags', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/field_name")); ?>>Package Tag</option>
                                                </select>
                                            </div>
                                            <div class="col-md-3 condc-interest_<?= $interest['id']; ?>" style="padding-left: 0;<?php if(wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/show") !== 'when') { ?>display: none<?php } ?>" >
                                                <select class="form-control wpdm-custom-select system-ui" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[assign_interest][{$interest['id']}][compare]" ?>">
                                                    <option value="is" <?php selected('is', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>is</option>
                                                    <option value="isnot" <?php selected('isnot', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>is not</option>
                                                    <option value=">" <?php selected('>', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>greater than</option>
                                                    <option value="<" <?php selected('<', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>less than</option>
                                                    <option value="contains" <?php selected('contains', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>contains</option>
                                                    <option value="starts_with" <?php selected('starts_with', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>starts with</option>
                                                    <option value="ends_with" <?php selected('ends_with', wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/compare")); ?>>ends with</option>
                                                </select>
                                            </div>
                                            <div class="col-md-3 condc-interest_<?= $interest['id']; ?>" style="padding-left: 0;<?php if(wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/show") !== 'when') { ?>display: none<?php } ?>">
                                                <input type="text" value="<?php echo wpdm_valueof($saved_settings, "assign_interest/{$interest['id']}/value"); ?>" class="form-control" name="<?= WPDM_MAILCHIMP_LIST_SETTINGS_KEY . "[assign_interest][{$interest['id']}][value]" ?>" />
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        <?php endforeach; ?>
                    </td>
                </tr>
            <?php endforeach; ?>
            </tbody>

        </table>
    </div>
<?php endif; ?>
    <input type="hidden" name="feature" value="<?php echo wpdm_query_var('feature') ?>" />
    <input type="hidden" name="list_id" value="<?php echo wpdm_query_var('list_id') ?>" />
    <input type="hidden" name="action" value="save_data_mapping" />
    <div class="well well-sm text-right">
        <button type="submit" class="btn btn-success">Save Data Mapping</button>
    </div>
</form>
