<?php
class NewsletterAjax{
    private static $instance;
    private $util;

    public static function getInstance(){

        if (self::$instance === null) {
            self::$instance = new self;
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
            self::$instance->actions();
        }
        return self::$instance;
    }

    private function actions(){
        $this->util = new \CAMPAIGN\UTIL\Utility();
        add_action('wp_ajax_eden_template_change', array($this, 'eden_template_change'));

        add_action('wp_ajax_eden_subscribe', array($this, 'edenSubscribe'));
        add_action('wp_ajax_nopriv_eden_subscribe', array($this, 'edenSubscribe'));

        //post subscribe hook
        add_action('wp_ajax_eden_campaign_post_subscribe', array($this, 'postSubscribe'));
        add_action('wp_ajax_nopriv_eden_campaign_post_subscribe', array($this, 'postSubscribe'));

        //post unsubscribe hook
        add_action('wp_ajax_eden_campaign_post_unsubscribe', array($this, 'postUnsubscribe'));

        add_action('wp_ajax_eden_campaign_list_unsubscribe', array($this, 'edenListUnsubscribe'));
        add_action('wp_ajax_nopriv_eden_campaign_list_unsubscribe', array($this, 'edenListUnsubscribe'));

        //profile update hook
        add_action('wp_ajax_eden_subscriber_profile', array($this, 'edenUpdateProfile'));
        add_action('wp_ajax_nopriv_eden_subscriber_profile', array($this, 'edenUpdateProfile'));

        //subscribe to campaign from profile page
        add_action('wp_ajax_eden_sc_subscribe', array($this, 'edenScSubscribe'));
        add_action('wp_ajax_nopriv_eden_sc_subscribe', array($this, 'edenScSubscribe'));

        //unsubscribe to campaign from profile page
        add_action('wp_ajax_eden_sc_unsubscribe', array($this, 'edenScUnSubscribe'));
        add_action('wp_ajax_nopriv_eden_sc_unsubscribe', array($this, 'edenScUnSubscribe'));
    }

    public function edenScSubscribe(){
        $result['type'] = '';
        global $wpdb;
        //check nonce
        if (check_ajax_referer('eden_sc_subscribe', 'nonce', false)) {
            if (is_user_logged_in()) {
                $user_id = get_current_user_id();
                $query = "UPDATE {$wpdb->eden_subscriber} SET active=1 where user_id=$user_id LIMIT 1";
                if ($wpdb->query($query) == 1) {
                    $result['message'][] = "Successfully Subscribed";
                } else {
                    $result['error'][] = "Database Error";
                }

            } else {
                $email = isset($_REQUEST['token']) ? $_REQUEST['token'] : '';
                if (!is_email($email)) {
                    $result['error'][] = "Invalid Token";
                } else {
                    $adminemail = new \CAMPAIGN\UTIL\AdminMail();
                    $data = $wpdb->get_row("SELECT * FROM $wpdb->eden_subscriber WHERE email='$email' LIMIT 1", ARRAY_A);
                    $adminemail->sendSubscribeEmail($data);
                    $message = $this->util->getOption('confirmation_msg', 'campaign_subscriber_subscribe');
                    if ($message == "") {
                        $message = "Successfully Subscribed";
                    }
                    $result['message'][] = $message;

                }

            }

            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }

    public function edenScUnSubscribe()
    {
        $result['type'] = '';
        global $wpdb;
        //check nonce
        if (check_ajax_referer('eden_sc_unsubscribe', 'nonce', false)) {
            if (is_user_logged_in()) {
                $user_id = get_current_user_id();
                $query = "UPDATE {$wpdb->eden_subscriber} SET active=0 where user_id=$user_id LIMIT 1";
                if ($wpdb->query($query) == 1) {
                    $result['message'][] = "Successfully Unsubscribed";
                } else {
                    $result['error'][] = "Database Error";
                }

            } else {
                $email = isset($_REQUEST['token']) ? $_REQUEST['token'] : '';
                if (!is_email($email)) {
                    $result['error'][] = "Invalid Token";
                } else {
                    $adminemail = new \CAMPAIGN\UTIL\AdminMail();
                    $data = $wpdb->get_row("SELECT * FROM $wpdb->eden_subscriber WHERE email='$email' LIMIT 1", ARRAY_A);
                    $adminemail->sendUnSubscribeEmail($data);
                    $message = $this->util->getOption('unsubscribe_success_msg', 'campaign_subscriber_unsubscribe');
                    if ($message == "") {
                        $message = "Successfully Unsubscribed";
                    }
                    $result['message'][] = $message;

                }

            }

            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }


    public function edenListUnsubscribe()
    {
        $result['type'] = '';
        //check nonce
        if (check_ajax_referer('list_unsubscribe', 'nonce', false)) {
            $util = new \CAMPAIGN\UTIL\Utility();
            $list_all = $util->getTerms();
            $id = isset($_REQUEST['id']) ? $_REQUEST['id'] : '';
            $list_id = isset($_REQUEST['list_id']) ? $_REQUEST['list_id'] : '';
            $flag = false;
            global $wpdb;

            if (!is_numeric($id)) {
                $result['error'][] = "Invalid ID";
                $flag = true;
            }
            if (!is_numeric($list_id)) {
                $result['error'][] = "Invalid List ID";
                $flag = true;
            }
            if (!array_key_exists($list_id, $list_all)) {
                $result['error'][] = "Invalid List ID";
                $flag = true;
            }

            if ($flag == false) {

                $query = "UPDATE {$wpdb->eden_subscriber_list} SET active=0 WHERE id='$id' AND list_id=$list_id LIMIT 1";
                if ($wpdb->query($query)) {
                    $result['message'][] = "List unsubscribed successfully";
                } else {
                    $wpdb->show_errors();
                    $wpdb->print_error();
                }

            }

            $result['type'] = 'success';
        } else {
            $result['error'][] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }


    public function edenUpdateProfile()
    {
        $result['type'] = '';
        //check nonce
        global $wpdb;
        if (check_ajax_referer('eden_subscriber', 'nonce', false)) {
            $fname = isset($_REQUEST['data']['fname']) ? stripslashes($_REQUEST['data']['fname']) : '';
            $lname = isset($_REQUEST['data']['lname']) ? stripslashes($_REQUEST['data']['lname']) : '';
            $gender = isset($_REQUEST['data']['gender']) ? stripslashes($_REQUEST['data']['gender']) : '';
            $id = isset($_REQUEST['data']['id']) ? stripslashes($_REQUEST['data']['id']) : '';
            $db_data = array(
                'fname' => $fname,
                'lname' => $lname,
                'gender' => $gender
            );
            $format = array('%s', '%s', '%d');

            if (is_user_logged_in()) {
                $user_id = get_current_user_id();

                $where = array('user_id' => $user_id);
                $format_where = array('%d');
                if ($wpdb->update($wpdb->eden_subscriber, $db_data, $where, $format, $format_where)) {
                    $result['message'][] = "Profile Updated";
                } else {
                    $result['error'][] = "No Change";
                    //$wpdb->show_errors();
                    //$wpdb->print_error();
                }
            } else {
                if (is_numeric($id)) {
                    $where = array('id' => $id);
                    $format_where = array('%d');
                    if ($wpdb->update($wpdb->eden_subscriber, $db_data, $where, $format, $format_where)) {
                        $result['message'][] = "Profile Updated";
                    } else {
                        $result['error'][] = "No Change";
                        //$wpdb->show_errors();
                        //$wpdb->print_error();
                    }
                } else {
                    $result['error'][] = "Invalid Entry";
                }
            }


            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }

    public function edenSubscribe()
    {
        $result['type'] = '';
        //check nonce
        global $wpdb;
        if (check_ajax_referer('eden_subscriber', 'eden_subscriber_nonce', false)) {
            $data = $_POST['eden_subscribe'];
            //$result['data'] = $data;
            $temp = array(
                'fname' => "",
                'lname' => '',
                'gender' => '',
                'list_id' => '',
                'email' => ''

            );
            $util = new \CAMPAIGN\UTIL\Utility();
            $list_all = $util->getTerms();
            if (is_user_logged_in()) {
                global $current_user;
                get_currentuserinfo();
                $email = $current_user->user_email;
                $user_id = $current_user->ID;
                $first_name = $current_user->user_firstname;
                $last_name = $current_user->user_lastname;
                $gender = isset($data['gender']) ? $data['gender'] : "";
                if (!empty($data['list_id'])) {
                    $query = "SELECT id,user_id FROM {$wpdb->eden_subscriber} WHERE email='$email' LIMIT 1";
                    $res = $wpdb->get_row($query, ARRAY_A);
                    $subscriber_id = $res['id'];
                    if ($res['user_id'] == "" || $res['user_id'] == NULL) {
                        $wpdb->query("UPDATE $wpdb->eden_subscriber SET user_id=$user_id where id=$subscriber_id");
                    }

                    foreach ($data['list_id'] as $key => $value):


                        if (array_key_exists($value, $list_all)) {
                            //valid list id

                            //check subscriber id
                            if (NULL == $subscriber_id) {
                                //new row insert
                                //insert new
                                $db_data = array(
                                    'user_id' => $user_id,
                                    'fname' => $first_name,
                                    'lname' => $last_name,
                                    'gender' => $gender,
                                    'email' => $email
                                );

                                $format = array(
                                    "%d", "%s", "%s", "%d", "%s"
                                );
                                if ($wpdb->insert($wpdb->eden_subscriber, $db_data, $format)) {
                                    //$result['message'][] = "<div class='alert alert-success'>Successfully Subscribed to the list " . $list_all[$value] ."</div>";
                                    $subscriber_id = $wpdb->insert_id;
                                } else {
                                    $wpdb->show_errors();
                                    $wpdb->print_error();
                                }
                            }

                            //check already subscribed or not...

                            $query = "SELECT id,active FROM $wpdb->eden_subscriber_list WHERE list_id=$value and subscriber_id='$subscriber_id' LIMIT 1";
                            $res = $wpdb->get_row($query, ARRAY_A);
                            if (!empty($res) && $res['active'] == 1) {
                                //already subscribed
                                $result['message'][] = "<div class='alert alert-warning'>Already Subscribed To The List " . $list_all[$value] . "</div>";
                            } else {
                                if (!empty($res) && $res['active'] == 0) {
                                    //already in database, change active to 1
                                    $data = array('active' => 1);
                                    $format = array('%d');
                                    $where = array(
                                        'list_id' => $value,
                                        'subscriber_id' => $subscriber_id
                                    );
                                    $format_where = array('%d', '%d');

                                    if ($wpdb->update($wpdb->eden_subscriber_list, $data, $where, $format, $format_where)) {
                                        $result['message'][] = "<div class='alert alert-success'>Successfully Subscribed to the list " . $list_all[$value] . "</div>";
                                    } else {
                                        $wpdb->show_errors();
                                        $wpdb->print_error();
                                    }
                                } else {
                                    //insert new row

                                    $data = array(
                                        'list_id' => $value,
                                        'subscriber_id' => $subscriber_id
                                    );
                                    $format = array('%d', '%d');
                                    if ($wpdb->insert($wpdb->eden_subscriber_list, $data, $format)) {
                                        $result['message'][] = "<div class='alert alert-success'>Successfully Subscribed to the list " . $list_all[$value] . "</div>";
                                    } else {
                                        $wpdb->show_errors();
                                        $wpdb->print_error();
                                    }
                                }

                            }
                        } else {
                            $result['message'][] = "<div class='alert alert-danger'>Invalid List ID Found '$value'</div>";
                        }


                    endforeach;
                } else {
                    $result['error'][] = "<div class='alert alert-danger'>Check some subscriber list</div>";
                }


            } else {
                $fname = isset($data['fname']) ? stripslashes($data['fname']) : "";
                $lname = isset($data['lname']) ? stripslashes($data['lname']) : "";
                $gender = isset($data['gender']) ? $data['gender'] : "";
                $email = isset($data['email']) ? stripslashes($data['email']) : "";
                $flag = false;
//               if($fname == "") {
//                   $result['error'][] = "<div class='alert alert-danger'>Please Enter First Name</div>";
//                   $flag=true;
//               }
//               if($lname == ""){
//                   $result['error'][] = "<div class='alert alert-danger'>Please Enter Last Name</div>";
//                   $flag=true;
//               }
//               if($gender == ""){
//                   $result['error'][] = "<div class='alert alert-danger'>Please Select Gender</div>";
//                   $flag=true;
//               }
                if ($email == "") {
                    $result['error'][] = "<div class='alert alert-danger'>Please Enter Email Address</div>";
                    $flag = true;
                }
                if (!is_email($email)) {
                    $result['error'][] = "<div class='alert alert-danger'>Please Enter Valid Email Address</div>";
                    $flag = true;
                }

                if (empty($data['list_id'])) {
                    $result['error'][] = "<div class='alert alert-danger'>Check some subscriber list</div>";
                    $flag = true;
                }

                if ($flag == false) {
                    $query = "SELECT id,user_id FROM {$wpdb->eden_subscriber} WHERE email='$email' LIMIT 1";
                    $temp = $wpdb->get_row($query, ARRAY_A);
                    $subscriber_id = $temp['id'];
                    $user_id = $temp['user_id'];
                    if (is_numeric($user_id)) {
                        $login = wp_login_url();

                        $result['error'][] = "<div class='alert alert-danger'>Please <a href='$login' title='Login'>Login</a> To Subscribe.</div>";
                    } else {
                        foreach ($data['list_id'] as $key => $value) {
                            if (array_key_exists($value, $list_all)) {
                                //check for subscriber id
                                if (NULL == $subscriber_id) {
                                    //insert new row
                                    $db_data = array(
                                        'fname' => $fname,
                                        'lname' => $lname,
                                        'gender' => $gender,
                                        'email' => $email
                                    );

                                    $format = array(
                                        "%s", "%s", "%d", "%s"
                                    );

                                    //check for double or single opt here
                                    if ($util->getOption('opt_in', 'campaign_subscriber_basic') == 0) {
                                        //double opt in
                                        $token = md5(uniqid($email, true));


                                        $db_data['token'] = $token;
                                        $db_data['active'] = 0;

                                        $format[] = "%s";
                                        $format[] = '%d';
                                    }


                                    if ($wpdb->insert($wpdb->eden_subscriber, $db_data, $format)) {
                                        $result['message'][] = "<div class='alert alert-success'>" . $util->getOption('confirmation_msg', 'campaign_subscriber_subscribe') . "</div>";
                                        $subscriber_id = $wpdb->insert_id;

                                        if ($util->getOption('opt_in', 'campaign_subscriber_basic') == 0) {
                                            //send subscribe email here....
                                            $mail = new \CAMPAIGN\UTIL\AdminMail();
                                            $mail->sendSubscribeEmail($db_data);
                                        }

                                    } else {
                                        $wpdb->show_errors();
                                        $wpdb->print_error();
                                    }

                                }


                                //check already subscribed or not...

                                $query = "SELECT id,active FROM $wpdb->eden_subscriber_list WHERE list_id=$value and subscriber_id='$subscriber_id' LIMIT 1";
                                $res = $wpdb->get_row($query, ARRAY_A);
                                if (!empty($res) && $res['active'] == 1) {
                                    //already subscribed
                                    $result['message'][] = "<div class='alert alert-warning'>Already Subscribed To The List " . $list_all[$value] . "</div>";
                                } else {
                                    if (!empty($res) && $res['active'] == 0) {
                                        //already in database, change active to 1
                                        $data = array('active' => 1);
                                        $format = array('%d');
                                        $where = array(
                                            'list_id' => $value,
                                            'subscriber_id' => $subscriber_id
                                        );
                                        $format_where = array('%d', '%d');

                                        if ($wpdb->update($wpdb->eden_subscriber_list, $data, $where, $format, $format_where)) {
                                            $result['message'][] = "<div class='alert alert-success'>Successfully Subscribed to the list " . $list_all[$value] . "</div>";
                                        } else {
                                            $wpdb->show_errors();
                                            $wpdb->print_error();
                                        }
                                    } else {
                                        //insert new row

                                        $data = array(
                                            'list_id' => $value,
                                            'subscriber_id' => $subscriber_id
                                        );
                                        $format = array('%d', '%d');
                                        if ($wpdb->insert($wpdb->eden_subscriber_list, $data, $format)) {
                                            $result['message'][] = "<div class='alert alert-success'>Successfully Subscribed to the list " . $list_all[$value] . "</div>";
                                        } else {
                                            $wpdb->show_errors();
                                            $wpdb->print_error();
                                        }
                                    }

                                }
                            } else {
                                $result['message'][] = "<div class='alert alert-danger'>Invalid List ID Found '$value'</div>";
                            }

                        }
                    }

                    if (isset($success) && is_array($success) && !empty($success)) {
                        //if double opt is enabled
                    }


                }

            }


            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
//            if(isset($result['message']) && is_array($result['message'])) {
//                json_encode($result['message']);
//            }
//            if(isset($result['error']) && is_array($result['error'])) {
//                json_encode($result['error']);
//            }
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }


    public function postSubscribe()
    {
        if (!wp_verify_nonce($_REQUEST['nonce'], 'post_subscribe')) {
            die('No Naughty Business');
        }
        $result['type'] = 'error';
        if (is_user_logged_in()) {

            $post_id = wpdm_query_var('post_id', 'int');
            $user_id = get_current_user_id();
            $data = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));
            $data2 = maybe_unserialize(get_user_meta($user_id, '_eden_campaign_subscriber', true));
            if (is_array($data) && in_array($user_id, $data)) {
                //already in array
            } else {
                if(!is_array($data)) $data = array();
                $data[] = $user_id;
                update_post_meta($post_id, '_eden_campaign_subscriber', $data);
            }

            if (is_array($data2) && in_array($post_id, $data2)) {
                //already_in_array
            } else {
                if(!is_array($data2)) $data2 = array();
                $data2[] = $post_id;
                update_user_meta($user_id, '_eden_campaign_subscriber', $data2);
            }


            $result['type'] = "success";

        } else {

            $post_id = $_GET['post_id'];
            $email = $_REQUEST['email'];
            $data = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));


            if (!empty($data) && in_array($email, $data)) {
                //already in array
            } else {
                $data[] = $email;
                array_unique($data);
                update_post_meta($post_id, '_eden_campaign_subscriber', $data);
            }

            $result['type'] = "success";

        }

        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }

    public function postUnsubscribe(){
        if (!wp_verify_nonce($_REQUEST['nonce'], 'post_unsubscribe')) {
            die('No Naughty Business');
        }

        $result['type'] = 'error';
        if (is_user_logged_in()) {

            $post_id = $_GET['post_id'];
            $user_id = get_current_user_id();
            $data = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));

            if (!empty($data) && in_array($user_id, $data)) {
                $key = array_search($user_id, $data);
                unset($data[$key]);
                update_post_meta($post_id, '_eden_campaign_subscriber', $data);
                $result['type'] = 'success';
            }

            $data2 = maybe_unserialize(get_user_meta($user_id, '_eden_campaign_subscriber', true));
            if (!empty($data2) && in_array($post_id, $data2)) {
                $key = array_search($post_id, $data2);
                unset($data2[$key]);
                update_user_meta($user_id, '_eden_campaign_subscriber', $data2);
                $result['type'] = 'success';
            }

        }
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }

    public function eden_template_change(){
        $result['type'] = '';
        //check nonce
        if (check_ajax_referer('ajax_nonce', 'nonce', false)) {
            $template = $_REQUEST['template_name'];
            $util = new \CAMPAIGN\UTIL\Utility();
            $content = $util->getTemplateData($template);
            $result['data'] = $content;
            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }


        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }

    public function ajaxTemplate(){
        $result['type'] = '';
        //check nonce
        if (check_ajax_referer('ajax_nonce', 'nonce', false)) {
            $result['type'] = 'success';
        } else {
            $result['type'] = "Nonce Error";
        }

        //echo result
        if (!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') {
            $result = json_encode($result);
            echo $result;
        } else {
            header("Location: " . $_SERVER["HTTP_REFERER"]);
        }

        die();
    }
}
