<?php
namespace CAMPAIGN;

if(!defined('WPINC')) {
    exit;
}

class ActionHooks{
    private static $instance;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function actions(){
        //frontend enqueue script
        add_action('wp_enqueue_scripts',array($this,'frontEndScript'));
        add_action('init',array($this,'exportCsv'));
    }
    
    public function frontEndScript(){
        wp_enqueue_script('jquery-form');
    }
    
    public function exportCsv(){
        global $wpdb;
        if(isset($_POST['export_eden_subscriber']) && check_admin_referer('export_csv')){

            $data = $_POST['eden_export'];
            $active = isset($data['active']) ? $data['active'] : '-1';
            $query = "SELECT * FROM {$wpdb->eden_subscriber} ";
            
            if($active != '-1') {
                $active = (int) $active;
                $query .= " WHERE active=$active";
            }
            
            $results = $wpdb->get_results($query,ARRAY_A);
            if(!empty($results)){
                // output headers so that the file is downloaded rather than displayed
                header('Content-Type: text/csv; charset=utf-8');
                header('Content-Disposition: attachment; filename=eden_subscriber.csv');

                // create a file pointer connected to the output stream
                $output = fopen('php://output', 'w');
                
                //echo "<pre>";
                foreach ($results as $key => $row) :
                    unset($row['id']);
                    unset($row['user_id']);
                    fputcsv($output, $row);
                endforeach;
            }
            // loop over the rows, outputting them
         
          die;  
        }
    }
}