<?php
namespace CAMPAIGN\ADMIN\PAGES;
class Settings{
    private static $instance;
    private $messages, $errors, $dir, $url, $table,$utility;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->messages = array();
            self::$instance->errors = array();
            self::$instance->utility = new \CAMPAIGN\UTIL\Utility();   
            global $wpdb;
            self::$instance->table = $wpdb->prefix . 'eden_campaign';
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function __construct() {
        ;
    }
    private function actions(){
        ob_start();
        $this->getSettingsForm();
        $content = ob_get_clean();
        echo $this->getHeader();
        echo $content;
        echo $this->getFooter();
        
    }
    
    
    
    private function getSettingsForm(){
        if(!empty($_POST) && check_admin_referer('campaing_settings_page')){
            $data = $_POST['data'];
            array_walk_recursive($data, function (&$value) {
                $value = htmlentities(trim($value));
            });
            
            update_option('eden_campaign_settings', $data);
            
        }
        $data = get_option('eden_campaign_settings');
    ?>    
        <form method="post" action="#" >
            <?php wp_nonce_field('campaing_settings_page'); ?>
            <table class="form-table">
                <tbody>
                <tr>
                    <th scope="row" valign="top">
                        <label for="fname"><?php _e('Post Subscription Post Type','eden_campaign'); ?></label>
                    </th>
                    <td>
                        <?php
                            $post_types = get_post_types( array('public'=>true), 'names' ); 
                            $list = $data['post_type'];
                            foreach ( $post_types as $post_type ) {
                                $selected = "";
                                if(!empty($list) && in_array($post_type,$list)) {
                                    $selected = "checked='checked'";
                                }
                                echo "<label for='{$post_type}_id'><input type='checkbox' name='data[post_type][]' value='{$post_type}' style='width:auto;' id='{$post_type}_id' $selected /> $post_type </label><br>";
                            }
                        ?>
                        <p class="description"><?php if(isset($this->errors['fname'])) echo $this->errors['fname']; ?></p>
                    </td>
                </tr>
                
                </tbody>
            </table>
            <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Save">
                </p>
        </form>
    <?php
    }
    
    
    
    private function getHeader(){
        $message = "";
        if(!empty($this->messages)):
            $message = '<div id="message" class="updated"><p>';
            foreach($this->messages as $key => $msg):
                $message .= $msg . "<br/>";
            endforeach;
            $message .= "</p></div>";
        endif;
    ?>
        <div class="wrap">
            <h2>Campaign Settings</h2>
            <?php echo $message; ?>
            <br>
    <?php
    }
    
    private function getFooter(){
        echo "</div>";
    }
    
}

