<?php
namespace CAMPAIGN\ADMIN\PAGES;

if(!defined('WPINC')) {
    exit;
}

class Subscribers{
    private static $instance;
    private $messages, $errors, $dir, $url, $table,$utility;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->messages = array();
            self::$instance->errors = array();
            self::$instance->utility = new \CAMPAIGN\UTIL\Utility();   
            global $wpdb;
            self::$instance->table = $wpdb->prefix . 'eden_subscriber';
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function __construct() {
        ;
    }
    
    private function actions(){
        if(isset($_REQUEST['page']) && $_REQUEST['page']=='eden_subscriber'):
            
            ob_start();
            if(isset($_REQUEST['add_new'])){
                $this->addNew();
            }
            elseif(isset($_REQUEST['edit'])){
                $this->edit();
            }
            elseif(isset ($_REQUEST['delete'])){
                $this->delete();
            }
            elseif(isset ($_REQUEST['import'])){
                $this->import();
            }
            elseif(isset ($_REQUEST['import_csv'])){
                $this->importCsv();
            }
            elseif(isset ($_REQUEST['export'])){
                $this->export();
            }
            else {
                $this->listTable();
            }
            
            
            $content = ob_get_clean();
            
            echo $this->getHeader();
            echo $content;
            echo $this->getFooter();
            
        endif;
    }
    
    
    private function import(){
        global $wpdb;
        
        if(!empty($_POST) && check_admin_referer('import_users')){
            $query = "SELECT ID,user_email FROM {$wpdb->users} WHERE 1";
            $users = $wpdb->get_results($query,ARRAY_A);
            //echo "<pre>"; print_r($users); echo "</pre>";
            $list_id = isset($_POST['list_id']) ? $_REQUEST['list_id'] : array();
            $count = 0;
            if(!empty($users) && !empty($list_id)){
                foreach ($users as $row):
                    $query = "SELECT id FROM {$wpdb->eden_subscriber} WHERE email='{$row['user_email']}' LIMIT 1";
                    $tmp = $wpdb->get_row($query,ARRAY_A);
                    if($tmp == NULL){
                        $fname = get_user_meta($row['ID'], 'first_name', true);
                        $lname = get_user_meta($row['ID'], 'last_name', true);
                        $user_id = $row['ID'];
                        $email = $row['user_email'];
                        $db_data = array(
                            'fname' => $fname,
                            'lname' => $lname,
                            'email' => $email,
                            'user_id' => $user_id
                        );
                        $format = array('%s','%s','%s','%d');
                        if($wpdb->insert($wpdb->eden_subscriber,$db_data,$format)){
                            $this->messages[] = "<strong>$email</strong> Imported Successfully";
                            $id = $wpdb->insert_id;
                            $query = "DELETE FROM {$wpdb->eden_subscriber_list} WHERE subscriber_id=$id";
                            $wpdb->query($query);
                            $list_all = $this->utility->getTerms();
                            foreach ($list_id as $key => $value):
                                $db_data = array(
                                    'subscriber_id' => $id,
                                    'list_id' => $value
                                );
                                $format = array('%d','%d');
                                if($wpdb->insert($wpdb->eden_subscriber_list, $db_data, $format)){
                                    $this->messages[] = "Successfully Subscribe to the list <strong>{$list_all[$value]}</strong>";
                                }
                                else {
                                    $wpdb->show_errors();
                                    $wpdb->print_error();
                                }
                            endforeach;
                        }
                    }
                    else {
                        $this->errors[] = "Email <strong>{$row['user_email']}</strong> already subscribed";
                    }
                endforeach;
            }
            else {
                $this->errors[] = "Please select campaign list";
                
            }
        }
        $this->importForm();
        
        
        
        
        
    }
    
    private function importForm(){
        $list_all = $this->utility->getTerms();
    ?>
        <form method="post">
            <?php wp_nonce_field('import_users'); ?>
            <table class="form-table">
                <tr>
                    <th>
                        <label><?php _e('Default Campaign List','eden_campaign'); ?></label>
                    </th>
                    <td>
                        <?php 
                            if(!empty($list_all)){
                                foreach ($list_all as $list_id => $name):
                                    echo "<label for='list_id_$list_id'><input type='checkbox' id='list_id_$list_id' name='list_id[]' value='$list_id' style='width:auto;' />$name</label><br>";
                                endforeach;
                            }
                        ?>
                    </td>
                </tr>
            </table>
            <p class="submit">
                <input type="submit" name="submit" id="submit" class="button button-primary" value="Import">
                <input type="button" value="Back" class="button button-secondary" onclick="window.location='<?php echo add_query_arg(array('post_type' => $_REQUEST['post_type'], 'page' => $_REQUEST['page']),'edit.php?' );  ?>'">
            </p>
        </form>
    <?php
    }

    private function importCsv(){
        global $wpdb;
        if(!empty($_POST) && check_admin_referer('eden_import_csv')){
            $list_id = isset($_POST['list_id']) ? $_POST['list_id'] : array();
            if(!empty($list_id)):
            if ($_FILES["file"]["error"] > 0) {
                $this->errors[] = "Please select a CSV file";
            } else {
                $file_name = $_FILES["file"]["tmp_name"];
                
                if (($handle = fopen($file_name, "r")) !== FALSE) {
                    $list_all = $this->utility->getTerms();
                    while (($data = fgetcsv($handle, 5000, ",")) !== FALSE) {
                        $num = count($data);
                        if($num != 7) {
                            //invalid column
                            $this->errors[] = "Invalid CSV column fields";
                            continue;
                        }
                        
                        $email = $data[2];
                        if(!is_email($email))   {
                            $this->errors[] = "Invalid email address <strong>$email</strong>";
                            continue;
                        }

                        $query = "SELECT id FROM {$wpdb->eden_subscriber} WHERE email='$email' LIMIT 1";
                        if($wpdb->get_row($query) == NULL){
                            //valid email
                            $format = array(
                                '%s','%s','%s','%d','%s', '%d','%s'
                            );
                            if($data[4]=="") {
                                $data[4] = md5(uniqid($email, true));
                            }
                            $db_data = array(
                                'fname' => $data[0],
                                'lname' => $data[1],
                                'email' => $data[2],
                                'gender' => $data[3],
                                'token' => $data[4],
                                'active' => $data[5],
                                'updated' => $data[6]
                            );
                            if($wpdb->insert($wpdb->eden_subscriber,$db_data,$format)){
                                $this->messages[] = "Subscriber Added";
                                $id = $wpdb->insert_id;
                                
                                foreach ($list_id as $key => $value){
                                    $db_data = array(
                                        'subscriber_id' => $id,
                                        'list_id' => $value
                                    );
                                    $format = array('%d','%d');
                                    if($wpdb->insert($wpdb->eden_subscriber_list,$db_data,$format)){
                                        $this->messages[] = "Successfully Subscribe to the list <strong>{$list_all[$value]}</strong>";
                                    }
                                    else {
                                        $wpdb->show_errors();
                                        $wpdb->print_error();
                                    }
                                }
                            }
                            else {
                                $wpdb->show_errors();
                                $wpdb->print_error();
                            }
                        }
                        else {
                            //email already exist
                            $this->errors[] = "Email <strong>$email</strong> already exist.";
                        }
                            
                        
                        
                    }
                    fclose($handle);
                }
            }
            else:
            $this->errors[] = "Please select campaign list";
            endif;
        }
        
        $this->importCsvForm();
    }
    
    private function importCsvForm(){
        
    ?>
            <form method="post" enctype="multipart/form-data">
                <?php wp_nonce_field('eden_import_csv') ?>
                <table class="form-table">
                    <tr>
                        <th><?php _e('Campaign List','eden_campaign'); ?>:</th>
                        <td>
                            <?php
                            $list_all = $this->utility->getTerms();
                            if(!empty($list_all)) foreach($list_all as $list_id => $name){
                                echo "<label for='list_id_$list_id'><input type='checkbox' name='list_id[]' id='list_id_$list_id' value='$list_id' />$name</label><br>";
                            }
                            ?>

                        </td>
                    </tr>
                    <tr>
                        <th><?php _e('Select CSV file'); ?>:</th>
                        <td>
                            <input type="file" name='file' value="Choose CSV File">
                        </td>
                    </tr>
                </table>
                <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Import">
                    <input type="button" value="Back" class="button button-secondary" onclick="window.location='<?php echo add_query_arg(array('post_type' => $_REQUEST['post_type'], 'page' => $_REQUEST['page']),'edit.php?' );  ?>'">
                </p>
                
            </form>
                
    <?php        
    }
    
    private function export(){
        
    ?>
         <form method="post" >
             <input type="hidden" name="export_eden_subscriber" value="1">
             <?php wp_nonce_field('export_csv'); ?>
             <table class="form-table">
                 
                 <tr>
                     <th>
                         <label for="active"><?php _e('Subscriber Status','eden_campaign'); ?>:
                     </th>
                     <td>
                         <select name="eden_export[active]" id="active">
                             <option value="-1"><?php _e('All Subscribers','eden_campaign'); ?></option>
                             <option value="1"><?php _e('Active Subscribers','eden_campaign'); ?></option>
                             <option value="0"><?php _e('Inactive Subscribers','eden_campaign'); ?></option>
                     </td>
                 </tr>
             </table>
             <p class="submit">
                <input type="submit" name="submit" id="submit" class="button button-primary" value="Export">
                <input type="button" value="Back" class="button button-secondary" onclick="window.location='<?php echo add_query_arg(array('post_type' => $_REQUEST['post_type'], 'page' => $_REQUEST['page']),'edit.php?' );  ?>'">
            </p>
         </form>
                 
    <?php        
    }
    
    
    
    private function listTable(){
        $table  = new \CAMPAIGN\UTIL\SubscriberList();
        $table->prepare_items();
    ?>
        <form id="movies-filter" method="get">
            <p class="search-box">
                <label class="screen-reader-text" for="post-search-input">Search Subscribers:</label>
                <input type="search" id="post-search-input" name="s" value="<?php if(isset($_REQUEST['s']) && $_REQUEST['s'] != "" )  echo stripslashes($_REQUEST['s']); ?>">
                <input type="submit" name="" id="search-submit" class="button" value="Search Subscribers">
            </p>
            <!-- For plugins, we also need to ensure that the form posts back to our current page -->
            <input type="hidden" name="post_type" value="<?php echo $_REQUEST['post_type'] ?>">
            <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
            <!-- Now we can render the completed list table -->
            <?php $table->display() ?>
        </form>
    <?php
    
    }
    private function addNew(){
        global $wpdb;
        
        if(!empty($_POST) && check_admin_referer('add_new_subscriber')){
            $fname = isset($_POST['fname']) ? stripslashes($_POST['fname']) : "";
            $lname = isset($_POST['lname']) ? stripslashes($_POST['lname']) : "";
            $email = isset($_POST['email']) ? stripslashes($_POST['email']) : "";
            $gender = isset($_POST['gender']) ? (int)$_POST['gender'] : "";
            $list_id = isset($_POST['list_id']) ? $_POST['list_id'] : array();
            
            $data = array(
                'fname' => $fname,
                'lname' => $lname,
                'email' => $email,
                'gender' => $gender,
            );
            
            if($email == "" || !is_email($email)){
                $this->errors['email'] = "Invalid Email Address";
            }
            
            if(empty($list_id)) {
                $this->errors['list_id'] = "Please Select a Campaign From List";
            }
            
            //check for already exist email for given subscripion
            
            if($email != ""){
                $cnt = $wpdb->query($wpdb->prepare("SELECT * FROM $wpdb->eden_subscriber WHERE email=%s",array($email)));
                if($cnt) {
                    $this->messages[] = "Email id is already registered";
                }
            }
            
            if(empty($this->errors) && empty($this->messages)){
                
                $format = array('%s','%s','%s','%d');
                
                
                if($wpdb->insert($wpdb->eden_subscriber,$data,$format)){
                    $this->messages[] = "Subscriber Added";
                    $id = $wpdb->insert_id;
                    $query = "DELETE FROM {$wpdb->eden_subscriber_list} WHERE subscriber_id=$id";
                    $wpdb->query($query);
                    $list_all = $this->utility->getTerms();
                    foreach ($list_id as $key => $value):
                        $db_data = array(
                            'subscriber_id' => $id,
                            'list_id' => $value
                        );
                        $format = array('%d','%d');
                        if($wpdb->insert($wpdb->eden_subscriber_list, $db_data, $format)){
                            $this->messages[] = "Successfully Subscribe to the list <strong>{$list_all[$value]}</strong>";
                        }
                        else {
                            $wpdb->show_errors();
                            $wpdb->print_error();
                        }
                    endforeach;
                    
                    
                    
                    $this->listTable();
                }
                else {
                    $this->messages[] = "Something Went Wrong. Please check you input";
                    $this->formTable($data);
                }
            }
            else {
                $this->formTable($data);
            }
            
        }
        else {
            $this->formTable();
        }
        
    }
    
    private function edit(){
        global $wpdb;
        if(!empty($_POST) && check_admin_referer('edit_subscriber')){
            
            $fname = isset($_POST['fname']) ? stripslashes($_POST['fname']) : "";
            $lname = isset($_POST['lname']) ? stripslashes($_POST['lname']) : "";
            //$email = isset($_POST['email']) ? stripslashes($_POST['email']) : "";
            $gender = isset($_POST['gender']) ? (int)$_POST['gender'] : "";
            //$list_id = isset($_POST['list_id']) ? (int)$_POST['list_id'] : ""; 
            $active = isset($_POST['active']) ? (int) $_POST['active'] : 0;
            $data = array(
                    'fname' => $fname,
                    'lname' => $lname,
                    //'email' => $email,
                    'gender' => $gender,
                    //'list_id' => $list_id
                    'active' => $active
                );
            $format = array('%s','%s','%d','%d');
            $where = array('id' => $_REQUEST['edit']);
            $format_where = array('%d');
            $wpdb->update($wpdb->eden_subscriber,$data,$where,$format,$format_where);
            $this->listTable();
        }
        else {
            
            $data = $wpdb->get_row(
                    $wpdb->prepare('SELECT * FROM ' . $wpdb->eden_subscriber .' WHERE id=%d', array($_REQUEST['edit']))
                    ,ARRAY_A
                    );
            $res = $wpdb->get_results($wpdb->prepare('SELECT list_id FROM ' . $wpdb->eden_subscriber_list . ' WHERE active=1 and subscriber_id=%d', array($_REQUEST['edit'])),ARRAY_A);
            if(!empty($res)) {
                foreach ($res as $row):
                    $data['list_id'][] = $row['list_id'];
                endforeach;
            }
            else {
                $data['list_id'] = array();
            }
            $this->formTable($data);
        }
    }
    private function delete(){
        global $wpdb;
        if(!empty($_POST) && check_admin_referer('delete_subscriber')){
            $wpdb->query($wpdb->prepare("DELETE FROM $wpdb->eden_subscriber WHERE id=%d",array($_REQUEST['delete'])));
            $wpdb->query($wpdb->prepare("DELETE FROM $wpdb->eden_subscriber_list WHERE subscriber_id=%d",array($_REQUEST['delete'])));
            $this->messages[] = "Subscriber Deleted";
            $this->listTable();
        }
        else{
        
    ?>
            <form method="post">
            <?php   wp_nonce_field('delete_subscriber'); ?>

                <h3>Are you sure, you want to delete ?</h3>
                <p class="submit">
                    <input type="submit" name="submit" id="submit" class="button button-primary" value="Delete">
                    <input type="button" value="Back" class="button button-secondary" onclick="window.location='<?php echo add_query_arg(array('post_type' => $_REQUEST['post_type'], 'page' => $_REQUEST['page']),'edit.php?' );  ?>'">
                </p>
            </form>
    <?php
         }
    }
    
    private function formTable($data = array()){
        if(empty($data)){
            $data = array(
                    'fname' => '',
                    'lname' => '',
                    'email' => '',
                    'gender' => '',
                    'list_id' => array(),
                    'active' => ''
                );
        }
    ?>
        <form method="post">
            <?php
                if(isset($_REQUEST['add_new'])){
                    echo '<h3>Add New Subscriber</h3>';
                    wp_nonce_field('add_new_subscriber');
                }
                elseif (isset ($_REQUEST['edit'])) {
                    echo '<h3>Edit Subscriber</h3>';
                    wp_nonce_field('edit_subscriber');
                }
            ?>
        <table class="form-table">
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="fname"><?php _e('First Name','eden_campaign'); ?></label>
                </th>
                <td>
                    <input type="text" name="fname" value="<?php echo $data['fname'];?>" id="fname" class="form">
                    <p class="description"><?php if(isset($this->errors['fname'])) echo $this->errors['fname']; ?></p>
                </td>
            </tr>
            
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="lname"><?php _e('Last Name','eden_campaign'); ?></label>
                </th>
                <td>
                    <input type="text" name="lname" value="<?php echo $data['lname'];?>" id="fname" class="form">
                    <p class="description"><?php if(isset($this->errors['lname'])) echo $this->errors['lname']; ?></p>
                </td>
            </tr>
            
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="email"><?php _e('Email','eden_campaign'); ?></label>
                </th>
                <td>
                    <input type="text" name="email" value="<?php echo $data['email'];?>" id="email" class="form">
                    <p class="description"><?php if(isset($this->errors['email'])) echo $this->errors['email']; ?></p>
                </td>
            </tr>
            
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="gender"><?php _e('Gender','eden_campaign'); ?></label>
                </th>
                <td>
                    <select name="gender" id="gender">
                        <option value="0" <?php selected($data['gender'], '0', false); ?> ><?php _e('Male','eden_campaign'); ?></option>
                        <option value="1" <?php selected($data['gender'], '1', false); ?> ><?php _e('FeMale','eden_campaign'); ?></option>
                        <option value="2" <?php selected($data['gender'], '2', false); ?> ><?php _e('Not Specified','eden_campaign'); ?></option>
                    </select>
                    <p class="description"><?php if(isset($this->errors['gender'])) echo $this->errors['gender']; ?></p>
                </td>
            </tr>
            
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="list_id"><?php _e('Campaign List','eden_campaign'); ?></label>
                </th>
                <td>
                    
                    <?php 
                        $lists = $this->utility->getTerms();
                        foreach($lists as $id => $name):
                            $selected = "";
                            if(!empty($data['list_id']) && in_array($id, $data['list_id'])){
                                $selected='checked="checked"';
                            }
                            echo "<label for='list_id_$id'><input type='checkbox' name='list_id[]' $selected value='$id' id='list_id_$id' style='width:auto;' /> $name</label><br>";
                        endforeach;
                    ?>
                    
                    <p class="description"><?php if(isset($this->errors['list_id'])) echo $this->errors['list_id']; ?></p>
                </td>
            </tr>
            
            <tr class="form-field">
                <th scope="row" valign="top">
                    <label for="active"><?php _e('Status','eden_campaign'); ?></label>
                </th>
                <td>
                    <select name="active" id="active">
                        <option value="1" <?php selected($data['active'],'1'); ?>><?php _e('Active','eden_campaign'); ?></option>
                        <option value="0" <?php selected($data['active'],'0'); ?>><?php _e('Inactive','eden_campaign'); ?></option>
                    </select>
                </td>
            </tr>
        </table>
            
        <p class="submit">
            <input type="submit" name="submit" id="submit" class="button button-primary" value="<?php if(isset($_REQUEST['add_new'])) {echo "Add"; } else {echo "Update" ;} ?>">
            <input type="button" value="Back" class="button button-secondary" onclick="window.location='<?php echo add_query_arg(array('post_type' => $_REQUEST['post_type'], 'page' => $_REQUEST['page']),'edit.php?' );  ?>'">
        </p>
        
        </form>
    <?php
    }
    
    
    
    
    
    private function getHeader(){
        $message = "";
        if(!empty($this->messages)):
            $message = '<div id="" class="updated"><p>';
            foreach($this->messages as $key => $msg):
                $message .= $msg . "<br/>";
            endforeach;
            $message .= "</p></div>";
        endif;
        
        if(!empty($this->errors)):
            $message = '<div id="" class="updated error"><p>';
            foreach($this->errors as $key => $msg):
                $message .= $msg . "<br/>";
            endforeach;
            $message .= "</p></div>";
        endif;
    ?>
        <div class="wrap">
            <h2>Subscribers 
                <a href="<?php echo "?post_type={$_REQUEST['post_type']}&page={$_REQUEST['page']}&add_new=1" ?>" class="add-new-h2 <?php if(isset($_REQUEST['add_new']) && $_REQUEST['add_new']=='1') { echo 'active';} ?>">Add New</a>
                <a href="<?php echo "?post_type={$_REQUEST['post_type']}&page={$_REQUEST['page']}&import=1" ?>" class="add-new-h2 <?php if(isset($_REQUEST['import']) && $_REQUEST['import']=='1') { echo 'active';} ?>">Import Registered Users</a>
                <a href="<?php echo "?post_type={$_REQUEST['post_type']}&page={$_REQUEST['page']}&import_csv=1" ?>" class="add-new-h2 <?php if(isset($_REQUEST['import_csv']) && $_REQUEST['import_csv']=='1') { echo 'active';} ?>">Import From CSV</a>
                <a href="<?php echo "?post_type={$_REQUEST['post_type']}&page={$_REQUEST['page']}&export=1" ?>" class="add-new-h2 <?php if(isset($_REQUEST['export']) && $_REQUEST['export']=='1') { echo 'active';} ?>">Export Subscribers</a>
            </h2>
            <?php echo $message; ?>
            <br>
    <?php
    }
    
    private function getFooter(){
        
        
    ?>
        </div>
    <?php
    
    }
    
    
    
    
}

