<?php
namespace CAMPAIGN;

if(!defined('WPINC')) {
    exit;
}

class FilterHooks{
    private static $instance;

    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
            self::$instance->actions();
        }
        return self::$instance;
    }

    private function actions(){
        add_filter('the_content', array($this,'postSubscribe'), 9999999999);
    }

    public function postSubscribe($content){
        ob_start();
        $util = new \CAMPAIGN\UTIL\Utility();
        $list = $util->getOption('post_type', 'eden_campaign_basics',array());
        $list = !is_array($list)?array():$list;

        if(is_single() && isset($list[get_post_type()])){
            global $post;
            if(is_user_logged_in()){
                //show subscribed button
                $data = maybe_unserialize(get_post_meta($post->ID, '_eden_campaign_subscriber', true));
                $user_id = get_current_user_id();
                if(!empty($data) && in_array($user_id, $data)) {
                    //already subscribed
                ?>
                    <div class="w3eden">
                        <div class="well wpdmnl-well wpdmnl-well-unsub">
                            <span class="eden_campaign_message" style="display: none;"></span>
                            <button type="button" id="eden_campaign_unsubscribe" class="btn btn-warning pull-right" style="margin-top: -4px">Unsubscribe</button> You will get notification on update of this post.
                        </div>
                    </div>
                <?php
                }
                else {
                    //display subscription
                ?>
                    <div class="w3eden">
                        <div class="well wpdmnl-well">
                            <span class="eden_campaign_message" style="display: none;"></span>
                            <button type="button" id="eden_campaign_subscribe" class="btn btn-success pull-right btn-sm" style="margin-top: -4px">Subscribe</button> Never miss an update .
                        </div>
                    </div>
                <?php
                }
                ?>
                <script type="text/javascript">
                    jQuery(function($){
                        $("#eden_campaign_unsubscribe").on('click',function(){

                                var th = $(this);
                                jQuery.ajax({
                                    type : "get",
                                    dataType : "json",
                                    url: '<?php echo admin_url('admin-ajax.php?action=eden_campaign_post_unsubscribe&post_id=' . $post->ID . '&nonce=' . wp_create_nonce('post_unsubscribe')); ?>',
                                    success: function(response) {
                                       if(response.type == "success") {
                                          th.html('Subscribe').attr('disabled','disabled');
                                          th.attr('id','eden_campaign_subscribe');
                                          th.parent().removeClass('alert-success').addClass('alert-danger');
                                          $('.eden_campaign_message').html('Unsubscribed successfully. <br>').show();
                                       }
                                       else {
                                          alert("Something Went Wrong");
                                       }
                                    }
                                 });

                            });

                            $("#eden_campaign_subscribe").on('click',function(){
                                var th = $(this);
                                var email = $('#wpdmnlemail').val();
                                email = (email !== undefined)?'&email='+email:'';
                                jQuery.ajax({
                                    type : "get",
                                    dataType : "json",
                                    url: '<?php echo admin_url('admin-ajax.php?action=eden_campaign_post_subscribe&post_id=' . $post->ID . '&nonce=' . wp_create_nonce('post_subscribe')); ?>'+email,
                                    success: function(response) {
                                       if(response.type == "success") {
                                          th.html('Unsubscribe').attr('disabled','disabled');
                                          th.parent().removeClass('alert-danger').addClass('alert-success');

                                          $('.eden_campaign_message').html('Post Subscribed successfully. <br>').show();
                                       }
                                       else {
                                          alert("Something Went Wrong");
                                       }
                                    }
                                 });
                            });
                        });
                    </script>
                <?php
            }
            else {
               ?>
                <div class="w3eden">
                    <div class="card  wpdmnl-panel">
                        <div class="card-header">Never Miss an Update</div>
                        <div class="card-body">
                            <span class="eden_campaign_message" style="display: none;"></span>
                            <div class="input-group"><input type="email" id="wpdmnlemail" required="required" class="form-control" placeholder="Your Email Address" /><span class="input-group-btn"><button type="button" id="eden_campaign_subscribe" class="btn btn-success">Subscribe</button></span></div>
                        </div>
                    </div>
                </div>
                <script type="text/javascript">
                    jQuery(function($){
                        $("#eden_campaign_unsubscribe").on('click',function(){

                            var th = $(this);
                            jQuery.ajax({
                                type : "get",
                                dataType : "json",
                                url: '<?php echo admin_url('admin-ajax.php?action=eden_campaign_post_unsubscribe&post_id=' . $post->ID . '&nonce=' . wp_create_nonce('post_unsubscribe')); ?>',
                                success: function(response) {
                                    if(response.type == "success") {
                                        th.html('Subscribe').attr('disabled','disabled');
                                        th.attr('id','eden_campaign_subscribe');
                                        th.parent().removeClass('alert-success').addClass('alert-danger');
                                        $('.eden_campaign_message').html('Unsubscribed successfully. <br>').show();
                                    }
                                    else {
                                        alert("Something Went Wrong");
                                    }
                                }
                            });

                        });

                        $("#eden_campaign_subscribe").on('click',function(){
                            var th = $(this);
                            var email = $('#wpdmnlemail').val();
                            email = (email != 'undefined')?'&email='+email:'';
                            jQuery.ajax({
                                type : "get",
                                dataType : "json",
                                url: '<?php echo admin_url('admin-ajax.php?action=eden_campaign_post_subscribe&post_id=' . $post->ID . '&nonce=' . wp_create_nonce('post_subscribe')); ?>'+email,
                                success: function(response) {
                                    if(response.type == "success") {
                                        th.html('Unsubscribe').attr('disabled','disabled');
                                        th.parent().removeClass('alert-danger').addClass('alert-success');

                                        $('.eden_campaign_message').html('Post Subscribed successfully. <br>').show();
                                    }
                                    else {
                                        alert("Something Went Wrong");
                                    }
                                }
                            });
                        });
                    });
                </script>
                <?php
            }
        }
        $content .= ob_get_clean();
        return $content;
    }
}

