<?php
namespace CAMPAIGN\INIT;

if(!defined('WPINC')) {
    exit;
}

class PostSubscribeMeta{
    private static $instance;
    private $dir, $url;
    private $util;
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->actions();
        }
        return self::$instance;
    }

    private function actions(){
        add_action( 'add_meta_boxes', array($this,'postSubscribeMetabox'), 10, 2 );
        add_action( 'save_post', array( $this, 'saveMeta' ) );
        add_action('admin_footer', array($this, 'modalHTML'));
        add_action('manage_posts_columns', array($this, 'columnsTH'));
        add_action('manage_posts_custom_column', array($this, 'columnsTD'), 10, 2);
        add_action('wp_ajax_listPostSubscribers', array($this, 'listPostSubscribers'));
        add_action('wp_ajax_postUnsubscribe', array($this, 'postUnsubscribe'));
    }

    function columnsTH($defaults) {
        if(get_post_type()!='wpdmpro') return $defaults;
        $defaults['subscribers'] = "Subscribers";
        return $defaults;
    }

    function columnsTD($column_name, $post_ID) {
        if(get_post_type()!='wpdmpro') return;
        if ($column_name == 'subscribers') {
            $postsubscribers = maybe_unserialize(get_post_meta($post_ID, '_eden_campaign_subscriber', true));
            $postsubscriber_count = is_array($postsubscribers)?count($postsubscribers):0;
            echo "<div class='w3eden'><button type='button' class='btn btn-default btn-sm' data-toggle='modal' data-postid='{$post_ID}' data-target='#wpdmPostSubscriberModal'>".($postsubscriber_count)."</button></div>";
            unset($postsubscribers);
        }
    }

    public function postSubscribeMetabox($post_type, $post){
        $util = new \CAMPAIGN\UTIL\Utility();
        $list = $util->getOption('post_type', 'eden_campaign_basics',array());
        $list = !is_array($list)?array():$list;
        if(!empty($list) && in_array($post_type, $list)){
            add_meta_box('post_subscribe_meta', __('Send Message To Subscriber'), array($this,'subscriberMeta'), $post_type);
        }
    }

    public function saveMeta($post_id){
         if(isset($_REQUEST['send_email_notification_nonce']) && check_admin_referer('send_email_notification','send_email_notification_nonce')){

             $data = array_map('stripslashes',$_POST['campaign_notification']);
             $data = array_map('trim', $data);

             if(isset($data['notify_subscriber'])) {
                 //send email here....
                 $message = $data['email_body'];
                 $message .= "<a href='".get_permalink($post_id)."'>".esc_attr__("Check Updates", WPDMNL_TEXT_DOMAIN)."</a>";
                 $db_data = array();
                 $db_data['post_id'] = $post_id;
                 $db_data['msg_type'] = 1;
                 $db_data['from_name'] = $data['from_name'];
                 $db_data['from_email'] = $data['from_email'];
                 $db_data['email_subject'] = $data['email_subject'];
                 $db_data['message'] = $message;
                 $db_data['recurrent'] = 0;
                 $db_data['total_sent'] = 0;
                 $db_data['send_on'] = time();
                 $db_data['created'] = date("Y-m-d H:i:s");

                 $format = array(
                     "%d", "%d" , "%s", "%s" , "%s", "%s", "%d", "%d", "%d", "%s"
                 );

                 global $wpdb;

                 /*
                 $users = $wpdb->get_results("SELECT user_email FROM $wpdb->users;");
                 $post = get_post($post_id);
                 $post_link = "<a href='".get_permalink($post_id)."'>{$post->post_title}</a>";
                 wp_mail($users, $data['email_subject'], $data['email_body']."<br/> Read More: {$post_link}");
                 */

                 $wpdb->insert($wpdb->eden_email_queue,$db_data,$format);

                 $data['email_body'] = "";
             }
             update_post_meta($post_id, '_campaign_notification', $data);
             update_post_meta($post_id, '_sendto_list', wpdm_query_var('campaign_notification/lists'));
         }

        // New code version 3.2.0
        /* if( !current_user_can('edit_posts', $post_id) ) return;
        if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) return;
        $post_subscribers = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));

        if(is_array($post_subscribers)):

            foreach ($post_subscribers as $subscriber):

            $subscriber_info = get_userdata($subscriber);

            wp_mail($subscriber_info->user_email,' Update Notice', 'Post Updated');

            endforeach;

        endif;*/


    }

    public function subscriberMeta($post){
        wp_nonce_field('send_email_notification','send_email_notification_nonce');
        $data = maybe_unserialize(get_post_meta($post->ID,'_campaign_notification',true));
        if(empty($data)){
            $data = array();
            $data['from_name'] = "";
            $data['from_email'] = "";
            $data['email_subject'] = "";
            $data['email_body'] = "";
            $data['notify_subscriber'] ="";
        }
    ?>
            <style>
                #post_subscribe_meta .inside {
                    padding: 0;
                    margin: 0;
                }
                #post_subscribe_meta .inside .panel{
                    border: 0;
                    margin: 0;
                }
                #post_subscribe_meta .inside .panel .panel-heading{
                    background: #ffffff !important;
                    border: 0 !important;
                    box-shadow: none !important;
                }
                #notify_subscriber {
                    float: left;
                    margin-right: 6px !important;
                    margin-top: 1px !important;
                }
            </style>
        <div class="w3eden">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <label for="notify_subscriber"><input type="checkbox" name="campaign_notification[notify_subscriber]" id="notify_subscriber" style="width: auto;" /> <?php _e('Notify Subscribers','eden_campaign');?></label></div>
                <div id="posbx" style="display: none">
                    <table class="table" style="margin: 0;">
                    <?php $c = maybe_unserialize(get_post_meta(get_the_ID(), '_eden_campaign_subscriber', true)); $subcount = is_array($c)  ? count($c) : 0; ?>
                        <?php if($subcount > 0) { ?>
                        <tr valign="middle" class="shide">
                            <th scope="row" >
                                <label for="from_name">
                                    <?php _e('Number of subscribers','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>
                                <?= $subcount ?>
                            </td>
                        </tr>
                        <?php } ?>
                        <tr valign="middle" class="shide">
                            <th scope="row" >
                                <label for="from_name">
				                    <?php _e('Select Lists','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>
                                <div>
                                <?php
                                $args = array(
	                                'orderby'       => 'id',
	                                'order'         => 'DESC',
	                                'hide_empty'    => false,
	                                'fields'        => 'all',
                                );

                                $lists = get_terms("subscriber_cat",$args);
                                foreach ($lists as $list) {
                                    echo "<label><input type='checkbox' name='campaign_notification[lists][]' value='{$list->term_id}' /> {$list->name}</label>";
                                }
                                ?>
                                </div>
                                <br/>
                                <em>Notification will be sent to the selected list</em>
                            </td>
                        </tr>
                        <tr valign="middle" class="shide">
                            <th scope="row" >
                                <label for="from_name">
                                    <?php _e('From Name','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>
                                <input type="text" name="campaign_notification[from_name]" id="from_name" class="form-control" value="<?php echo empty($data['from_name'])?get_bloginfo('sitename'):$data['from_name']; ?>" />
                            </td>
                        </tr>

                        <tr valign="middle" class="shide">
                            <th scope="row">
                                <label for="from_email">
                                    <?php _e('From Email','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>
                                <input type="email" name="campaign_notification[from_email]" id="from_email" class="form-control"  value="<?php echo empty($data['from_email'])?get_bloginfo('admin_email'):$data['from_email']; ?>" />

                            </td>
                        </tr>

                        <tr valign="top" class="shide">
                            <th scope="row">
                                <label for="email_subject">
                                    <?php _e('Email Subject','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>
                                <input type="text" name="campaign_notification[email_subject]" id="email_subject" class="form-control"  value="<?php echo empty($data['email_subject'])?'New Update Available For: '.get_the_title():$data['email_subject']; ?>" />

                            </td>
                        </tr>


                        <tr valign="top" class="shide">
                            <th scope="row">
                                <label for="email_body">
                                    <?php _e('Email Body','eden_campaign'); ?>:
                                </label>
                            </th>

                            <td>

                                <?php wp_editor( $data['email_body'], "email_body" , array('textarea_name' => 'campaign_notification[email_body]')); ?>

                            </td>
                        </tr>
                    </table>
                </div>
            </div>

        </div>
        <script type="text/javascript">
            jQuery(function($){
                $('.hide').hide();

                $('#notify_subscriber').click(function() {
                    var $this = $(this);
                    // $this will contain a reference to the checkbox
                    if ($this.is(':checked')) {
                        $('#posbx').slideDown();
                    } else {
                        // the checkbox was unchecked
                        $('#posbx').slideUp();
                    }
                });
            });
        </script>
    <?php
    }

    function modalHTML(){
        if(wpdm_query_var('post_type') !== 'wpdmpro') return;
        ?>
    <!-- Modal -->
    <div class="w3eden">

    <div class="modal fade hidden" id="wpdmPostSubscriberModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <form method="post" id="wpdmPostSubscriberModalForm">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title" id="myModalLabel">Subscribers</h4>
                </div>
                <div class="modal-body" id="wpdmpsmb" style="max-height: 400px;overflow-y: auto;padding: 0">

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default btn-sm" data-dismiss="modal">Close</button>
                    <button type="submit" id="psfsb" class="btn btn-danger btn-sm pull-left">Remove Selected</button>
                </div>
            </div>
        </div>
        </form>
    </div>

    </div>

    <script>
        jQuery(function($){
            $('#wpdmPostSubscriberModal').on('show.bs.modal', function (event) {
                $(this).removeClass('hidden');
                var button = $(event.relatedTarget);
                var postid = button.data('postid');
                var modal = $(this);
                modal.find('.modal-body').html('<i class="fa fa-refresh fa-spin"></i> Loading...').load(ajaxurl+'?action=listPostSubscribers&postid='+postid);
            });
            $('#wpdmPostSubscriberModalForm').submit(function(event){
                event.preventDefault();
                $('#psfsb').html('<i class="fa fa-refresh fa-spin"></i>');
                var data = $( this ).serialize();
                $.post(ajaxurl+'?action=postUnsubscribe', data, function(res){
                    $('#psfsb').html(res);
                    alert(res);
                    $('#psfsb').html('Remove Selected');
                });
                $(this).find('.lid:checked').each(function(){
                    $($(this).data('row')).slideUp();
                });

            });

            $('body').on('click','#mlid', function(){
                $('.lid').prop('checked', $(this).is(":checked"))
            });
        });
    </script>
        <?php
    }

    function listPostSubscribers(){
        if(!current_user_can('edit_posts')) die('Only For Adiministrator!');
        $post_id = (int)$_GET['postid'];
        $postsubscribers = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));
        ?>
        <input type="hidden" name="postid" value="<?php echo $post_id; ?>" />
        <table class="table table-striped">
            <thead>
            <tr>
                <td><input id="mlid" type="checkbox"></td>
                <td>First Name</td>
                <td>Last Name</td>
                <td>Email</td>
            </tr>
            </thead>
            <tbody>
                <?php
                if(is_array($postsubscribers)){
                foreach($postsubscribers as $user){
                    $lid = $user;
                    if(is_email($user) && email_exists($user))
                        $user = get_user_by('email', $user);
                    if(is_email($user) && !email_exists($user)) {
                        $vuser = new \WP_User();
                        $vuser->first_name = '&mdash;';
                        $vuser->last_name = '&mdash;';
                        $vuser->user_email = $user;
                        $user = $vuser;
                    }
                    else
                        $user = get_userdata($user);

                    if(is_object($user) && !is_wp_error($user)){
                    ?>
                <tr id="row-<?php echo sanitize_title($lid); ?>">
                    <td><input type="checkbox" class="lid" data-row="#row-<?php echo sanitize_title($lid); ?>" value="<?php echo $lid; ?>" name="lid[]"></td>
                    <td><?php echo $user->first_name; ?></td>
                    <td><?php echo $user->last_name; ?></td>
                    <td><?php echo $user->user_email; ?></td>
                </tr>
                <?php }}} ?>
            </tbody>
        </table>
        <?php
        die();
    }

    function postUnsubscribe(){
        if(!current_user_can('edit_posts')) die('Only For Adiministrator!');
        $post_id = (int)$_REQUEST['postid'];
        $postsubscribers = maybe_unserialize(get_post_meta($post_id, '_eden_campaign_subscriber', true));
        $newsb = array();
        if(is_array($postsubscribers)) {
            foreach ($postsubscribers as $id => $user) {
                if(!in_array($user, $_REQUEST['lid']))
                    $newsb[] = $user;
            }
        }
        update_post_meta($post_id, '_eden_campaign_subscriber', $newsb);
        die('Done!');
    }
}

