<?php
namespace CAMPAIGN\INIT;

if(!defined('WPINC')) {
    exit;
}

class Taxonomy{
    private static $instance;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function actions(){
        add_action('init',array($this,'addTaxonomy'));
        add_action('edited_subscriber_cat',array($this,'editedCat'),10,2);
        add_action('created_subscriber_cat',array($this,'editedCat'),10,2);
        add_action('delete_subscriber_cat',array($this,'editedCat'),10,2);
    }
    
    public function addTaxonomy(){
        register_taxonomy( 'subscriber_cat',
	        array('eden_campaign'),
	        array(
	            'hierarchical' 		=> false,
	            'label' 			=> __( 'Lists', 'campaign'),
	            'labels' => array(
                        'name' 			=> __( 'Lists', 'campaign'),
                        'singular_name' 	=> __( 'List', 'campaign'),
                        'menu_name'		=> _x( 'Lists', 'Admin menu name', 'campaign' ),
                        'search_items' 		=> __( 'Search Lists', 'campaign'),
                        'all_items' 		=> __( 'All Lists', 'campaign'),
                        'edit_item' 		=> __( 'Edit List', 'campaign'),
                        'update_item' 		=> __( 'Update List', 'campaign'),
                        'add_new_item' 		=> __( 'Create New List', 'campaign'),
                        'new_item_name' 	=> __( 'New List', 'campaign')
	            	),
                'public'                    => true,
	            'show_ui' 			=> true,
	            'query_var' 		=> true,
	            'rewrite' 			=> true,
	            'show_in_nav_menus'         => false,
	            'show_tagcloud'             => false,
	        ) 
	    );
    }
    
    public function editedCat( $term_id, $tt_id){
        $transient = "subscriber_category_list";
        delete_transient($transient);
        
    }
}

