<?php
namespace CAMPAIGN\INSTALL;

if(!defined('WPINC')) {
    exit;
}

class DB{
    private static $instance;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function actions(){
        //echo "hello";
        global $wpdb;
        $sqls[] = "CREATE TABLE `{$wpdb->prefix}eden_subscriber` (
                      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                      `user_id` bigint(20) unsigned DEFAULT NULL,
                      `fname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                      `lname` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                      `email` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                      `gender` tinyint(4) unsigned NOT NULL,
                      `token` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
                      `active` tinyint(4) unsigned NOT NULL DEFAULT '1',
                      `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                      UNIQUE KEY `id` (`id`),
                      UNIQUE KEY `email` (`email`)
                    );";
        
        $sqls[] = "CREATE TABLE `{$wpdb->prefix}eden_email_queue` (
                      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                      `post_id` bigint(20) unsigned NOT NULL,
                      `msg_type` tinyint(3) unsigned NOT NULL,
                      `from_name` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                      `from_email` varchar(250) COLLATE utf8_unicode_ci NOT NULL,
                      `email_subject` varchar(500) COLLATE utf8_unicode_ci NOT NULL,
                      `message` longtext COLLATE utf8_unicode_ci NOT NULL,
                      `recurrent` tinyint(3) unsigned NOT NULL,
                      `last_email` bigint(20) unsigned NOT NULL,
                      `total_sent` bigint(20) unsigned NOT NULL,
                      `status` tinyint(3) unsigned NOT NULL,
                      `send_on` int(11) NOT NULL,
                      `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
                      UNIQUE KEY `id` (`id`)
                    );";
        
        $sqls[] = "CREATE TABLE `{$wpdb->prefix}eden_subscriber_list` (
                      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                      `subscriber_id` bigint(20) unsigned NOT NULL,
                      `list_id` bigint(20) unsigned NOT NULL,
                      `active` tinyint(3) unsigned NOT NULL DEFAULT '1',
                      UNIQUE KEY `id` (`id`),
                      UNIQUE KEY `key2` (`subscriber_id`,`list_id`)
                    );";
        
        
            
        
        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
  
        foreach($sqls as $key => $query):
            dbDelta( $query );
        endforeach;
        
    }
}

//SELECT id, fname, lname, email, group_concat(list_id) FROM `zwp_eden_subscriber` group by email