<?php
namespace CAMPAIGN\INSTALL;

if(!defined('WPINC')) {
    exit;
}

class Options{
    private static $instance;
    
    public static function getInstance(){
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->dir = \CAMPAIGN\EdenCampaign::getDir();
            self::$instance->url = \CAMPAIGN\EdenCampaign::getUrl();
            self::$instance->actions();
        }
        return self::$instance;
    }
    
    private function actions(){
        $settings_fields = array();
        //general settings
        $settings_fields['eden_campaign_basics']['post_type'] = 'no';
        $settings_fields['eden_campaign_basics']['campaign_url'] = '';

        //Email Settings
        $settings_fields['eden_campaign_email']['sender_email'] = get_option('admin_email');
        $settings_fields['eden_campaign_email']['sender_name'] = get_bloginfo('name');
        $settings_fields['eden_campaign_email']['return_path'] = get_option('admin_email');
        $settings_fields['eden_campaign_email']['reply_to'] = '';

        //SMTP Settings
        $settings_fields['eden_campaign_smtp']['enable'] = '0';
        $settings_fields['eden_campaign_smtp']['host'] = '';
        $settings_fields['eden_campaign_smtp']['port'] = 25;
        $settings_fields['eden_campaign_smtp']['security'] = '';
        $settings_fields['eden_campaign_smtp']['user'] = '';
        $settings_fields['eden_campaign_smtp']['password'] = '';

        //advance settings
        $settings_fields['eden_campaign_advanced']['scheduler_max'] = 100;
        $settings_fields['eden_campaign_advanced']['php_time_limit'] = '';

        //subscriber basic settings
        $settings_fields['campaign_subscriber_basic']['opt_in'] = '0';
        $settings_fields['campaign_subscriber_basic']['email_notification'] = '0';
        $settings_fields['campaign_subscriber_basic']['notify_email'] = get_option('admin_email');

        //subscribe settings
        $settings_fields['campaign_subscriber_subscribe']['confirmation_msg'] = "You have successfully subscribed to the newsletter. 
You'll receive a confirmation email in few minutes. 
Please follow the link in it to confirm your subscription. 
If the email takes more than 15 minutes to appear in your mailbox, please check
your spam folder.";
        
        $settings_fields['campaign_subscriber_subscribe']['confirmation_email_subject'] = 'Please confirm subscription - ##site_name## newsletter';
        
        $settings_fields['campaign_subscriber_subscribe']['confirmation_email'] = "<p>Hi ##name##,</p>
<p>A newsletter subscription request for this email address was
received. Please confirm it by clicking ##subscribe_here##. If you cannot
click the link, please use the following link.</p>

<p>##subscribe_url##</p>

<p>If you did not make this subscription request, just ignore this
message.</p>
<p>Thank you!<br>
<a href='##site_url##'>##site_name##</a></p>";
        
        
        $settings_fields['campaign_subscriber_subscribe']['activation_message'] = '<p>Your subscription has been confirmed! Thank you ##name##!</p>';
        
        $settings_fields['campaign_subscriber_subscribe']['subscription_success_email'] = '';
        
        $settings_fields['campaign_subscriber_subscribe']['subscription_success_email_subject'] = 'Welcome ##name##';
        
        $settings_fields['campaign_subscriber_subscribe']['subscription_success_email_body'] = "<p>This message confirms your subscription to the ##site_name## newsletter.</p>
<p>Thank you!<br>
<a href='##site_url##'>##site_name##</a></p>
<p>To unsubscribe, <a href='##unsubscribe_url##'>click here</a>.  To change subscriber options,
<a href='##profile##'>click here</a>.</p>";
        
        $settings_fields['campaign_subscriber_subscribe'][] = "<p>This email address is already subscribed.</p>";
        
        
        //campaign_subscriber_unsubscribe
        $settings_fields['campaign_subscriber_unsubscribe']['unsubscribe_email_subject'] = "Please confirm unsubscription - ##site_name## newsletter";
        
        $settings_fields['campaign_subscriber_unsubscribe']['unsubscribe_email_msg'] = "<p>Please confirm that you want to unsubscribe by <a href='##unsubscribe_url##'>clicking here</a>.</p>";

        $settings_fields['campaign_subscriber_unsubscribe']['unsubscribe_success_msg'] = "<p>Your subscription has been deleted. Thank you.</p>";
        
        
        //check uninstall hook here
               
        foreach ($settings_fields as $key => $value){
            if(get_option($key)==FALSE){
                update_option($key, $value);
            }
            
        }
    }
    
}