<?php
namespace CAMPAIGN\UTIL;

if(!defined('WPINC')) {
    exit;
}


class AdminMail extends \CAMPAIGN\UTIL\Mailer{
    private $global;
    public function __construct() {
        $this->actions();
        $this->global = array(
            '##site_name##' => get_bloginfo('name'),
            '##site_url##' => get_bloginfo('url')
        );
        
    }
    
    public function sendUnSubscribeEmail($data){
        if ($this->mailer == null)
            $this->phpMailerInit();
        
        $this->mailer->IsHTML(true);
        
        //email body
        $email_body = $this->util->getOption('unsubscribe_email_msg','campaign_subscriber_unsubscribe');
        $email_body = $this->replaceTags($email_body,$data);
        $email_body = str_replace("\r\n", "\n", $email_body);
        $email_body = str_replace("\r", "\n", $email_body);
        $email_body = str_replace("\n", "\r\n", $email_body);
        $this->mailer->Body = $email_body;
        
        
        //email subject
        $email_sub = $this->util->getOption('unsubscribe_email_subject','campaign_subscriber_unsubscribe');
        $email_sub = $this->replaceTags($email_sub,$data);
        $this->mailer->Subject = $email_sub;
        
        
        $this->mailer->ClearAddresses();
        $this->mailer->AddAddress($data['email']);
        $this->mailer->Send();

        if ($this->mailer->IsError()) {
            $error = $this->mailer->ErrorInfo;
            echo $error;
            // If the error is due to SMTP connection, the mailer cannot be reused since it does not clean up the connection
            // on error.
            $this->mailer = null;
            return false;
        }
        
        return true;
    }
    
    public function sendSubscribeEmail($data){
        if ($this->mailer == null)
            $this->phpMailerInit();
        
        $this->mailer->IsHTML(true);
        
        //email body
        $email_body = $this->util->getOption('confirmation_email','campaign_subscriber_subscribe');
        $email_body = $this->replaceTags($email_body,$data);
        $email_body = str_replace("\r\n", "\n", $email_body);
        $email_body = str_replace("\r", "\n", $email_body);
        $email_body = str_replace("\n", "\r\n", $email_body);
        $this->mailer->Body = $email_body;
        
        
        //email subject
        $email_sub = $this->util->getOption('confirmation_email_subject','campaign_subscriber_subscribe');
        $email_sub = $this->replaceTags($email_sub,$data);
        $this->mailer->Subject = $email_sub;
        
        
        $this->mailer->ClearAddresses();
        $this->mailer->AddAddress($data['email']);
        $this->mailer->Send();

        if ($this->mailer->IsError()) {
            $error = $this->mailer->ErrorInfo;
            echo $error;
            // If the error is due to SMTP connection, the mailer cannot be reused since it does not clean up the connection
            // on error.
            $this->mailer = null;
            return false;
        }
        
        return true;
    }
    
    
    
    private function replaceTags($text,$data){
        foreach ($this->global as $key => $val){
            $text = str_replace($key, $val, $text);
        }
        
        //check here for custom link from settings page
        $url = trim($this->util->getOption('campaign_url','eden_campaign_basics'));
        $sap = get_option('permalink_structure')?'?':'&';
        if($url != ""){
            $subscribe_url = $url . $sap.  'token=' . $data['token'] . "&tab=subscribe";
            $unsubscribe_url = $url . $sap.  'token=' . $data['token'] . "&tab=unsubscribe";
            $profile = $url . $sap.  'token=' . $data['token'] . "&tab=profile";
        }
        else {
            $subscribe_url = home_url() . $sap.  'task=eden_subscriber&token=' . $data['token'] . "&tab=subscribe";
            $unsubscribe_url = home_url() . $sap.  'task=eden_subscriber&token=' . $data['token'] . "&tab=unsubscribe";
            $profile = home_url() . $sap.  'task=eden_subscriber&token=' . $data['token'] . "&tab=profile";
        }
        
        $temp = array(
            '##name##' => $data['fname'] . ' ' . $data['lname'],
            '##subscribe_here##' => "<a href='$subscribe_url'>Here</a>",
            '##unsubscribe_here##' => "<a href='$unsubscribe_url'>Here</a>",
            '##subscribe_url##' => $subscribe_url,
            '##unsubscribe_url##' => $unsubscribe_url,
            '##profile##' => $profile
        );
        foreach ($temp as $key => $val){
            $text = str_replace($key, $val, $text);
        }
        return $text;
    }
    
}