<?php
namespace CAMPAIGN\UTIL;

if(!defined('WPINC')) {
    exit;
}

class SubscriberHandle {
    private static $instance;
    private $echo,$util,$profile_tab, $list_tab,$post_tab,$subscribe_tab,$unsubscribe_tab,$error;
    
    public static function getInstance($echo = true){
        //echo true means output data, otherwise return data 
        if(self::$instance === null){
            self::$instance = new self;
            self::$instance->util = new \CAMPAIGN\UTIL\Utility();
        }
        self::$instance->echo = $echo;
        self::$instance->profile_tab = "";
        self::$instance->list_tab = "";
        self::$instance->post_tab = "";
        self::$instance->unsubscribe_tab = "";
        return self::$instance;
    }
    
    public function showProfile(){
        if($this->echo == false){
            $this->initialize();
            $data = $this->outputTabs();
            return $data;
        }
        else {
            add_action('wp_head',array($this,'headJs'));
            add_action('wp_footer',array($this,'footerHtml'));
        }
    }
    
    public function headJs(){
    ?>
        <script type="text/javascript">
            jQuery(function(){
                jQuery(window).load(function() {
                    jQuery('#edenCampaignProfile').modal();
                });
            });
        </script>
    <?php
        
    }
    
    public function footerHtml(){
        $this->initialize();
        $data = $this->outputTabs();
    ?>
        <div class="w3eden">
        <div class="modal fade" id="edenCampaignProfile" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-lg">
              <div class="modal-content">
                <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                  <h4 class="modal-title" id="myModalLabel" style="display:inline-block"><?php _e('Eden Campaign','eden_campaign'); ?></h4>
                </div>
                <div class="modal-body" id="eden_campaign_modal_body">
                    
                    <?php echo $data; ?>
                </div>
                <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                </div>
              </div>
            </div>
         </div>
        </div>
        
    <?php    
    }
    
    private function outputTabs(){
        ob_start();
        $tab = isset($_REQUEST['tab']) ? stripslashes($_REQUEST['tab']) : '';
    ?>
        <div id="edenCampaignProfileMessage">
            <?php 
                if(isset($this->error)){
                    foreach ($this->error as $key => $msg):
                        echo '<div class="alert alert-danger">'.$msg.'</div>';
                    endforeach;
                }
            ?>
        </div>
        <!-- Nav tabs -->
        <ul class="nav nav-tabs">
            
        <?php if($this->profile_tab != ""): ?>
            <li class="<?php if($tab=='profile' || $tab=="") {echo 'active';} ?>"><a href="#eden_profile" data-toggle="tab"><?php _e('Profile','eden_campaign'); ?></a></li>
        <?php endif; ?>
            
        <?php if($this->list_tab != ""): ?>
            <li class=""><a href="#eden_list" data-toggle="tab"><?php _e('Subscription List','eden_campaign'); ?></a></li>
        <?php endif; ?>
            
        <?php if($this->post_tab != ""): ?>
            <li class=""><a href="#eden_post" data-toggle="tab"><?php _e('Post Subscribed','eden_campaign'); ?></a></li>
        <?php endif; ?>
            
        <?php if($this->unsubscribe_tab != ""): ?>
            <li class="<?php if($tab != '' && $tab=='unsubscribe') {echo 'active';} ?>"><a href="#eden_unsubscribed" data-toggle="tab"><?php _e('Unsubscribe','eden_campaign'); ?></a></li>
        <?php endif; ?>
        
        <?php if($this->subscribe_tab != ""): ?>
            <li class="<?php if($tab != '' && $tab=='subscribe') {echo 'active';} ?>"><a href="#eden_subscribed" data-toggle="tab"><?php _e('Subscribe','eden_campaign'); ?></a></li>
        <?php endif; ?>    
        </ul>
        
        <!-- Tab panes -->
        <div class="tab-content">
            
        <?php if($this->profile_tab != ""): ?>
            <div class="tab-pane <?php if($tab=='profile' || $tab=="") {echo 'active';} ?>" id="eden_profile"><br><?php echo $this->profile_tab; ?></div>
        <?php endif; ?>  
            
        <?php if($this->list_tab != ""): ?>
            <div class="tab-pane" id="eden_list"><br><?php echo $this->list_tab; ?></div>
        <?php endif; ?>  
            
        <?php if($this->post_tab != ""): ?>
            <div class="tab-pane" id="eden_post"><br><?php echo $this->post_tab; ?></div>
        <?php endif; ?>  
            
        <?php if($this->unsubscribe_tab != ""): ?>
            <div class="tab-pane <?php if($tab != '' && $tab=='unsubscribe') {echo 'active';} ?>" id="eden_unsubscribed"><br><?php echo $this->unsubscribe_tab; ?></div>
        <?php endif; ?>    
            
        <?php if($this->subscribe_tab != ""): ?>
            <div class="tab-pane <?php if($tab != '' && $tab=='subscribe') {echo 'active';} ?>" id="eden_subscribed"><br><?php echo $this->subscribe_tab; ?></div>
        <?php endif; ?>       
            
            
            
        </div>
        
    <?php
        return ob_get_clean();
    }
    
    private function initialize(){
        global $wpdb;
        $list_all = $this->util->getTerms();
        $user_data = array();
        $list_data = array();
        $post_subscribed = array();
        $token = isset($_REQUEST['token']) ? stripslashes($_REQUEST['token']) : '';
        $tab = isset($_REQUEST['tab']) ? stripslashes($_REQUEST['tab']) : '';
        
        if(is_user_logged_in()){
            
            //post_subscribed list_subscribed unsubscribe
            $user_id = get_current_user_id();
            $query = "SELECT * FROM {$wpdb->eden_subscriber}  WHERE user_id=$user_id LIMIT 1";
            $user_data = $wpdb->get_row($query,ARRAY_A); //null return if error
            $post_subscribed = maybe_unserialize(get_user_meta($user_id, '_eden_campaign_subscriber', true));
            
            if($user_data != NULL){
                $query = "SELECT * FROM {$wpdb->eden_subscriber_list} WHERE subscriber_id={$user_data['id']}";
                $list_data = $wpdb->get_results($query,ARRAY_A);
            }
            
        }    
        
        else{
            
            //profile list_subscribed unsubscribe
            if($token != ""):
                $query = "SELECT * FROM {$wpdb->eden_subscriber} WHERE token='$token' LIMIT 1";
                $user_data = $wpdb->get_row($query,ARRAY_A);
                if($user_data == NULL || empty($user_data)):
                    //invalid token
                    $this->error[] = "Invalid Token";

                else:

                    if(is_numeric($user_data['user_id'])){
                        //force to login...
                        $login = wp_login_url();
                        $this->error[] = "Please <a href='$login' title='Login'>Login</a> first"; 
                    }
                    else {

                        $query = "SELECT * FROM {$wpdb->eden_subscriber_list} WHERE subscriber_id={$user_data['id']}";
                        $list_data = $wpdb->get_results($query,ARRAY_A);

                    }
                endif;
            else:
                $this->error[] = "Invalid Token";
            endif;
            
        }
        
        //if tab is set to subscribe or unsubscribe
        //do the task first
        //
        if($tab != '' && $tab=='subscribe'){
            $this->subscribeUser($user_data);
            
            $url = remove_query_arg('tab');
            $this->redirect($url,"Redirecting...",'edenCampaignProfileMessage');
            
        }
        elseif($tab != '' && $tab=='unsubscribe'){
            $this->unSubscribeUser($user_data);
            $url = remove_query_arg('tab');
            $this->redirect($url,"Redirecting...",'edenCampaignProfileMessage');
        }
        
        //post_subscribed tab data
        if(!empty($post_subscribed)){
            ob_start();
            $this->postSubscribed($post_subscribed);
            $this->post_tab = ob_get_clean();
        }

        //list_subscribe tab data
        if(!empty($list_data)){
            ob_start();   
            $this->listSubscribed($list_data);
            $this->list_tab = ob_get_clean();    
        }
        
        if(!empty($user_data)){
            //profile tab
            ob_start();
            $this->getProfile($user_data);
            $this->profile_tab = ob_get_clean();
            
            if($user_data['active']==0){
                //user in unsubscribed
                //show subscribe tab
                ob_start();
                $this->getSubscribed($user_data);
                $this->subscribe_tab = ob_get_clean();
            }
            elseif($user_data['active']==1) {
                //user is subscribed
                //show unsubscribed tab
                ob_start();
                $this->getUnSubscribed($user_data);
                $this->unsubscribe_tab = ob_get_clean();
            }
            else {
                
            }
            
        }
        
    }
    
    private function redirect($url,$message="",$id=""){
        
        if($message != "" && $id != ""):
    ?>
        <script type="text/javascript">
            jQuery(function($){
                $("#<?php echo $id; ?>").append('<?php echo $message; ?>');
                setTimeout(function(){window.location = '<?php echo $url; ?>';},3000);
            });
        </script>
    <?php
        else:
            echo "<script>window.location = '$url';</script>";
        endif;
    }
    
    private function subscribeUser(&$user_data){
        //
        global $wpdb;
        if(is_numeric($user_data['id']) && $user_data['active']==0) {
            $query = "UPDATE {$wpdb->eden_subscriber} SET active=1 WHERE id={$user_data['id']} LIMIT 1";
            if($wpdb->query($query)==1){
                $this->error[] = "Subscription Activated";
                $user_data['active'] = 1;
            }
            else {
                $this->error[] = "Database Error";
                $wpdb->shor_errors();
                $wpdb->print_error();
                
            }
        }
    }

    private function unSubscribeUser(&$user_data){
        global $wpdb;
        if(is_numeric($user_data['id']) && $user_data['active']==1) {
            $query = "UPDATE {$wpdb->eden_subscriber} SET active=0 WHERE id={$user_data['id']} LIMIT 1";
            if($wpdb->query($query)==1){
                $this->error[] = "Subscription Canceled";
                $user_data['active'] = 0;
            }
            else {
                $this->error[] = "Database Error";
                $wpdb->shor_errors();
                $wpdb->print_error();
                
            }
        }
    }
    
    private function getSubscribed($user_data){
        //if not site user send subscription email
        //else just subscribe here with js
    ?>
        <div class="alert alert-info">You are not subscribed to campaign. You will not receive any updates / email from this site.</div>
        <form method="post" id="eden_sc_subscribe" action="<?php echo admin_url('admin-ajax.php') ?>">
            <input type="hidden" name="action" value="eden_sc_subscribe" />
            <?php wp_nonce_field('eden_sc_subscribe'); ?>
            <label><?php _e('Do you want to subscribe to campaign','eden_campaign'); ?>?</label>
            <?php if($user_data['user_id'] == NULL):?>
            <input type="hidden" name="token" value="<?php echo $user_data['email'];  ?>" />
            <?php endif; ?>
            <button type="submit" class="btn btn-success"><?php _e('Subscribe','eden_campaign'); ?></button>
        </form>
        
        <script type="text/javascript">
            jQuery(function($){
                $('#eden_sc_subscribe').submit(function(){
                    $(this).ajaxSubmit({
                        dataType: 'json',
                        success: function(res){
                            console.log(res);
                            //res = json_encode(res);
                            if(res.type=="success"){
                                var str= "";
                                if(res.message){
                                   $.each(res.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-success">' + data + '</div>';

                                   });
                                }
                                if(res.error){
                                   $.each(res.error, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-danger">' + data + '</div>';

                                   });
                                }
                                $('#edenCampaignProfileMessage').html(str);
                                $('#eden_sc_subscribe').children('button').attr('disabled','disabled');
                            }
                            else {
                                alert('Something Went Wrong');
                            }
                        }
                    });
                    return false;
                });
                    
            });
        </script>
            
    <?php    
    }

    private function getUnSubscribed($user_data){
    ?>
        <div class="alert alert-success">You are subscribed to campaign. You will receive updates / email from this site.</div>
        <form method="post" id="eden_sc_unsubscribe" action="<?php echo admin_url('admin-ajax.php') ?>">
            <input type="hidden" name="action" value="eden_sc_unsubscribe" />
            <?php wp_nonce_field('eden_sc_unsubscribe'); ?>
            <label><?php _e('Do you want to unsubscribe to campaign','eden_campaign'); ?>?</label>
            <?php if($user_data['user_id'] == NULL):?>
            <input type="hidden" name="token" value="<?php echo $user_data['email'];  ?>" />
            <?php endif; ?>
            <button type="submit" class="btn btn-success"><?php _e('Unsubscribe','eden_campaign'); ?></button>
        </form>
        
        <script type="text/javascript">
            jQuery(function($){
                $('#eden_sc_unsubscribe').submit(function(){
                    $(this).ajaxSubmit({
                        dataType: 'json',
                        success: function(res){
                            console.log(res);
                            //res = json_encode(res);
                            if(res.type=="success"){
                                var str= "";
                                if(res.message){
                                   $.each(res.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-success">' + data + '</div>';

                                   });
                                }
                                if(res.error){
                                   $.each(res.error, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-danger">' + data + '</div>';

                                   });
                                }
                                $('#edenCampaignProfileMessage').html(str);
                                $('#eden_sc_unsubscribe').children('button').attr('disabled','disabled');
                            }
                            else {
                                alert('Something Went Wrong');
                            }
                        }
                    });
                    return false;
                });
                    
            });
        </script>
            
    <?php
    }

    private function getProfile($user_data){
    ?>    
        <form role="form" id="eden_subscriber_profile" action="<?php echo admin_url('admin-ajax.php') ?>">
            <input type="hidden" name="action" value="eden_subscriber_profile">
            <input type="hidden" name="data[id]" value="<?php echo $user_data['id'];?> " />
            <?php wp_nonce_field('eden_subscriber','nonce'); ?>
            <div class="form-group">
                <label for="fname"><?php _e('First Name','eden_campaign');  ?></label>
                <input type="text" class="form-control" id="fname" name="data[fname]" value="<?php echo $user_data['fname']; ?>" placeholder="Enter first name">
            </div>
            <div class="form-group">
                <label for="lname"><?php _e('Last Name','eden_campaign');  ?></label>
                <input type="text" class="form-control" id="lname" name="data[lname]" value="<?php echo $user_data['lname']; ?>" placeholder="Enter last name">
            </div>
            <div class="form-group">
                <label for="gender"><?php _e('Gender','eden_campaign');  ?></label>
                <select name="data[gender]" id="gender" class="form-control">
                    <option value="0" <?php selected('0', $user_data['gender'], true); ?>><?php _e('Male','eden_campaign'); ?></option>
                    <option value="1" <?php selected('1', $user_data['gender'], true); ?>><?php _e('FeMale','eden_campaign'); ?></option>
                    <option value="2" <?php selected('2', $user_data['gender'], true); ?>><?php _e('Not Specified','eden_campaign'); ?></option>
                </select>
            </div>
            <button type="submit" class="btn btn-success">Update Profile</button>
        </form>
        
        <script type="text/javascript">
            jQuery(function($){
                $('#eden_subscriber_profile').submit(function(){
                    $(this).ajaxSubmit({
                        dataType: 'json',
                        success: function(response){
                            console.log(response);
                            //res = json_encode(res);
                            if(response.type=="success"){
                                var str= "";
                              if(response.message){
                                  $.each(response.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-info">' + data + '</div>';

                                   });
                              }
                              if(response.error){
                                  $.each(response.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-danger">' + data + '</div>';

                                   });
                              }
                              
                              if(str) {
                                  $('#edenCampaignProfileMessage').html(str);
                              }
                                
                                   
                            }
                            else {
                                console.log('error');
                            }
                        }
                    });
                    return false;
                });
            });
        </script>

        
    <?php    
    }

    private function listSubscribed($list_data = array()){
        $list_all = $this->util->getTerms();
    ?>
        <div class="table-responsive">
            <table class="table table-bordered table-hover">
                <thead>
                    <tr>
                        <td><?php _e('List Name','eden_campaign'); ?></td>
                        <td><?php _e('Action','eden_campaign'); ?></td>
                    </tr>
                </thead>
                
                <tbody>
                            
                        
                
            <?php    
            
            if(!empty($list_data)):
                foreach ($list_data as $row):
                    $unsubscribe_url = admin_url('admin-ajax.php?action=eden_campaign_list_unsubscribe&id=' . $row['id'] . '&list_id='.$row['list_id'].'&nonce=' . wp_create_nonce('list_unsubscribe'));;
                    $active = true;
                    if($row['active'] == 0){
                        $active = false;
                    }
                    if(!$active) continue;
                ?>
                    <tr>
                        <td><?php echo $list_all[$row['list_id']]; ?></td>
                        <td>
                            <a href='<?php echo $unsubscribe_url; ?>' class='btn btn-success eden_list_unsubscribe'>Un Subscribe</a>
                        </td>
                    </tr>
                <?php            
                endforeach;
                
            else:
            ?>
                    <tr>
                        <td colspan="2"><?php echo __("You didn't subscribed to any lists",'eden_campaign');  ?></td>
                    </tr>
            <?php
            endif;
            ?>
                </tbody>
            </table>
        </div>
                
        <script type="text/javascript">
            jQuery(function($){
                $('.eden_list_unsubscribe').on('click',function(){
                    var th = $(this);
                    var url = th.attr('href');
                    th.html('Please Wait..');
                    th.attr('disabled','disabled');
                    jQuery.ajax({
                        type : "get",
                        dataType : "json",
                        url: url,
                        success: function(response) {
                           if(response.type == "success") {
                              th.parent().parent().remove();
                              var str= "";
                              if(response.message){
                                  $.each(response.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-info">' + data + '</div>';

                                   });
                              }
                              if(response.error){
                                  $.each(response.message, function (index, data) {
                                        //console.log(index + ' ' + data);
                                        str += '<div class="alert alert-danger">' + data + '</div>';

                                   });
                              }
                              
                              if(str) {
                                  $('#edenCampaignProfileMessage').html(str);
                              }
                           }
                           else {
                              alert("Something Went Wrong");
                           }
                        }
                     }); 


                    return false;
                });
            });

        </script>
                
    <?php            
    }
    
    private function postSubscribed($post_subscribed = array()){
    ?>
        <div class="table-responsive">
            <table class="table table-bordered table-hover">
                <thead>
                    <tr>
                        <th><?php echo __('Title','eden_campaign'); ?></th>
                        <th><?php echo __('Action','eden_campaign'); ?></th>
                    </tr>
                </thead>
                
                <tbody>
            <?php
            if(!empty($post_subscribed)):
            foreach ($post_subscribed as $key => $post_id){
                $post_title = get_the_title($post_id);
                $permalink = get_permalink($post_id);
                $unsubscribe_link = admin_url('admin-ajax.php?action=eden_campaign_post_unsubscribe&post_id=' . $post_id . '&nonce=' . wp_create_nonce('post_unsubscribe'));
                //$subscribe_link = admin_url('admin-ajax.php?action=eden_campaign_post_subscribe&post_id=' . $post_id . '&nonce=' . wp_create_nonce('post_subscribe'));
            ?>
                    <tr>
                        <td><?php echo "<a href='$permalink'>$post_title</a>"; ?></td>
                        <td><a class="btn btn-success eden_post_unsubscribe" href="<?php echo $unsubscribe_link ?>"><?php echo __('Un Subscribe','eden_capaign'); ?></a></td>
                    </tr>
            <?php
            }
            else:
            ?>
                    <tr>
                        <td colspan="2"><?php echo __("You didn't subscribed to any posts",'eden_campaign');  ?></td>
                    </tr>
            <?php
            endif;
            ?>
                </tbody>
            </table>
        </div>      
                
        <script type="text/javascript">
            jQuery(function($){
                $('.eden_post_unsubscribe').on('click',function(){
                    var th = $(this);
                    var url = th.attr('href');
                    th.html('Please Wait..');
                    th.attr('disabled','disabled');
                    jQuery.ajax({
                        type : "get",
                        dataType : "json",
                        url: url,
                        success: function(response) {
                           if(response.type == "success") {
                              th.parent().parent().remove();
                               $('#edenCampaignProfileMessage').html('<div class="alert alert-success">Post Unsubscribed Successfully.</div>');
                           }
                           else {
                              alert("Something Went Wrong");
                           }
                        }
                     }); 

                    return false;
                });
            });
        </script>
    <?php            
    }
    
}