<?php
namespace CAMPAIGN\UTIL;

if(!defined('WPINC')) {
    exit;
}

class Utility{
    protected $table,$dir,$url,$template_dir;
    
    public function __construct() {
        $this->dir = \CAMPAIGN\EdenCampaign::getDir();
        $this->url = \CAMPAIGN\EdenCampaign::getUrl();
        $this->table = "";
        $this->template_dir = $this->dir . '/templates/';
    }
    /**
     * This function will return all template folder name as key and their path as value
     * @return array All templates folder name or an empty array if no templates is found
     */
    public function getTemplates(){
        $files = scandir($this->template_dir);
        $templates = array();
        foreach($files as $key => $value):
            if($value != '.' || $value != '..'){
                $file = $this->template_dir . $value . '/index.html';
                if(file_exists($file)):
                    $templates[$value] = $file;
                endif;
            }
        endforeach;
        
        if(!empty($templates)):
            return $templates;
        else:
            return array();
        endif;
    }
    
    public function getTemplateData($template_name = ""){
        
        if($template_name != ""){
            $content = "";
            $file = $this->template_dir . $template_name . '/index.html';
                if(file_exists($file)):
                    $content = file_get_contents($file);
                endif;
                return $content;
        }
        else {
            return "";
        }
        
    }
    
    
    
    public function getTerms(){
        $transient = "subscriber_category_list";

            $args = array(
                'orderby'       => 'id', 
                'order'         => 'DESC',
                'hide_empty'    => false, 
                'fields'        => 'all', 
            );

            $terms = get_terms("subscriber_cat",$args);
            $ret = array();
            if(!empty($terms) && !is_wp_error($terms)):
                foreach ( $terms as $term ) {
                    $ret[$term->term_id] = $term->name;
                }
            endif;

        
        
        return $ret;
    }
    
    /**
    * Get the value of a settings field
    *
    * @param string $option settings field name
    * @param string $section the section name this field belongs to
    * @param string $default default text if it's not found
    * @return mixed
    */
    function getOption( $option, $section, $default = '' ) {
 
        $options = get_option( $section );

        if ( isset( $options[$option] ) ) {
            return $options[$option];
        }

        return $default;
    }
    
    
}


