<?php
namespace CAMPAIGN\WIDGET;

use WPDM\__\UI;

if(!defined('WPINC')) {
    exit;
}

class SubscriberWidget extends \WP_Widget {
	private $utility;
        /**
	 * Register widget with WordPress.
	 */
	function __construct() {
		parent::__construct(
			'eden_campaign_subscriber', // Base ID
			__('Campaign Subscriber', 'eden_campaign'), // Name
			array( 'description' => __( 'Widget to register subscriber', 'eden_campaign' ), ) // Args
		);
                $this->utility = new \CAMPAIGN\UTIL\Utility();
	}

	/**
	 * Front-end display of widget.
	 *
	 * @see WP_Widget::widget()
	 *
	 * @param array $args     Widget arguments.
	 * @param array $instance Saved values from database.
	 */
	public function widget( $args, $instance ) {
                //echo "<pre>";
                //print_r($instance);
                //echo "</pre>";
		$title = apply_filters( 'widget_title', $instance['title'] );
                $message = $instance['message'];
                $list_id = $instance['list_id'];


                echo $args['before_widget'];
		if ( ! empty( $title ) )
			echo $args['before_title'] . $title . $args['after_title'];
		//display form here
                ?>
                <div class="eden_campaign w3eden">
                <div id="error_div"></div>
                <form method="post" role="form" action="<?php echo admin_url('admin-ajax.php') ?>" id="eden_subscriber">
                    <input type="hidden" name="action" value="eden_subscribe">
                    <?php wp_nonce_field('eden_subscriber','eden_subscriber_nonce'); ?>
                    <?php if(isset($instance['show_fname']) && $instance['show_fname'] == "on" && !is_user_logged_in()): ?>
                    <div class="form-group">
                        <label for="fname"><?php echo $instance['fname_title']; ?></label>
                        <input type="text" class="form-control" name="eden_subscribe[fname]" id="fname" />
                    </div>
                    <?php endif; ?>

                    <?php if(isset($instance['show_lname']) && $instance['show_lname'] == "on" && !is_user_logged_in()): ?>
                    <div class="form-group">
                        <label for="lname"><?php echo $instance['lname_title']; ?></label>
                        <input type="text" class="form-control" name="eden_subscribe[lname]" id="lname" />
                    </div>
                    <?php endif; ?>

                    <?php if(isset($instance['show_gender']) && $instance['show_gender'] == "on" ): ?>
                    <div class="form-group">
                        <label for="gender"><?php echo $instance['gender_title']; ?></label>
                        <select name="eden_subscribe[gender]" id="gender" class="form-control">
                            <option value="0" ><?php _e('Male','eden_campaign'); ?></option>
                            <option value="1" ><?php _e('FeMale','eden_campaign'); ?></option>
                            <option value="2" ><?php _e('Not Specified','eden_campaign'); ?></option>
                        </select>
                    </div>
                    <?php endif; ?>

                    <div class="form-group">
                        <?php if(isset($instance['list_heading']) && $instance['list_heading'] != ""): ?> <label for="list_id"><?php echo $instance['list_heading']; endif; ?></label> <br>
                        <?php
                            $lists = $this->utility->getTerms();
                            if(is_array($list_id)) {
                                foreach ($list_id as $key => $id):
                                    echo "<label for='list_id_{$id}'><input type='checkbox' id='list_id_{$id}' name='eden_subscribe[list_id][]' value='$id'> {$lists[$id]}</label><br>";
                                endforeach;
                            } else {
                                echo UI::div(esc_attr__("No list avaialble yet!", WPDMNL_TEXT_DOMAIN), "alert alert-info");
                            }
                        ?>
                    </div>

                    <?php if(isset($instance['email']) && $instance['email'] != "" && !is_user_logged_in()): ?>
                    <div class="form-group">
                        <label for="lname"><?php echo $instance['email']; ?></label>
                        <input type="text" class="form-control" name="eden_subscribe[email]" id="lname" />
                    </div>
                    <?php endif; ?>


                    <button type="submit" class="btn btn-primary btn-block"><?php if(isset($instance['submit']) && $instance['submit'] != "") {echo $instance['submit']; } else { echo "Subscribe"; } ?></button>

                </form>

                <div class="modal fade" id="edenCampaignModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
                    <div class="modal-dialog">
                      <div class="modal-content">
                        <div class="modal-header">
                          <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                          <h4 class="modal-title" id="myModalLabel" style="display:inline-block">Email Subscription</h4>
                        </div>
                        <div class="modal-body" id="eden_campaign_modal_body">

                        </div>
                        <div class="modal-footer">
                          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        </div>
                      </div>
                    </div>
                 </div>




                <script type="text/javascript">
                    jQuery(function($){
                        $('#eden_subscriber').submit(function(){
                            $(this).ajaxSubmit({
                                dataType: 'json',
                                success: function(res){
                                    console.log(res);
                                    //res = json_encode(res);
                                    if(res.type=="success"){
                                        var str= "";
                                        if(res.message){
                                           $.each(res.message, function (index, data) {
                                                //console.log(index + ' ' + data);
                                                str += data;

                                           });
                                        }

                                        if(res.error){
                                            $.each(res.error, function(index, data){
                                                str += data;
                                            });
                                        }

                                        $('#eden_campaign_modal_body').html(str);
                                        $('#edenCampaignModal').modal();
                                    }
                                    else {
                                        console.log('error');
                                    }
                                }
                            });

                            return false;
                        });
                    });
                </script>
                </div>
                <?php


		echo $args['after_widget'];
	}

	/**
	 * Back-end widget form.
	 *
	 * @see WP_Widget::form()
	 *
	 * @param array $instance Previously saved values from database.
	 */
	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) {
			$title = $instance[ 'title' ];
		}
		else {
			$title = "";
		}

                if(isset($instance['message'])){
                    $message = $instance['message'];
                }
                else {
                    $message = "";
                }

                //Campaign list
                if(isset($instance['list_id'])) {
                    $list_id = $instance['list_id'];
                }
                else {
                    $list_id = array();
                }

                if(isset($instance['list_heading'])) {
                    $list_heading = $instance['list_heading'];
                }
                else {
                    $list_heading = "Availabel List";
                }

                //first name
                if(isset($instance['show_fname'])) {
                    $show_fname = $instance['show_fname'];
                }
                else {
                    $show_fname = "";
                }
                if(isset($instance['fname_title'])) {
                    $fname_title = $instance['fname_title'];
                }
                else {
                    $fname_title = "First Name";
                }


                //last name
                if(isset($instance['show_lname'])) {
                    $show_lname = $instance['show_lname'];
                }
                else {
                    $show_lname = "";
                }
                if(isset($instance['lname_title'])) {
                    $lname_title = $instance['lname_title'];
                }
                else {
                    $lname_title = "Last Name";
                }

                //gender
                if(isset($instance['show_gender'])) {
                    $show_gender = $instance['show_gender'];
                }
                else {
                    $show_gender = "";
                }

                if(isset($instance['gender_title'])) {
                    $gender_title = $instance['gender_title'];
                }
                else {
                    $gender_title = "Gender";
                }

                if(isset($instance['submit'])) {
                    $submit = $instance['submit'];
                }
                else {
                    $submit = "Subscribe";
                }

                if(isset($instance['email'])) {
                    $email = $instance['email'];
                }
                else {
                    $email = "Email";
                }




		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title','eden_campaign' ); ?>:</label>
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>

                <p>
		<label for="<?php echo $this->get_field_id( 'message' ); ?>"><?php _e( 'Custom Message','eden_campaign' ); ?>:</label>
                <textarea class="widefat" id="<?php echo $this->get_field_id( 'message' ); ?>" name="<?php echo $this->get_field_name( 'count' ); ?>"><?php echo esc_attr( $message ); ?></textarea>
		</p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'list_heading' ); ?>"><?php _e( 'Campaign list Heading' , 'eden_campaign' ); ?></label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'list_heading' ); ?>" name="<?php echo $this->get_field_name( 'list_heading' ); ?>" type="text" value="<?php echo esc_attr( $list_heading ); ?>" />
                </p>

                <p>
		<label for="<?php echo $this->get_field_id( 'list_id' ); ?>"><?php _e( 'List To display','eden_campaign'); ?></label> <br>
                    <?php
                        $list = $this->utility->getTerms();
                        if(!empty($list)) {
                            foreach($list as $id => $name){
                                $checked = "";
                                if(in_array($id, $list_id)) $checked = "checked='checked'";
                                echo "<label for='".$this->get_field_id( 'list_id' )."_{$id}'><input type='checkbox' name='" . $this->get_field_name( 'list_id' ) ."[]' value='{$id}' ".$checked." id='".$this->get_field_id( 'list_id' )."_{$id}'>$name</label><br>";
                            }
                        }
                    ?>
		</p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'show_fname' ); ?>"><input id="<?php echo $this->get_field_id( 'show_fname' ); ?>" name="<?php echo $this->get_field_name( 'show_fname' ); ?>" type="checkbox" value="on" <?php if($show_fname == "on") {echo "checked='checked'" ;} ?> /> <?php _e( 'Display First Name' , 'eden_campaign' ); ?></label><br>
                    <label for="<?php echo $this->get_field_id( 'fname_title' ); ?>"><?php _e( 'First Name Text' , 'eden_campaign' ); ?>: </label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'fname_title' ); ?>" name="<?php echo $this->get_field_name( 'fname_title' ); ?>" type="text" value="<?php echo esc_attr( $fname_title ); ?>" />
                </p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'show_lname' ); ?>"><input id="<?php echo $this->get_field_id( 'show_lname' ); ?>" name="<?php echo $this->get_field_name( 'show_lname' ); ?>" type="checkbox" value="on" <?php if($show_lname == "on") {echo "checked='checked'" ;} ?> /> <?php _e( 'Display Last Name' , 'eden_campaign' ); ?></label><br>
                    <label for="<?php echo $this->get_field_id( 'lname_title' ); ?>"><?php _e( 'Last Name Text' , 'eden_campaign' ); ?>: </label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'lname_title' ); ?>" name="<?php echo $this->get_field_name( 'lname_title' ); ?>" type="text" value="<?php echo esc_attr( $lname_title ); ?>" />
                </p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'show_gender' ); ?>"><input id="<?php echo $this->get_field_id( 'show_gender' ); ?>" name="<?php echo $this->get_field_name( 'show_gender' ); ?>" type="checkbox" value="on" <?php if($show_lname == "on") {echo "checked='checked'" ;} ?> /> <?php _e( 'Display Gender' , 'eden_campaign' ); ?></label><br>
                    <label for="<?php echo $this->get_field_id( 'gender_title' ); ?>"><?php _e( 'Gender Text' , 'eden_campaign' ); ?>: </label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'gender_title' ); ?>" name="<?php echo $this->get_field_name( 'gender_title' ); ?>" type="text" value="<?php echo esc_attr( $gender_title ); ?>" />
                </p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'email' ); ?>"><?php _e( 'Email Text' , 'eden_campaign' ); ?>: </label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'email' ); ?>" name="<?php echo $this->get_field_name( 'email' ); ?>" type="text" value="<?php echo esc_attr( $email ); ?>" />
                </p>

                <p>
                    <label for="<?php echo $this->get_field_id( 'submit' ); ?>"><?php _e( 'Submit Button Text' , 'eden_campaign' ); ?>: </label>
                    <input class="widefat" id="<?php echo $this->get_field_id( 'submit' ); ?>" name="<?php echo $this->get_field_name( 'submit' ); ?>" type="text" value="<?php echo esc_attr( $submit ); ?>" />
                </p>


		<?php
	}

	/**
	 * Sanitize widget form values as they are saved.
	 *
	 * @see WP_Widget::update()
	 *
	 * @param array $new_instance Values just sent to be saved.
	 * @param array $old_instance Previously saved values from database.
	 *
	 * @return array Updated safe values to be saved.
	 */
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : $old_instance['title'];
                $instance['message'] = ( !empty( $new_instance['message']) ) ? stripslashes($new_instance['message']): $old_instance['message'];
                $instance['list_id'] = ( !empty( $new_instance['list_id']) ) ? $new_instance['list_id']: $old_instance['list_id'];
                $instance['list_heading'] = ( !empty( $new_instance['list_heading']) ) ? $new_instance['list_heading']: $old_instance['list_heading'];
                $instance['show_fname'] = ( !empty( $new_instance['show_fname']) ) ? $new_instance['show_fname']: '';
                $instance['fname_title'] = ( !empty( $new_instance['fname_title']) ) ? $new_instance['fname_title']: $old_instance['fname_title'];
                $instance['show_lname'] = ( !empty( $new_instance['show_lname']) ) ? $new_instance['show_lname']: '';
                $instance['lname_title'] = ( !empty( $new_instance['lname_title']) ) ? $new_instance['lname_title']: $old_instance['lname_title'];
                $instance['show_gender'] = ( !empty( $new_instance['show_gender']) ) ? $new_instance['show_gender']: '';
                $instance['gender_title'] = ( !empty( $new_instance['gender_title']) ) ? $new_instance['gender_title']: $old_instance['gender_title'];
                $instance['submit'] = ( !empty( $new_instance['submit']) ) ? $new_instance['submit']: $old_instance['submit'];
                $instance['email'] = ( !empty( $new_instance['email']) ) ? $new_instance['email']: $old_instance['email'];

                return $instance;
	}

} // class Foo_Widget

function register_SubscriberWidget() {

}
add_action( 'widgets_init', function(){
    register_widget( 'CAMPAIGN\WIDGET\SubscriberWidget' );
});
