jQuery(document).ready(function() {

	jQuery('.add-to-pack-list').colorbox({
		width: function(){
			var screen_width = jQuery(window).width();
			if(screen_width > 700) return '600px';
			else return (screen_width*0.8)+'px';
		},
		scrolling: false,
	});

	jQuery('body').on('click','.add-to-list-ajax', function(){
		var ele = jQuery(this);
		var product_id = jQuery(this).data('package');
		var list_id = jQuery(this).data('list');
		//Show wait message
		jQuery('.ajax-res-msg').css({'opacity':'1'});

		post_data = 'action=wpdm_add2list&p=' + product_id+'&list=' + list_id;
		jQuery.ajax({
			type: 'POST',
			url: wpdm_url.ajax,
			data: post_data,
			dataType: 'json',
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				jQuery('.ajax-res-msg').css({'opacity':'1'});
				jQuery('.ajax-res-msg span').text('Error!');
				setTimeout(function(){
					jQuery('.ajax-res-msg').css({'opacity':'0'});
				}, 3000);
			},
			success: function (data, textStatus) {
				jQuery('.ajax-res-msg').css({'opacity':'1'});
				jQuery('.ajax-res-msg span').text(data.msg);
				setTimeout(function(){
					jQuery('.ajax-res-msg').css({'opacity':'0'});
				}, 3000);

				if(data.response == true){
					ele.addClass('remove-list-item-ajax item-in-list').removeClass('add-to-list-ajax');

					//Update number of items
					update_list_item_number('items-in-'+ list_id, '+');
				}

			}
		});

	});

	function update_list_item_number( class_name, ops){
		var prev_val = parseInt(jQuery('.'+class_name).text());
		if(ops == '+')
			jQuery('.'+class_name).text(prev_val + 1);
		else
			jQuery('.'+class_name).text(prev_val - 1);
	}

	jQuery('body').on('click','.remove-list-item-ajax', function(){
		var ele = jQuery(this);
		var product_id = jQuery(this).data('package');
		var list_id = jQuery(this).data('list');
		//Show wait message
		jQuery('.ajax-res-msg').css({'opacity':'1'});

		post_data = 'action=wpdm_remove_list_item&p=' + product_id+'&list=' + list_id;
		jQuery.ajax({
			type: 'POST',
			url: wpdm_url.ajax,
			data: post_data,
			dataType: 'json',
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				jQuery('.ajax-res-msg').css({'opacity':'1'});
				jQuery('.ajax-res-msg span').text('Error!');
				setTimeout(function(){
					jQuery('.ajax-res-msg').css({'opacity':'0'});
				}, 3000);
			},
			success: function (data, textStatus) {
				jQuery('.ajax-res-msg').css({'opacity': '1'});
				jQuery('.ajax-res-msg span').text(data.msg);
				setTimeout(function () {
					jQuery('.ajax-res-msg').css({'opacity': '0'});
				}, 3000);
				if (data.response == true){
					ele.addClass('add-to-list-ajax').removeClass('remove-list-item-ajax item-in-list');
					//Update number of items
					update_list_item_number('items-in-'+ list_id, '-');
				}
			}
		});

	});

	//List Names array

	// Add New list option in modal
	jQuery('body').on('click','.create-new-pack-list', function(e){
		e.preventDefault();
		jQuery('.wpdm-new-pack-list').css({'visibility':'visible'});
		jQuery('.save-new-pack-list').removeClass('wpdm-btn-disabled').addClass('wpdm-btn-active');
		jQuery(this).addClass('wpdm-btn-disabled').removeClass('wpdm-btn-active');
	});

	// Create new list and add current package in list
	jQuery('body').on('click','.save-new-pack-list', function(e){
		e.preventDefault();

		var name = jQuery('.new-list-name').text();
		var pack_id = jQuery('.new-list-item').data('package');
		var privacy = jQuery('.privacy-state.active').data('privacy');

		//List Names
		var list_names = [];
		jQuery('.pack-list-title').each(function(){
			list_names.push(jQuery(this).text());
		});
		list_names.pop();

		if(jQuery.inArray(name,list_names) != -1 ) {
			jQuery('.ajax-res-msg').css({'opacity': '1'});
			jQuery('.ajax-res-msg span').text('List with this name already exist!');
			setTimeout(function () {
				jQuery('.ajax-res-msg').css({'opacity': '0'});
			}, 3000);
		}else {
			//Show wait message
			jQuery('.ajax-res-msg').css({'opacity':'1'});
			post_data = 'action=wpdm_create_new_list&name=' + name + '&p=' + pack_id + '&privacy=' + privacy;
			jQuery.ajax({
				type: 'POST',
				url: wpdm_url.ajax,
				data: post_data,
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					jQuery('.ajax-res-msg').css({'opacity': '1'});
					jQuery('.ajax-res-msg span').text('Error!');
					setTimeout(function () {
						jQuery('.ajax-res-msg').css({'opacity': '0'});
					}, 3000);
				},
				success: function (data, textStatus) {
					jQuery('.ajax-res-msg').css({'opacity': '1'});
					jQuery('.ajax-res-msg span').text(data.msg);
					setTimeout(function () {
						jQuery('.ajax-res-msg').css({'opacity': '0'});
					}, 3000);

					if(data.response == true) {
						jQuery('.new-list-item').data('list',data.list_id);
						jQuery('.new-list-item').addClass('remove-list-item-ajax item-in-list').removeClass('new-list-item');
						jQuery('.no-item-yet').text('1 Item');
						jQuery('.no-item-yet').addClass('num-of-items').removeClass('no-item-yet').html('<span class="items-in-'+data.list_id+'">1</span> Item');
						// Disable button after clicking save
						jQuery('.save-new-pack-list').addClass('wpdm-btn-disabled').removeClass('wpdm-btn-active');
					}
				}
			});
		}

	});


	// Remove item from List ( from Dashboard area )
	jQuery('body').on('click','.wpdm-remove-from-list', function(e){
		e.preventDefault();
		var product_id = jQuery(this).data('package');
		var list_id = jQuery(this).data('list');
		//Show wait message
		jQuery('.ajax-res-msg').css({'opacity':'1'});

		post_data = 'action=wpdm_remove_list_item&p=' + product_id+'&list=' + list_id;
		jQuery.ajax({
			type: 'POST',
			url: wpdm_url.ajax,
			data: post_data,
			dataType: 'json',
			error: function (XMLHttpRequest, textStatus, errorThrown) {
				jQuery('.db-ajax-res-msg').css({'opacity':'1'});
				jQuery('.db-ajax-res-msg span').text('Error!');
				setTimeout(function(){
					jQuery('.db-ajax-res-msg').css({'opacity':'0'});
				}, 3000);
			},
			success: function (data, textStatus) {
				jQuery('.db-ajax-res-msg').css({'opacity': '1'});
				jQuery('.db-ajax-res-msg span').text(data.msg);
				setTimeout(function () {
					jQuery('.db-ajax-res-msg').css({'opacity': '0'});
				}, 3000);
				if (data.response == true){
					jQuery('#wpdm-list-item-'+product_id).remove();
					//Update number of items
					update_list_item_number('no-of-list-items', '-');
				}
			}
		});

	});

	// Delete List ( from Dashboard area )
	jQuery('body').on('click','.wpdm-delete-pack-list', function(e){
		e.preventDefault();

		var confrm = confirm(jQuery(this).attr('title'));

		if(confrm == true){
			var list_id = jQuery(this).data('list');
			//Show wait message
			jQuery('.ajax-res-msg').css({'opacity':'1'});
			post_data = 'action=wpdm_delete_list&list=' + list_id;
			jQuery.ajax({
				type: 'POST',
				url: wpdm_url.ajax,
				data: post_data,
				dataType: 'json',
				error: function (XMLHttpRequest, textStatus, errorThrown) {
					jQuery('.db-ajax-res-msg').css({'opacity':'1'});
					jQuery('.db-ajax-res-msg span').text('Error!');
					setTimeout(function(){
						jQuery('.db-ajax-res-msg').css({'opacity':'0'});
					}, 3000);
				},
				success: function (data, textStatus) {
					jQuery('.db-ajax-res-msg').css({'opacity': '1'});
					jQuery('.db-ajax-res-msg span').text(data.msg);
					setTimeout(function () {
						jQuery('.db-ajax-res-msg').css({'opacity': '0'});
					}, 3000);
					if (data.response == true){
						jQuery('#wpdm-list-'+list_id).remove();
					}
				}
			});
		}

	});

	// List Privacy toggle on Modal
	jQuery('body').on('click','.privacy-state', function(e){
		jQuery('.privacy-state').removeClass('active');
		jQuery(this).addClass('active');
	});


});
