<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

$user_id = get_current_user_id();
$list_id = isset($_GET['list']) ? $_GET['list'] : '';

$sep = ( isset( $params['flaturl'] ) && $params['flaturl'] == 1 ) ? '?' : '&';

if($list_id == ''){
    $lists = self::$PackListAPI->get_pack_lists_by_user($user_id);
?>
    <div class="panel panel-default dashboard-panel card">
        <div class="panel-heading card-header" style="position: relative;">
            <?php _e('Manage Lists',''); ?>
            <div class="db-ajax-res-msg"><span><?php _e('Please wait...'); ?></span></div>
        </div>
        <div class="panel-body card-body">

            <div class="row">
                <?php foreach($lists as $list): ?>
                    <div id="wpdm-list-<?php echo $list->list_id; ?>" class="col-md-4 col-sm-6 col-xs-12">
                        <div class="panel panel-default panel-wpdm-list card">
                            <div title="" class="panel-heading card-header"><?php echo $list->name; ?></div>
                            <div class="panel-body card-body text-center">
                                <a href="<?php echo $_SERVER['REQUEST_URI'].$sep.'list='.$list->list_id; ?>">
                                    <img alt="" class="wpdm-list-thumb" src="<?php echo plugins_url('/wpdm-package-lists/assets/images/list.png'); ?>">
                                </a>
                            </div>
                            <div class="panel-footer card-footer footer-info">
                                <?php echo $list->items; ?> Items
                                <span class="pull-right" style="width: 25px;">
                                <a title="Delete <?php echo $list->name; ?>?" class="wpdm-delete-pack-list" data-list="<?php echo $list->list_id;?>" href="#"><i class="fa fa-trash"></i></a>
                            </span>
                                <?php if($list->privacy == '1'): ?>
                                    <span class="pull-right" style="width: 25px; margin-right: 5px">
                                <span class="wpdm-private-list"><i class="fa fa-lock"></i></span>
                            </span>
                                <?php endif; ?>
                            </div>
                        </div>
                    </div>
                <?php endforeach; ?>
            </div>

        </div>
    </div>
<?php }else{

    $list = self::$PackListAPI->get_list_info($list_id);
    $list_items = self::$PackListAPI->get_list_items($list_id);
    $list_thumb_url = '';

    if( $list && ( get_current_user_id() == $list->owner_id ) || $list->privacy == '0' ):
    ?>
    <div class="panel panel-default dashboard-panel card">
        <div class="panel-heading card-header" style="position: relative;">
            <?php _e('Manage Lists ',''); ?> <i class="fa fa-angle-double-right"></i> <?php echo $list->name; ?>
            <div class="db-ajax-res-msg"><span><?php _e('Please wait...'); ?></span></div>
        </div>
        <div class="panel-body card-body">
            <div class="row">
            <?php foreach($list_items as $package_id):

                $resized_featured_image = wpdm_thumb((int)$package_id, [360, 270], false);
                //$list_thumb_url = $resized_featured_image;
                ?>
                <div id="wpdm-list-item-<?php echo $package_id;?>" class="col-md-4">
                    <div class="card panel panel-default pack-info-wrapper" style="margin-bottom: 30px;overflow: hidden;border-radius: 6px">
                        <a title="Remove from list" class="wpdm-remove-from-list" data-list="<?php echo $list_id;?>" data-package="<?php echo $package_id;?>" href="#"><i class="fa fa-times"></i></a>
                        <?=$resized_featured_image ?>
                        <a class="card-footer panel-footer bg-white" href="<?php echo get_the_permalink($package_id); ?>"><?php echo get_the_title($package_id); ?></a>
                    </div>
                </div>
            <?php endforeach; ?>
            </div>
        </div>
        <div class="panel-footer footer-info card-footer">
            <span class="no-of-list-items"><?php echo $list->items; ?></span> Items
            <span class="pull-right">Updated <?php echo date('j M Y',$list->updated);?></span>
        </div>
    </div>
        <?php
        if( $list->privacy == '0' ) include(WPDM_PL_PLUGIN_DIR.'/includes/share.php');
        ?>
<?php
    endif;

    // Private List warning to viewer
    if( $list && get_current_user_id() != $list->owner_id && $list->privacy == '1' ):
        ?>
        <div class="panel panel-default dashboard-panel card">
            <div class="panel-heading card-header">
                <?php _e('Manage Lists ',''); ?> <i class="fa fa-angle-double-right"></i> <?php echo $list->name; ?>
            </div>
            <div class="panel-body card-body">
                <span class=""><i class="fa fa-lock"></i> This is a private list. Only list owner can view list items.</span>
            </div>
        </div>
        <?php
        endif;

    }
?>
