<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}

$user_id = get_current_user_id();
$list_id = isset($_GET['list']) ? $_GET['list'] : '';

if($list_id == ''){
    $lists = self::$PackListAPI->get_pack_lists_paged();
?>

    <div class="w3eden wpdm-lists-public">
        <div class="row">

        <?php foreach($lists as $list): ?>
            <div class="col-md-6 col-sm-6 col-xs-12">
                <div class="wpdm-list-box">
                    <span class="wpdm-list-box-icon"><i class="fa fa-list"></i></span>
                    <div class="wpdm-list-box-content">
                        <a  href="<?php echo $_SERVER['REQUEST_URI'].'?list='.$list->list_id; ?>" class="wpdm-list-box-title"><?php echo $list->name; ?></a>
                        <div class="wpdm-list-box-meta">
                            <span class="wpdm-list-box-count"><i class="fa fa-file-o"></i><?php echo $list->items; ?> Items</span>
                            <span class="wpdm-list-box-update"></span>
                        </div>
                    </div>
                </div>
            </div>
        <?php endforeach; ?>

        </div>
    </div>

<?php }else{

    $list = self::$PackListAPI->get_list_info($list_id);

    if( $list && $list->privacy == '0' ):
        $list_items = self::$PackListAPI->get_list_items($list_id);
    ?>
    <div class="w3eden wpdm-lists-public wpdm-lists-public-single">
        <div class="row">
            <div class="col-md-12">
                <div class="wpdm-public-list-title">
                    <span style=""><?php echo $list->name; ?> <?php echo ' ( '.$list->items.' Items )'; ?></span>
                    <span class="pull-right">Updated <?php echo date('j M Y',$list->updated);?></span>
                </div>
            </div>
            <?php foreach($list_items as $package_id):

                $featured_image = wp_get_attachment_image_src(get_post_thumbnail_id($package_id), 'full');
                $featured_image_url = $featured_image['0'];
                $featured_image_path = str_replace(site_url('/'), ABSPATH, $featured_image_url);
                $resized_featured_image_path = wpdm_dynamic_thumb($featured_image_path, array(360, 270));
                $resized_featured_image_url = str_replace(ABSPATH, site_url('/'), $resized_featured_image_path);
                ?>
                <div id="wpdm-list-item-<?php echo $package_id;?>" class="col-md-4">
                    <div class="wpdm-list-item-card card panel panel-default" style="margin-bottom: 30px;border-radius: 6px;overflow: hidden">
                        <img class="pack-thumb-in-list" alt="" src="<?php echo $resized_featured_image_url; ?>">
                        <a class="wpdm-list-item-card-footer panel-footer card-footer" href="<?php echo get_the_permalink($package_id); ?>"><?php echo get_the_title($package_id); ?></a>
                    </div>
                </div>
            <?php endforeach; ?>

        </div>
    </div>
<?php
    endif;

    }
?>
