<?php
/*
Plugin Name: WPDM - Pinterest Pin Lock
Description: Ask to pin on Pinterest before download
Plugin URI: http://www.wpdownloadmanager.com/
Author: Shaon
Version: 1.2.2
Author URI: http://www.wpdownloadmanager.com/
*/

define("WPDM_PINKEY", "1d952d88264f42e9ddd3efae3b6a25a981fdee72");

class WPDM_Pinterest_Pin_Lock {

	function __construct() {

		add_action( 'wpdm_download_lock_option', array( $this, 'share_lock_option' ) );
		add_action( 'wpdm_download_lock', array( $this, 'apply_share_lock' ), 10, 2 );
		add_action( 'wpdm_check_lock', array( $this, 'check_lock' ), 10, 2 );
		add_action( 'init', array( $this, 'track_pin' ) );
		add_action( 'init', array( $this, 'check_for_pin' ) );

	}

	function share_lock_option( $post ) {
		$id = is_object( $post ) ? $post->ID : null;
		?>
        <div class="panel panel-default card">
            <div class="panel-heading card-header"><label><input type="checkbox" rel="pin_lock" class="wpdmlock"
                                                                 name="file[pin_lock]" <?php if ( get_post_meta( $id, '__wpdm_pin_lock', true ) == '1' ) {
						echo "checked=checked";
					} ?>
                                                                 value="1">
                    <span class="checkx"><i class="fas fa-check-double"></i></span>
					<?php echo __( 'Enable Pinterest Pin Lock', 'wpdmpro' ); ?></label></div>
            <div id="pin_lock"
                 class="formlock fwpdmlock panel-body card-body" <?php if ( get_post_meta( $id, '__wpdm_pin_lock', true ) != '1' ) {
				echo "style='display:none'";
			} ?> >


                Ask visitor to pin in pinterest before download


            </div>
        </div>

		<?php
	}

	function track_pin() {
		if ( isset( $_GET["wpdmpin"] ) && $_GET["wpdmpin"] != "" ) {

			// validate the user agent ("Pinterest/0.1 +http://pinterest.com/" as of 2012-12-20)
			$srouce    = isset( $_SERVER['HTTP_USER_AGENT'] ) && substr_count( $_SERVER['HTTP_USER_AGENT'], 'pinterest.com' ) ?: $_SERVER['HTTP_REFERER'];
			$userAgent = isset( $_SERVER['HTTP_REFERER'] ) ?: '';

            //wp_mail("shaon.cse99.cuet@gmail.com","Testing Pin", print_r($_SERVER,1).print_r($_GET,1), "From: no-reply@testing.com");

			if ( strpos( $userAgent, 'pinterest.com' ) || 1 ) {
				// save activity
				$key = $_GET['_udid'];
				update_post_meta( $_GET['_pid'], "__wpdmkey_" . $key, 3 );

			}
			$image = isset( $_GET["wpdmpin"] ) ? $_GET["wpdmpin"] : '/';
			header( 'Location: ' . $image );

			die();
		}
	}

	function check_for_pin() {
		if ( isset( $_GET['_chkpin'] ) && $_GET['_chkpin'] != "" ) {
			sleep( 4 );
            $ID = wpdm_query_var('_chkpin', 'int');
			$pinned = get_post_meta( $ID, "__wpdmkey_" . wpdm_query_var('_wpdmkey', 'txt'), true );
			if ( $pinned ) {
				//$file = array( 'ID' => $_GET[''] );
                //wpdm_download_url( $file, "_wpdmkey={$_GET['_wpdmkey']}" )
				$res  = array( 'download_url' =>  WPDM()->package->expirableDownloadLink($ID));
				wp_send_json($res);
			}
			echo "recheck";
			die();
		}
	}

	function apply_share_lock( $extralocks, $file ) {

		if ( get_post_meta( $file['ID'], '__wpdm_pin_lock', true ) != 1 ) {
			return $extralocks;
		}

		$url = get_permalink( $file['ID'] );
		$key = uniqid();
		if ( ! is_array( $extralocks ) ) {
			$extralocks = [ 'html' => '' ];
		}
		if ( ! isset( $extralocks['html'] ) ) {
			$extralocks['html'] = '';
		}
		$checkpinurl = home_url( "/?_chkpin=" . $file['ID'] . "&_wpdmkey=" . $key );
		$image       = isset( $file['preview'] ) ?: get_the_post_thumbnail_url( $file['ID'], 'full' );
		$title       = get_the_title( $file['ID'] );
		//wpdmdd(home_url("/?_pid={$file['ID']}&_udid={$key}&wpdmpin=".$image));
		$img = urlencode( home_url( "/?_pid={$file['ID']}&_udid={$key}&wpdmpin=" . $image ) );
		//$extralocks['html'] .= '<div class="fb-share-button" data-href="https://developers.facebook.com/docs/plugins/" data-type="button_count"></div>';
		//$extralocks['html'] .= '<a class="btn btn-fb btn-sm" id="facebook-share-'.$file['ID'].'" href="#" target="_blank"><i class="pluginButtonIcon img sp_plugin-button-2x sx_plugin-button-2x_favblue"></i> Share to Download<label class="label label-white" id="share-count-'.$file['ID'].'">0</label></a>';
		$extralocks['html'] .= '<button id="pin-button-' . $file['ID'] . '" class="wpdm-social-lock btn wpdm-pinterest" data-url="//www.pinterest.com/pin/create/button/?url=' . $url . '&media=' . $img . '&description=' . urlencode( $title ) . '" data-pin-do="buttonPin" data-pin-config="beside" data-pin-color="red"><i class="fab fa-pinterest"></i> Pin</button>
                                <script type="text/javascript" async src="//assets.pinterest.com/js/pinit.js"></script>
<script>
var pinchk = 0;
jQuery(document).on("click", "#pin-button-' . $file['ID'] . '" , function(){

checkpin();

});
function checkpin(){
pinchk++;
if(pinchk>30) return false;
jQuery.get("' . $checkpinurl . '",function(res){
if(res=="recheck") checkpin();
else {
//var data = jQuery.parseJSON(res);
//console.log(res.download_url);
if(typeof res.download_url !== "undefined") location.href = res.download_url;
}
});
}

</script>';
		$extralocks['lock'] = 'locked';
		$extralocks['type'] = 'social';

		return $extralocks;
	}

	function check_lock( $lock, $id ) {
		if ( get_post_meta( $id, '__wpdm_pin_lock', true ) == '1' ) {
			$lock = 'locked';
		}

		return $lock;
	}


}

new WPDM_Pinterest_Pin_Lock();



