<?php
/**
 * Template for Review Form
 *
 * This template can be overridden by copying it to /active-theme/download-manager/review-form.php
 *
 * @version     1.1.0
 */
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
?>
<div class="panel panel-default card mt-3">
    <div class="panel-heading card-header"><strong><?php _e('Submit Your Review', 'download-manager'); ?></strong></div>
<div class="card-body panel-body">
    <form method="post" action="<?php echo site_url('/'); ?>" id="wpdm-user-review-form">
    <input type="hidden" name="wpdmtask" value="save_review"/>
    <input type="hidden" name="wpdm_review[pid]" value="<?php echo $pid; ?>"/>
    <input type="hidden" name="wpdm_review[reply]" value="0"/>

    <div class="row mb-3">
        <div class="wpdm-reviews-input">
            <label class="wpdm-reviews-input" for="name">Name</label>
            <input class="wpdm-reviews-input form-control" type="text" name="name"/>
        </div>
        <div class="col-md-4">
            <input class="form-control" type="text" name="wpdm_review[name]" required="required" placeholder="<?php _e('Display Name', 'download-manager'); ?>" value="<?php echo $name; ?>"/>
        </div>
        <div class="col-md-5">

            <input class="form-control" type="email" placeholder="<?php _e('Email', 'download-manager'); ?>" required="required" value="<?php echo $email; ?>" name="wpdm_review[email]"/>
        </div>
        <div id="ratingdv" class="col-md-3">
            <div class="ttip" title="Rate">
                <input name="wpdm_review[rating]" type="hidden" value="0" id="rateval">
<!--                <div class="rateit bigstars" id="ratepackage" data-rateit-backingfld="#rateval" data-rateit-resetable="false" data-rateit-ispreset="true" data-rateit-min="0"-->
<!--                     data-rateit-starwidth="24" data-rateit-starheight="24" data-rateit-max="5">-->
<!--                </div>-->
                <?php self::rating_stars(0); ?>
            </div>
        </div>
    </div>
    <div class="row mb-3">
        <div class="col-md-12">
            <input class="form-control input-lg" type="text" name="wpdm_review[title]" placeholder="Review Title" required="required"/>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <textarea rows="4" class="form-control" name="wpdm_review[review]" placeholder="Write Your Review..." required="required"></textarea>
        </div>
    </div>

    <div class="text-right">
        <button id="wpdm-submit-review-button" class="btn btn-primary btn-lg">
            <i class="fa fa-check-double"></i> <?php _e('Submit Review', 'download-manager'); ?>
        </button>
    </div>

</form>
</div>
</div>
<div class="modal fade" id="wpdm-reply-form" style="margin-top:150px">
    <div class="modal-dialog">
        <form method="post" action="<?php echo home_url('/'); ?>" id="wpdm-user-reply-form">
        <div class="modal-content">
            <div class="modal-header">
                <strong><?php _e('Reply', 'download-manager'); ?></strong>
            </div>
            <div class="modal-body">
                    <input type="hidden" name="wpdmtask" value="save_review"/>
                    <input type="hidden" name="wpdm_review[pid]" value="<?php echo $pid; ?>"/>
                    <input type="hidden" id="wpdm-reply-for" name="wpdm_review[reply]" value="0"/>
                    <div class="row mb-2">
                        <div class="col-md-5">
                            <label for="wpdm_review[name]"><?php _e('Name', 'download-manager'); ?></label>
                            <input class="form-control" required="required" type="text" name="wpdm_review[name]" value="<?php echo $name; ?>"/></div>
                        <div class="col-md-7">
                            <label for="wpdm_review[email]"><?php _e('Email', 'download-manager'); ?></label>
                            <input class="form-control" type="email" required="required" name="wpdm_review[email]" value="<?php echo $email; ?>"/>
                        </div>
                    </div>
                    <div class="row mb-2">
                        <div class="col-md-12">
                            <label for="wpdm_review[title]"><?php _e('Title', 'download-manager'); ?></label>
                            <input required class="form-control" required="required" type="text" name="wpdm_review[title]"/>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <label for="wpdm_review[review]"><?php _e('Message', 'download-manager'); ?></label>
                            <textarea rows="4" class="form-control" name="wpdm_review[review]" required="required"></textarea>
                        </div>
                    </div>

            </div>
            <div class="modal-footer">
                <a href="#" type="button" class="btn" data-dismiss="modal" aria-hidden="true"><?php _e('Close', 'download-manager'); ?></a>
                <button class="btn btn-primary" id="wpdm-submit-reply-form"><?php _e('Save changes', 'download-manager'); ?></button>
            </div>
        </div>
        </form>
    </div>
</div>
<script>
    var rate = 0;
    jQuery(function ($) {
        //jQuery(".rateit").rateit();

        $('.star__ratings__:not(.__static) .star__ratings__blank i.far').on('click', function () {
            rate = $(this).data('value');
            $('#rateval').val(rate);
            $('.star__ratings__:not(.__static) .star__ratings__full').addClass('star-locked');

        });
        $('.star__ratings__:not(.__static)  .star__ratings__blank i.far').on('mouseover', function () {
            var star = $(this).data('value');
            var percent = 20*star;
            $('.star__ratings__:not(.__static) .star__ratings__full').css('width', percent+'%');
        });

        $('.star__ratings__:not(.__static)').on('mouseout', function () {
            var crt = 20;
            crt = crt * rate;
            $('.star__ratings__:not(.__static) .star__ratings__full:not(.star-locked)').css('width', '0%');
            $('.star__ratings__:not(.__static) .star__ratings__full.star-locked').css('width', crt + '%');
        });

        jQuery("#wpdm-user-review-form").submit(function () {
            jQuery("#wpdm-submit-review-button").attr("disabled", "disabled").html("<i class='fa fa-refresh'></i> <?php _e('Please Wait...', 'download-manager'); ?>");
            jQuery(this).ajaxSubmit({
                success: function (res) {
                    if (!res.match(/ok/)) {
                        jQuery("#wpdm-user-review-form").append("<div onclick='jQuery(this).fadeOut()' class='alert alert-danger'>" + res + "</div>");
                        jQuery("#wpdm-submit-review-button").removeAttr("disabled").html("<i class='fa fa-check'></i> <?php _e('Submit Review', 'download-manager'); ?>");
                    } else {
                        jQuery("#wpdm-submit-review-button").html("<i class='fa fa-check'></i> Done!");
                        jQuery("#wpdm-user-review-form").append("<div onclick='jQuery(this).fadeOut()' class='alert alert-success'><?php _e('Thanks for your comment! It will be published after review within a short time.', 'download-manager'); ?></div>");
                    }
                }
            });
            return false;
        });

        jQuery("#wpdm-user-reply-form").on('submit', function (e) {
            e.preventDefault();
            jQuery("#wpdm-submit-reply-form").attr("disabled", "disabled").html("<?php _e('Please Wait...', 'download-manager'); ?>");
            jQuery("#wpdm-user-reply-form").ajaxSubmit({
                success: function (res) {
                    jQuery("#wpdm-user-reply-form").append("<div class='alert alert-success'><?php _e('Thanks for your comment! It will be published after review within a short time.', 'download-manager'); ?></div>");
                    jQuery("#wpdm-submit-reply-form").html("Done!");
                }
            });
            return false;
        });

        jQuery(".reply-comment").click(function () {
            jQuery("#wpdm-reply-for").val(this.rel);
        });
    });
</script>

