<?php
/**
 * Template for Single Review
 *
 * This template can be overridden by copying it to /active-theme/download-manager/single-review.php
 *
 * @version     1.0.0
 */
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly
}
?>
<div class="panel panel-default card mt-3" <?php echo $reply_style; ?>>
    <div class="panel-body card-body">
        <div class="media wpdm-review">
            <a class="pull-left mr-3" href="#">
	            <?= get_avatar(get_post_meta( $review->ID, 'email', true ), 50); ?>
            </a>
            <div class="media-body">
                <h3 class="media-heading"><?php echo $review->post_title; ?></h3>
                <div class="wpdm-cmeta"></div>
                <div style="clear:both"></div>
                <?php echo wpautop($review->post_content); ?>
            </div>
        </div>
    </div>
    <div class="panel-footer card-footer">
        <?php //echo $rating; ?>
        <?php self::rating_stars($rate, true); ?>
        <div class="pull-right rinfo">
            <i class="fa fa-user"></i> <?php echo get_post_meta( $review->ID, 'name', true ); ?>  &nbsp;
            <i class="fa fa-calendar"></i> <?php echo date( get_option( 'date_format', 'M d, Y' ), strtotime( $review->post_date ) ); ?> &nbsp;
            <a class="reply-comment text-success" href="#wpdm-reply-form" data-toggle="modal" role="button" rel="<?php echo $review->ID; ?>"><i class="fa fa-comment"></i> Reply</a>
        </div>
        <div class="clear"></div>
    </div>
</div>
