<?php
/*
Plugin Name:  WPDM - Web Hooks
Plugin URI: http://www.wpdownloadmanager.com/
Description: Send request to remote url on execution of wpdm functions
Author: Shaon
Version: 0.1.1
Author URI: http://wpdownloadmanager.com/
*/

if(!defined('WPINC')) {
    exit('1');
}

class WpdmWebHook {
    private static $instance;
    private $dir, $url, $table,$hooks;

    public static function getInstance() {
        global $wpdb;
        if(self::$instance === null) {
            self::$instance = new self;

            self::$instance->hooks = apply_filters("wpdm_web_hooks", array(
                'wpdm_before_email_download_link' => array('_POST','package'),
                //'before_download' => array('package'),
                //'after_downlaod' => array('package'),
                'after_add_package' => array('post_id','post_info'),
                'wpdm_onstart_download' => array('package'),
                'user_register' => array('user'),
                'wpdmpp_payment_completed' => array('order'),
                'wpdmpp_order_renewed' => array('order'),
            ));

            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
            self::$instance->table = $wpdb->prefix . "ahm_wpdm_webhook";
            //self::$instance->registerHooks();
            self::$instance->actions();

        }
        return self::$instance;
    }

    private function actions() {
        //echo "Hello World";

        register_activation_hook(__FILE__, array($this,'activate'));
        register_deactivation_hook(__FILE__, array($this,'deactivate'));

        if(is_admin()){
            add_action('admin_menu', array($this, 'menuPage'));
            add_action('wpdm_webhook_changed',array($this,'deleteCache'));
        }
        if(!is_admin()){

        }

        if ( defined('DOING_AJAX') ) {

        }

        $this->registerHooks();

    }


    public function activate(){
        global $wpdb;
        //create database
        $sqls[] = "CREATE TABLE  `{$this->table}` (
                    `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
                    `hook` varchar(512) COLLATE utf8_unicode_ci NOT NULL,
                    `url` varchar(1024) COLLATE utf8_unicode_ci NOT NULL,
                    `description` text COLLATE utf8_unicode_ci,
                    `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
                    `added` int(10) unsigned NOT NULL,
                    `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
                    UNIQUE KEY `id` (`id`)
                  ) ;
                ";

        require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );

        foreach($sqls as $key => $query):
            dbDelta( $query );
        endforeach;
    }

    public function deactivate(){

    }

    public static function getDir(){
        return self::$instance->dir;
    }

    public static function getUrl(){
        return self::$instance->url;
    }

    public static function getHooks(){

        return self::$instance->hooks;
    }

    public function menuPage(){
        add_submenu_page('edit.php?post_type=wpdmpro', __('Web Hooks'), __('Web Hooks'), 'manage_options', 'wpdm-web-hook', array($this, 'webHook'));
    }

    public function WebHook(){
        if(!class_exists('WpdmWebHookAdmin')) {
            require_once $this->dir . '/admin-page.php';
        }

        WpdmWebHookAdmin::getInstance();
    }

    public function deleteCache(){
        delete_transient( 'wpdm_webhook_cache' );
    }

    public function registerHooks(){
        global $wpdb;

        //delete_transient( 'wpdm_webhook_cache' );
        if ( false === ( $allHooks = get_transient( 'wpdm_webhook_cache' ) ) ) {
            $query = "SELECT id,hook,url FROM `{$this->table}` WHERE status=1";
            $result = $wpdb->get_results($query,ARRAY_A);
            if(!empty($result)) {
                foreach($result as $row):
                    $allHooks[ $row['id'] ] = $row;
                endforeach;
            }
            set_transient( 'wpdm_webhook_cache', $allHooks );
        }

        if(empty($allHooks)) return;

        foreach ($allHooks as $hooks):
            $callbacks = function () use ($hooks){
                $args = func_get_args();
                return wpdm_web_hook_genericAction($hooks['id'],$args);
            };


            $arg_count = isset($this->hooks[ $hooks['hook'] ]) && is_array($this->hooks[ $hooks['hook'] ]) ? count($this->hooks[ $hooks['hook'] ]) : 0;

            //echo $desc['hook'] . '  ' .  $arg_count . '<br>';

            add_filter($hooks['hook'], $callbacks, 123456, $arg_count);
        endforeach;

    }




}

WpdmWebHook::getInstance();

    function wpdm_web_hook_genericAction($id,$args){

        $newobj = array();
        $data = array();
        global $wpdb;
        if ( false === ( $allHooks = get_transient( 'wpdm_webhook_cache' ) ) ) {
            $query = "SELECT id,hook,url FROM `{$wpdb->prefix}ahm_wpdm_webhook` WHERE status=1";
            $result = $wpdb->get_results($query,ARRAY_A);
            if(!empty($result)) {
                foreach($result as $row):
                    $allHooks[ $row['id'] ] = $row;
                endforeach;
            }
            set_transient( 'wpdm_webhook_cache', $allHooks );
        }

        if(array_key_exists($id, $allHooks)) {
            $data = $allHooks[$id];
        }
        else {
            return;
        }

        foreach($args as $i => $arg) {
            $newobj = array_merge($newobj,(array)$arg);
        }

//        if($data['hook'] === 'wpdm_onstart_download' || $data['hook'] === 'wpdm_before_email_download_link'){
//            if(!array_key_exists('email', $newobj)) {
//                return;
//            }
//        }

        //dd($newobj);

        //$json_body = json_encode($newobj);

        //$form_data = array("sslverify" => false, "ssl" => true, "body" => $json_body, 'referer' => get_bloginfo('url'));

	$response = wpdm_remote_post($data['url'], array('data'=> json_encode($newobj)));
        if (is_wp_error($response)) {
                //unseccessfull
        }
        else {
               //successfull
        }
    }


    function wpdm_webhook_ext_before_download($package){
        $email = isset($_GET['em']) ? stripslashes($_GET['em']) : '';
        $score = isset($_GET['score']) ? stripslashes($_GET['score']) : '';
        if(is_email($email) && is_numeric($score)) :
            unset($package['email_lock']);
            unset($package['password_lock']);
            unset($package['gplusone_lock']);
            unset($package['facebooklike_lock']);

            //$package['password_lock'] = 0;
            //$package['gplusone_lock'] = 0;
            //$package['facebooklike_lock'] = 0;
            $package['email'] = $email;
            $package['score'] = $score;

            $package['download_url'] = add_query_arg(array('em'=>$email, 'score'=>$score),$package['download_url']);
            //echo $package['download_url'] . '<br>';
            $package['download_link'] ='<a class="wpdm-download-link wpdm-download-locked __wpdm_download_btn__" rel="noindex nofollow" href="'.$package['download_url'].'"><i class=""></i>Download</a>';
            //echo "<pre>";    print_r($package); echo "</pre>";
        endif;


        return $package;
    }


add_filter('wpdm_after_prepare_package_data','wpdm_webhook_ext_before_download',100,1);
add_filter('before_download','wpdm_webhook_ext_before_download',100,1);
