<?php
/*
Plugin Name: WPDM - ZOHO CRM Leads
Plugin URL: http://www.wpdownloadmanager.com/
Description: ZOHO CRM Leads generation Addon for Download Manager Plugin
Version: 1.0.0
Author: Shaon
Author URI: http://www.wpdownloadmanager.com/

*/

if ( ! defined( 'WPINC' ) ) {
    die;
}

class WpdmZohoCrm{
    private static $instance;
    private $dir, $url;

    public static function getInstance() {
        if(self::$instance === null) {
            self::$instance = new self;
            self::$instance->actions();
            self::$instance->dir = dirname(__FILE__);
            self::$instance->url = WP_PLUGIN_URL . '/' . basename(self::$instance->dir);
        }
        return self::$instance;
    }

    private function actions() {
        register_activation_hook(__FILE__, array($this,'activate'));
        register_deactivation_hook(__FILE__, array($this,'deactivate'));

        if(is_admin()){
            add_filter('add_wpdm_settings_tab',  array($this,'settings_tab'));
        }
        if(!is_admin()){
        }
        add_action('wpdm_before_email_download_link',array($this,'pushToZOHO'),10,2);
    }

    function settings_tab($tabs){
        $tabs['zohocrm'] = \WPDM\admin\menus\Settings::createMenu('zohocrm', 'ZOHO CRM', array($this,'settings'), 'fa fa-envelope');
        return $tabs;

    }

    public function activate(){
        if(false == get_option('wpdm_zoho_crm')){
            $option = array('key'=>'');
            add_option('wpdm_zoho_crm',$option);
        }
    }

    public function deactivate(){

    }

    public static function getDir(){
        return self::$instance->dir;
    }

    public static function getUrl(){
        return self::$instance->url;
    }


    public function settings(){

        if(isset($_POST['zoho_auth_token'])){
            $options['token'] = stripslashes($_POST['zoho_auth_token']);
            $options['source'] = stripslashes($_POST['lead_source']);

            update_option('wpdm_zoho_crm',$options);
            die('Settings Saved Successfully.');
        }

        $options = get_option('wpdm_zoho_crm');
        $api_key = $options['token'];
        $lead_source = $options['source'];

        ?>
        <div class="panel panel-default">
            <div class="panel-heading">ZOHO Authentication Token</div>
            <div class="panel-body">
                <div class="form-group">
                    <label for="lead_source">Lead Source</label>
                    <input class="form-control" type="text" name="lead_source" id="lead_source" value="<?php echo $lead_source; ?>" placeholder="Enter a Lead Source Name">
                </div>
                <div class="form-group">
                    <label for="zoho_auth_token">Auth Token</label>
                    <input class="form-control" type="text" name="zoho_auth_token" id="zoho_auth_token" value="<?php echo $api_key; ?>" placeholder="Enter ZOHO Auth Token">
                    <p class="help-block">Get your ZOHO Authentication Token <a href="https://accounts.zoho.com/apiauthtoken/create?SCOPE=ZohoCRM/crmapi" target="_blank">HERE</a></p>
                </div>
            </div>
        </div>
        <?php
    }


    public function pushToZOHO($post, $file)
    {
        $name = $post['custom_form_field']['name'];
        $names = explode(' ', $name);
        $first_name = $names[0];
        $last_name = $names[1];

        $email = $post['email'];

        if (is_email($email)) {
            $option = get_option('wpdm_zoho_crm');
            $authtoken = $option['token'];
            $lead_source = $option['source'];

            $form_data = "";
            $form_data .= '<FL val="First Name">' . $first_name. '</FL>';
            $form_data .= '<FL val="Last Name">' . $last_name . '</FL>';
            $form_data .= '<FL val="Email">' . $email . '</FL>';


            $url = 'https://crm.zoho.com/crm/private/xml/Leads/insertRecords';
            $xmldata = '<Leads>
<row no="1"><FL val="Lead Source">'.$lead_source.'</FL>
' . $form_data . '
</row>
</Leads>';




            $fields = array(
                'newFormat' => 1,
                'authtoken' => $authtoken,
                'scope' => 'crmapi',
                'xmlData' => $xmldata
            );

            $fields_string = NULL;
            foreach ($fields as $key => $value) {
                $fields_string .= $key . '=' . $value . '&';
            }
            $fields_string = rtrim($fields_string, '&');


            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $fields_string);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
            curl_setopt($ch, CURLOPT_HEADER, 0);  // DO NOT RETURN HTTP HEADERS
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  // RETURN THE CONTENTS OF THE CALL

            curl_exec($ch);

            curl_close($ch);
        }
    }
}

WpdmZohoCrm::getInstance();
