<?php
if(!defined('WPINC')) {
    exit();
}
class WpdmApiTasks{
    public function __construct() {
        ;
    }


    protected function apiversion(){
        return array('apiversion'=>2);
    }
    
    /**
     * Returns an array of term objects, or a WP_Error object if any of the taxonomies to get terms from does not exist. 
     * @return Array term objects
     * @return WP_ERROR 
     */
    protected function getCategoryList(){
        $args = array(
            'orderby'       => 'name',
            'order'         => 'ASC',
            'hide_empty'    => false,
            'exclude'       => array(),
            'exclude_tree'  => array(),
            'include'       => array(),
            'number'        => '',
            'fields'        => 'all',
            'slug'          => '',
            'hierarchical'  => true,
            'get'           => '',
            'name__like'    => '',
            'pad_counts'    => false,
            'offset'        => '',
            'search'        => '',
            'cache_domain'  => 'core'
        );
        $categories = get_terms('wpdmcategory',$args);
        return $categories;
    }

    protected function getCategoryList2(){
        $args = array(
            'orderby'       => 'name',
            'order'         => 'ASC',
            'hide_empty'    => false,
            'exclude'       => array(),
            'exclude_tree'  => array(),
            'include'       => array(),
            'number'        => '',
            'fields'        => 'all',
            'slug'          => '',
            'hierarchical'  => true,
            'get'           => '',
            'name__like'    => '',
            'pad_counts'    => false,
            'offset'        => '',
            'search'        => '',
            'cache_domain'  => 'core'
        );
        $categories = get_terms('wpdmcategory',$args);
        if(!empty($categories)) {
            $ret['data'] = $categories;
            $ret['message'] = "Success";
        } else {
            $ret['error'] = "No Category Found...";
        }
        return $ret;
    }

    protected function getPackageList($cat_id=null,$count=null){
        $args = array();
        if($cat_id != null ){
            $args['tax_query'] = array(
                array(
                    'taxonomy' => 'wpdmcategory',
                    'field' => 'id',
                    'terms' => intval($cat_id)
                )
            );
        }

        if($count != null){
            $args['posts_per_page'] = intval($count);
        }
        else {
            $args['posts_per_page'] = -1;
        }
        $args['post_type'] = "wpdmpro";
        $args['post_status'] = "publish";

        $query = new WP_Query( $args );
        $post_content = $query->posts;
        $post_extra = array();
        if($query->have_posts()):
            while($query->have_posts()): $query->the_post();
                $link = get_permalink(get_the_ID());
                $pinfo = wpdm_custom_data(get_the_ID());
                if(!isset($pinfo['version'])) $pinfo['version'] = '1.0.0';
                $price = wpdmpp_product_price(get_the_ID());
                $title = get_the_title();
                $thumbnail = wpdm_thumb( get_the_ID(), array(200,200),'url');
                $excerpt = substr(strip_tags(get_the_content()),0,80)."...";
                $cart = "<a href='{$link}' class='btn btn-info' target='_blank'><i class='icon icon-white icon-shopping-cart'></i> Buy Now</a>";
                $terms = get_the_terms( get_the_ID(), 'wpdmcategory' );
                $cats = array();
                if ( $terms && ! is_wp_error( $terms ) ) :
                    $draught_links = array();
                    foreach ( $terms as $term ) {
                        $cats[] = $term->slug;
                    }
                endif;

                $tmp = array(
                    "ID"=>get_the_ID(),
                    "link"=>$link,
                    "pinfo"=>$pinfo,
                    "price"=>$price,
                    "currency"=>get_option('_wpdm_curr_sign','$'),
                    "title"=>$title,
                    "thumbnail"=>$thumbnail,
                    "excerpt"=>$excerpt,
                    'cats' => $cats,
                    "cart" => $cart
                );
                $post_extra[get_the_ID()] = $tmp;
            endwhile;
        endif;
        $ret = array('post'=>$post_content,"post_extra"=>$post_extra);
        return $ret;
    }
	
    
    protected function getProductList(){
        $cat_id = isset($_REQUEST['cat_id']) ? (int) stripslashes($_REQUEST['cat_id']) : '';
        $count = isset($_REQUEST['count']) ? (int) stripslashes($_REQUEST['count']) : 0;
        $order_by = isset($_REQUEST['order_by']) ? (int) stripslashes($_REQUEST['order_by']) : '';
        $order = isset($_REQUEST['order']) ? (int) stripslashes($_REQUEST['order']) : 'asc';
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : 1;
        
        
        
        $args = array();
        
        //category paremeter
        if($cat_id !== '' ){
            $args['tax_query'] = array(
		array(
			'taxonomy' => 'wpdmcategory',
			'field' => 'id',
			'terms' => $cat_id
		)
            );
        }
        
        //order parameter
        if($order_by != '') {
            if($order_by != 'modified' && $order_by != 'date'){
                $args['meta_key'] = $order_by;
                $args['orderby'] = 'meta_value_num'; 
            }
            else {
                $args['orderby'] = $order_by;
            }

            $args['order'] = $order;
        }
        
        //pagination parameter
        if($count > 0) {
            $start = ($cp-1)*$count;
            $args["posts_per_page"] = $count;
            $args["offset"] = $start;
        }
        else {
            $args['posts_per_page'] = -1;
        }
        
        
        
        $args['post_type'] = "wpdmpro";
        $args['post_status'] = "publish";
        
        $query = new WP_Query( $args );
        //echo "<pre>"; print_r($query); echo "</pre>";
        $ret = array();
        if($query->have_posts()):
        while ($query->have_posts()){ 
            $query->the_post();
            $package_role = maybe_unserialize(get_post_meta(get_the_ID(), '__wpdm_access', true));
            $ext = "_blank";
            $data = wpdm_custom_data(get_the_ID());
            $data += get_post(get_the_ID(), ARRAY_A);
            $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
            $data['ID'] = get_the_ID();
            $data['id'] = get_the_ID();
            $data['page_url'] = get_permalink(get_the_ID());
            $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
            $ret[] = $data;
        }
        else:
            $ret['message'] = "No package found...";
        endif;
        
        return $ret;
    }
    
     protected function getRecentPackages(){
        $cat_id = isset($_REQUEST['cat_id']) ? (int) stripslashes($_REQUEST['cat_id']) : '';
        $count = isset($_REQUEST['count']) ? (int) stripslashes($_REQUEST['count']) : '10';
        $order_by = isset($_REQUEST['order_by']) ? (int) stripslashes($_REQUEST['order_by']) : '';
        $order = isset($_REQUEST['order']) ? (int) stripslashes($_REQUEST['order']) : 'asc';
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : 1;
        
        $args = array();
        
        if($cat_id !== '' ){
            $args['tax_query'] = array(
		array(
			'taxonomy' => 'wpdmcategory',
			'field' => 'id',
			'terms' => $cat_id
		)
            );
        }
        
        
        //order parameter
        if($order_by != '') {
            if($order_by != 'modified' && $order_by != 'date'){
                $args['meta_key'] = $order_by;
                $args['orderby'] = 'meta_value_num'; 
            }
            else {
                $args['orderby'] = $order_by;
            }

            $args['order'] = $order;
        }
        
        //pagination parameter
        if($count > 0) {
            $start = ($cp-1)*$count;
            $args["posts_per_page"] = $count;
            $args["offset"] = $start;
        }
        else {
            $args['posts_per_page'] = -1;
        }
        
        
        $args['post_type'] = "wpdmpro";
        $args['post_status'] = "publish";
        
        $args['order'] = 'DESC';
        $args['orderby'] = 'date';

        $query = new WP_Query( $args );
        $ret = array();
        if($query->have_posts()):
        while ($query->have_posts()){ 
            $query->the_post();
            $package_role = maybe_unserialize(get_post_meta(get_the_ID(), '__wpdm_access', true));
            $ext = "_blank";
            $data = wpdm_custom_data(get_the_ID());
            $data += get_post(get_the_ID(), ARRAY_A);
            $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
            $data['ID'] = get_the_ID();
            $data['id'] = get_the_ID();
            $data['page_url'] = get_permalink(get_the_ID());
            $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
            $ret[] = $data;
        }
        else:
            $ret['message'] = "No package found...";
        endif;
        
        return $ret;
        
    }
    
    protected function getMostDownloadedPackages(){
        $cat_id = isset($_REQUEST['cat_id']) ? (int) stripslashes($_REQUEST['cat_id']) : '';
        $count = isset($_REQUEST['count']) ? (int) stripslashes($_REQUEST['count']) : '';
        $order_by = isset($_REQUEST['order_by']) ? (int) stripslashes($_REQUEST['order_by']) : '';
        $order = isset($_REQUEST['order']) ? (int) stripslashes($_REQUEST['order']) : 'asc';
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : 1;
        
        $args = array();
        if($cat_id !== '' ){
            $args['tax_query'] = array(
		array(
			'taxonomy' => 'wpdmcategory',
			'field' => 'id',
			'terms' => $cat_id
		)
            );
        }
        
        //order parameter
        if($order_by != '') {
            if($order_by != 'modified' && $order_by != 'date'){
                $args['meta_key'] = $order_by;
                $args['orderby'] = 'meta_value_num'; 
            }
            else {
                $args['orderby'] = $order_by;
            }

            $args['order'] = $order;
        }
        
        //pagination parameter
        if($count > 0) {
            $start = ($cp-1)*$count;
            $args["posts_per_page"] = $count;
            $args["offset"] = $start;
        }
        else {
            $args['posts_per_page'] = -1;
        }
        
        //custom_field parameter
        $args['meta_query'] = array(
		array(
			'key'     => '__wpdm_download_count',
			'value'   => '0',
			'compare' => '>',
		),
	);
        
        
        $args['post_type'] = "wpdmpro";
        $args['post_status'] = "publish";
        
        $query = new WP_Query( $args );
        $ret = array();
        if($query->have_posts()):
        while ($query->have_posts()){ 
            $query->the_post();
            $package_role = maybe_unserialize(get_post_meta(get_the_ID(), '__wpdm_access', true));
            $ext = "_blank";
            $data = wpdm_custom_data(get_the_ID());
            $data += get_post(get_the_ID(), ARRAY_A);
            $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
            $data['ID'] = get_the_ID();
            $data['id'] = get_the_ID();
            $data['page_url'] = get_permalink(get_the_ID());
            $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
            $ret[] = $data;
        }
        else:
            $ret['message'] = "No package found...";
        endif;
        
        return $ret;
        
    }

    protected function getMostSalingPackages(){
        $count = isset($_REQUEST['count']) ? (int) stripslashes($_REQUEST['count']) : '10';
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : '';
        
        //pagination parameter
        if($cp > 1) {
            $start = ($cp-1)*$count;
        }
        else {
            $start = 0;
        }
        
        $ret = array();
        if(function_exists('wpdmpp_popular_files')) {
            global $wpdb;
            $query = "select *, sum(oi.price) as price_total from {$wpdb->prefix}ahm_orders o "
            . "inner join {$wpdb->prefix}ahm_order_items oi on oi.oid=o.order_id "
            . "inner join {$wpdb->prefix}posts p on oi.pid=p.ID where p.post_type='wpdmpro' "
            . "and o.payment_status='Completed'  group by  oi.pid order by price_total desc limit $start, $count";
            
            $pp = $wpdb->get_results($query,ARRAY_A);
            
            $cnt = count($pp);
            for($i = 0; $i<$cnt; $i++){
                $data = wpdm_custom_data($pp[$i]['ID']);
                $pp[$i]['items'] = unserialize($pp[$i]['items']);
                $pp[$i]['cart_data'] = maybe_unserialize($pp[$i]['cart_data']);
                $pp[$i]['currency_sign'] = wpdmpp_currency_sign();
                $data += $pp[$i];
                $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
                $data['page_url'] = get_permalink($pp[$i]['id']);
                $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
                $ret[] = $data;
            }
        }
        return $ret;
    }
    
    protected function getMostSalingPackagesByRange(){
        global $wpdb;
        $count = isset($_REQUEST['count']) ? (int) stripslashes(trim($_REQUEST['count'])) : 100;
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : '';
        
        //pagination parameter
        if($cp > 1) {
            $start = ($cp-1)*$count;
        }
        else {
            $start = 0;
        }
        
        $startDate = isset($_REQUEST['sdate']) ? stripslashes(trim($_REQUEST['sdate'])) : stripslashes(trim($_REQUEST['edate']));
        $endDate = isset($_REQUEST['edate']) ? stripslashes(trim($_REQUEST['edate'])) : stripslashes(trim($_REQUEST['sdate']));
        $ret = array();
        if( $startDate != '' || $endDate != '' ) {
            $sdate = strtotime("$startDate 00:00:00");
            $edate = strtotime("$endDate 23:59:59");
            $query = "select *, sum(oi.price) as price_total from {$wpdb->prefix}ahm_orders o "
            . "inner join {$wpdb->prefix}ahm_order_items oi on oi.oid=o.order_id "
            . "inner join {$wpdb->prefix}posts p on oi.pid=p.ID where p.post_type='wpdmpro' "
            . "and o.payment_status='Completed' and o.date>=$sdate and o.date<=$edate  group by  oi.pid order by price_total desc limit $start, $count";
            
            $pp = $wpdb->get_results($query,ARRAY_A);
            
            $cnt = count($pp);
            for($i = 0; $i<$cnt; $i++){
                $data = wpdm_custom_data($pp[$i]['ID']);
                
                $pp[$i]['items'] = unserialize($pp[$i]['items']);
                $pp[$i]['cart_data'] = maybe_unserialize($pp[$i]['cart_data']);
                $pp[$i]['currency_sign'] = wpdmpp_currency_sign();
                $data += $pp[$i];
                $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
                $data['page_url'] = get_permalink($pp[$i]['id']);
                $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
                $ret[] = $data;
            }
        } else {
            $ret['message'] = "Invalid Date Range";
        }
        return $ret;
    }
    
    protected function getTodaySales(){
        global $wpdb;
        $count = isset($_REQUEST['count']) ? (int) stripslashes(trim($_REQUEST['count'])) : 100;
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : '';
        
        //pagination parameter
        if($cp > 1) {
            $start = ($cp-1)*$count;
        }
        else {
            $start = 0;
        }
        
        $startDate = date('Y-m-d 00:00:00');
        if(isset($_REQUEST['date']))
            $startDate = date($_REQUEST['date'].'00:00:00');
        $endDate = time();
        $ret = array();
        if( $startDate != '' && $endDate != '' ) {
            $sdate = strtotime($startDate);
            $edate = $endDate;
            $query = "select *, oi.price as item_price, sum(oi.quantity) as item_counts from {$wpdb->prefix}ahm_orders o "
            . "inner join {$wpdb->prefix}ahm_order_items oi on oi.oid=o.order_id "
            . "inner join {$wpdb->prefix}posts p on oi.pid=p.ID where p.post_type='wpdmpro' "
            . "and o.payment_status='Completed' and o.date>=$sdate and o.date<=$edate  group by  oi.pid order by item_price desc limit $start, $count";

            $pp = $wpdb->get_results($query,ARRAY_A);

            $cnt = count($pp);
            for($i = 0; $i<$cnt; $i++){
                $data = wpdm_custom_data($pp[$i]['ID']);
                
                $pp[$i]['items'] = unserialize($pp[$i]['items']);
                $pp[$i]['cart_data'] = maybe_unserialize($pp[$i]['cart_data']);
                $pp[$i]['currency_sign'] = wpdmpp_currency_sign();
                
                $data += $pp[$i];
                $data['download_count'] = isset($data['download_count'])?$data['download_count']:0;
                $data['ID'] = $pp[$i]['id'];
                $data['id'] = $pp[$i]['id'];
                $data['page_url'] = get_permalink($pp[$i]['id']);
                $data['files'] = isset($data['files'])?maybe_unserialize($data['files']):array();
                $ret[] = $data;
            }
        } else {
            $ret['message'] = "Invalid Date Range";
        }

        return $ret;
    }
    
    protected function getOrderByRange(){
        $startDate = isset($_REQUEST['sdate']) ? stripslashes($_REQUEST['sdate']) : stripslashes($_REQUEST['edate']);
        $endDate = isset($_REQUEST['edate']) ? stripslashes($_REQUEST['edate']) : stripslashes($_REQUEST['sdate']);
        $count = isset($_REQUEST['count']) ? (int) stripslashes(trim($_REQUEST['count'])) : 1000;
        $cp = isset($_REQUEST['cp']) ? (int) stripslashes($_REQUEST['cp']) : '';
        
        //pagination parameter
        if($cp > 1 && $count > 0) {
            $start = ($cp-1)*$count;
        }
        else {
            $start = 0;
        } 
        
        
        if($startDate != '' || $endDate != '') {
            $sdate = strtotime("$startDate 00:00:00");
            $edate = strtotime("$endDate 23:59:59");
            global $wpdb;
            $ret = array();
            $query = "select * from {$wpdb->prefix}ahm_orders where `date` >= $sdate and `date` <= $edate and payment_status='Completed' order by `date` desc limit $start,$count";
            $orders = $wpdb->get_results($query);
            if(!empty($orders)) {
                foreach($orders as $order) { 
                    $user_info = get_userdata($order->uid);
                    $data['order_id'] = $order->order_id;
                    $data['total'] = $order->total;
                    $data['customer_name'] = isset($user_info->user_login)?$user_info->user_login:'';
                    $data['order_status'] = $order->order_status ;
                    $data['payment_status'] = $order->payment_status ;
                    $data['currency_sign'] = wpdmpp_currency_sign();
                    $data['date'] = date("D, F d, Y",$order->date);
                    $ret[] = $data;
                }
            }
        }
        else {
            //invalid date
            $ret['message'] = "Invalid range";
        }
        
        return $ret;
        
    }

    protected function getOrderDetails(){
        $order_id = isset($_REQUEST['oid']) ? stripslashes($_REQUEST['oid']) : '';
        if($order_id != '' && function_exists('wpdmpp_orders')) {
            global $wpdb;
            $order1 = new Order();
            $query = $wpdb->prepare("select * from {$wpdb->prefix}ahm_orders where order_id=%s",array($order_id));
            $order = $wpdb->get_row($query,ARRAY_A);
            $order['items'] = unserialize($order['items']);
//            foreach($order['items'] as $key => $var){
//                $order['items'][$key]['unit_price'] = number_format((($item['price']+$var['prices'])*$var['quantity'])-$var['discount_amount'] - $var['coupon_amount'],2,".","");
//            }
            $order['cart_data'] = maybe_unserialize($order['cart_data']);
            $order['tax'] = $order1->wpdmpp_calculate_tax($order['order_id']);
            $order['currency_sign'] = wpdmpp_currency_sign();
            $order['client_info'] = get_userdata($order['uid']);
            return $order;
        }
    }


    protected function overview(){
        global $wpdb;
        $overview = array();
        $count_posts = wp_count_posts('wpdmpro');
        $overview['total_packages'] = $count_posts->publish + $count_posts->draft + $count_posts->pending;
        $overview['total_publish_packages'] = $count_posts->publish;
        $overview['total_draft_packages'] = $count_posts->draft;
        $overview['total_pending_packages'] = $count_posts->pending;
        $overview['total_downloads'] = (int)$wpdb->get_var("select sum(meta_value) from {$wpdb->prefix}postmeta where meta_key='__wpdm_download_count'");
        $overview['total_subscribers'] = count($wpdb->get_results("select count(email) from {$wpdb->prefix}ahm_emails group by email"));
        $s = strtotime(date("Y-m-d 0:0:0"));
        $e = time();
        $overview['todays_subscribers'] = count($wpdb->get_results("select count(email) from {$wpdb->prefix}ahm_emails where date > $s and date < $e group by email"));
        $overview['fblike'] = get_option('wpdm_fb_likes', 0);
        $overview['tweets'] = get_option('wpdm_tweets', 0);
        $overview['gplus1s'] = get_option('wpdm_gplus1s', 0);
        $overview['linkedins'] = get_option('wpdm_linkedins', 0);
        return $overview;
    }

    protected function getStats(){
        global $wpdb;
        $start  = isset($_REQUEST['tstart'])?strtotime(($_REQUEST['tstart'])): strtotime('-7 days');
        $end  = isset($_REQUEST['tend'])?strtotime(($_REQUEST['tend'])): time();
        $starts = array(date("j", $start),date("m", $start),date("Y", $start), date("D", $start));
        $days = $downloads = $sales = array();
        for($i = date("Ymd", $start); $i < date("Ymd",$end);){
            $dts = array('day'=>date("j", strtotime($i)), 'month' =>  date("m", strtotime($i)),'year' => date("Y", strtotime($i)), 'wday' => date("D", strtotime($i)));
            $days[] = date("D", strtotime($i));
            $ds = strtotime(date("Ymd", $i)." 00:00:00");
            $de = strtotime(date("Ymd", $i)." 23:59:00");
            $downloads[] = $wpdb->get_var("select count(*) from {$wpdb->prefix}ahm_download_stats where `day`='{$dts['day']}' and `month`='{$dts['month']}' and `year`='{$dts['year']}'");
            $sales[] = $wpdb->get_var("select count(*) from {$wpdb->prefix}ahm_orders where `date`>='{$ds}' and `date`<='{$de}'");
            $i = date('Ymd', strtotime($i.' +1 day'));
        }

        $data = new stdClass();
        $data->days = $days;
        $data->downloads = $downloads;
        $data->sales = $sales;
        return $data;
    }
    
    
    
    
    
}
