<?php

/*
  Plugin Name: WPDMPP - Linked Products
  Plugin URI: http://www.wpdownloadmanager.com/
  Description: Linked Products
  Author: Shaon
  Version: 1.0.0
  Author URI: http://www.wpdownloadmanager.com/
 */



if (!class_exists('WPDMPP_LinkedProducts')) {

    class WPDMPP_LinkedProducts {

        function __construct() {
            $this->Filters();
            $this->Action();
        }

        function Filters() {
            add_filter('wpdm_package_settings_tabs', array($this, 'settingsTab'));
            add_shortcode('wpdmpp_upsell', array($this, 'upsellHTML'));
            add_shortcode('wpdmpp_crosssell', array($this, 'crosssellHTML'));
            add_shortcode('wpdmpp_groupsell', array($this, 'groupingHTML'));
            add_filter( 'wpdm_after_prepare_package_data', array( $this, 'fetch_template_tag' ) );
            add_filter( 'wdm_before_fetch_template', array( $this, 'fetch_template_tag' ) );
        }

        function Action() {
            if (is_admin()) {
                add_action('wp_ajax_wpdm_cal_get_product', array($this, 'wpdm_cal_get_product'));
                add_action("admin_enqueue_scripts", array($this, 'wpdm_cal_enqueue_scripts'));
                add_action( 'wpdm_template_editor_menu', array( $this, 'template_editor_menu' ));
            }
        }

        function linkProductsHTML() {
            if (get_post_type() != 'wpdmpro')
                return;

            include wpdm_tpl_path("linked-products.php", dirname(__FILE__) . '/tpls/');
        }

        function wpdm_cal_enqueue_scripts() {
            if (get_post_type() == 'wpdmpro') {
                wp_enqueue_script('jquery-ui-core');
                wp_enqueue_script('jquery-ui-autocomplete');
            }
        }

        function upsellHTML($params = array()) {
            $pid  = $params['id'];

            ob_start();
            include wpdm_tpl_path("upsell-products.php", dirname(__FILE__) . '/tpls/');
            return ob_get_clean();
        }

        function crosssellHTML($params = array()) {
            ob_start();
            include wpdm_tpl_path("crosssell-products.php", dirname(__FILE__) . '/tpls/');
            return ob_get_clean();
        }

        function groupingHTML($params = array()) {
            $pid  = $params['id'];
            ob_start();
            include wpdm_tpl_path("grouping-products.php", dirname(__FILE__) . '/tpls/');
            return ob_get_clean();
        }

        function settingsTab($tabs) {
            $tabs['linked-products'] = array('name' => 'Linked Products', 'callback' => array($this, 'linkProductsHTML'));
            return $tabs;
        }

        function my_scripts() {

            wp_enqueue_script('jquery');
            wp_enqueue_script('jquery-form');

            wp_enqueue_script("tokeninput", plugins_url('/wpdmpp-linked-products/src/jquery.tokeninput.js'), array('jquery'));
            wp_enqueue_style("token-input", plugins_url('/wpdmpp-linked-products/styles/token-input.css'));
            wp_enqueue_style("token-input-facebook", plugins_url('/wpdmpp-linked-products/styles/token-input-facebook.css'));
        }

        function wpdm_cal_get_product() {
            $q = esc_attr($_GET['term']);

            $response = array();


            $args = array(
                'post_type' => 'wpdmpro',
                's' => $q,
                'post_status' => 'publish',
                'orderby' => 'title',
                'order' => 'ASC'
            );
            $wp_query = new WP_Query($args);
            $posts = $wp_query->get_posts();

            foreach ($posts as $post) {
                $data['value'] = $post->post_title;
                $data['id'] = $post->ID;
                $response[] = $data;
            }

            header("Content-type: application/json");

            echo json_encode($response);
            die();
        }

        function my_the_content_filter($content) {
            if (is_single()) {
                if (get_post_type() == 'wpdmpro') {
                    return $content . $this->upsellHTML();
                }
            }
            return $content;
        }

        function fetch_template_tag($vars)
        {

            $vars['upsell_items'] = $this->upsellHTML(array('id' => $vars['ID']));
            $vars['grouped_items'] = $this->groupingHTML(array('id' => $vars['ID']));
            return $vars;
        }

        function template_editor_menu(){
            ?>
            <li class="dropdown">
                <a href="#" id="linkedp" role="button" class="dropdown-toggle" data-toggle="dropdown">Linked Products <b class="caret"></b></a>
                <ul class="dropdown-menu" role="menu" aria-labelledby="linkedp">
                    <li role="presentation"><a role="menuitem" tabindex="-1" href="#[upsell_items]">Up sell Items</a></li>
                    <li role="presentation"><a role="menuitem" tabindex="-1" href="#[grouped_items]">Grouped items</a></li>
                </ul>
            </li>

            <?php
        }



    }

    new WPDMPP_LinkedProducts();
}
