<?php

if (!defined("ABSPATH")) die();
$active = 0;
?>
<div class="w3eden">
    <ul class="nav nav-tabs pl-0 ml-0">
        <?php
        foreach ($subscriptions as $index => $subscription) {
            $plan = $subscription->getPlan();
            if ($plan) {
                $active++;
                ?>
                <li class="nav-item">
                    <a class="nav-item nav-link  <?= $active === 1 ? 'active' : '' ?>"
                       href="#sub_<?= $subscription->getId(); ?>" data-toggle="tab" role="tab"
                       aria-controls="sub_<?= $subscription->getId(); ?>" aria-selected="true">
                        <strong><?= $plan->getName(); ?></strong>
                    </a>
                </li>
                <?php
            }
        } ?>
        <li class="nav-item">
            <a class="nav-item nav-link" href="#sub_new" data-toggle="tab" role="tab" aria-controls="sub_new"
               aria-selected="true">
                <i class="fa fa-plus-circle"></i>
            </a>
        </li>
    </ul>
    <div class="tab-content mt-3" id="nav-tabContent">
        <?php
        $active = 0;
        foreach ($subscriptions as $index => $subscription) {
            $plan = $subscription->getPlan();
            if ($plan) {
                $active++;
                ?>
                <div id="sub_<?= $subscription->getId(); ?>"
                     class="tab-pane fade show <?= $active === 1 ? 'active' : '' ?>">
                    <div class="row">
                        <div class="col-md-4">
                            <div class="panel panel-default card dashboard-panel">
                                <div class="panel-heading card-header bg-white">
                                    <?php _e('Subscription', WPPM_TEXTDOMAIN); ?>
                                    <?php //echo $subscription->getSubscriptionStatus()
                                    ?>
                                </div>
                                <div class="panel-body card-body">
                                    <div class="d-flex">
                                        <h3 class="m-0 p-0 text-primary"
                                            style="width: 100%"><?= $plan->getName(); ?></h3>
                                        <div>
                                            <a class="wppm-cancel-subscription text-danger ttip"
                                               onclick="return confirm('Are you sure?')"
                                               href="<?= $subscription->getCancelUrl() ?>"
                                               title="<?php _e('Cancel Subscription', WPPM_TEXTDOMAIN); ?>">
                                                <i class="fa fa-times-circle"></i>
                                            </a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="panel panel-default card dashboard-panel">
                                <div class="panel-heading card-header bg-white"><?php _e("Membership Fee", WPPM_TEXTDOMAIN); ?></div>
                                <div class="panel-body card-body">
                                    <h3 class="text-info m-0 p-0">
                                        <?= $subscription->getPlan()->getBillingText(); ?>
                                    </h3>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="panel panel-default card dashboard-panel">
                                <div class="panel-heading card-header bg-white"><?php _e('Next Billing Cycle', WPPM_TEXTDOMAIN); ?></div>
                                <div class="panel-body card-body">
                                    <h3 class="text-success m-0 p-0">
                                        <?= $subscription->getFormattedExpiresDate(); ?>
                                    </h3>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="card mt-3">
                        <div class="card-header bg-white"><?php _e('Payment History', WPPM_TEXTDOMAIN); ?></div>
                        <table class="table table-striped m-0">
                            <thead>
                            <tr>
                                <th><?php _e('Payment System', WPPM_TEXTDOMAIN); ?></th>
                                <th><?php _e('Payment Date', WPPM_TEXTDOMAIN); ?></th>
                                <th><?php _e('Invoice ID', WPPM_TEXTDOMAIN); ?></th>
                                <th><?php _e('Amount', WPPM_TEXTDOMAIN); ?></th>
                                <th><?php _e('Invoice', WPPM_TEXTDOMAIN); ?></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php foreach ($subscription->getInvoices() as $invoice) : ?>
                                <tr>
                                    <td><?= $invoice->getPaymentSystemId() ?></td>
                                    <td><?= $invoice->getCreatedAt() ?></td>
                                    <td><?= $invoice->getPaymentSystemInvoiceId() ?></td>
                                    <td>
                                        <?= $invoice->getAmount(); ?>
                                        <?= $invoice->getCurrencyCode(); ?>
                                    </td>
                                    <td>
                                        <?php if (method_exists($invoice->getParser(), 'getInvoiceUrl')) : ?>
                                            <a target="_blank" href="<?= $invoice->getParser()->getInvoiceUrl() ?>">
                                                <i class="fa fa-link"></i> Invoice
                                            </a>
                                        <?php endif; ?>
                                    </td>
                                </tr>
                            <?php endforeach; ?>
                            </tbody>
                        </table>
                    </div>


                    <?php do_action('wpmp-membeship-account-page', $subscription); ?>
                </div>
            <?php }
        } ?>
        <div id="sub_new" class="tab-pane fade show">
            <?php
            WPPM()->checkout_manager->renderCheckout();
            //$page = get_post(26282);
            //echo do_shortcode(wpautop($page->post_content));
            ?>
        </div>
    </div>
</div>
