<?php
if(!defined('ABSPATH')) exit;

global $wpdb, $current_user;
$user_download_count = $download_limit = 0;
if (!is_user_logged_in()) {
    echo WPDM()->user->login->form();
} else {

    if(class_exists('\WPDM\AddOn\DownloadLimit')) {
        ?>

        <div class="panel panel-default dashboard-panel">
            <div class="panel-heading"><?php _e('Download Limit', 'wppromembership'); ?></div>
            <div class="panel-body">
                <?php

                $download_limit = WPPM()->user_manager->downloadLimit();
                $time = get_user_meta($current_user->ID, 'wpdm_reset_time', true);

                if ($download_limit > 0):
                    $user_download_count = (int)get_user_meta($current_user->ID, 'wpdm_dd_user_dlc', true);
                    $progress = ($user_download_count / $download_limit) * 100;
                    $bar_color = $progress < 70 ? 'success' : 'warning';
                    ?>

                    <div class="progress" style="margin: 0;height: 31px;line-height: 31px;">
                        <div title="<?php echo $progress; ?>% Used"
                             class="progress-bar progress-bar-<?php echo $bar_color; ?> progress-bar-striped"
                             role="progressbar" aria-valuenow="<?php echo $progress; ?>" aria-valuemin="0"
                             aria-valuemax="100"
                             style="width:<?php echo $progress; ?>%;line-height: 31px;font-size: 13px;overflow: visible">
                        </div>
                    </div>

                    <style>
                        .progress::after {
                            color: rgba(0, 0, 0, 0.3);
                            content: "<?php echo $progress; ?>% used ( <?php echo $user_download_count; ?> of <?php echo $download_limit; ?> )";
                            font-family: Montserrat, sans-serif;
                            font-size: 12px;
                            left: 0;
                            position: absolute;
                            text-align: center;
                            text-transform: uppercase;
                            width: 100%;
                        }

                        .label {
                            font-family: monospace;
                            border-radius: 1px !important;
                            padding: 5px 8px !important;
                            display: inline-block !important;
                            font-weight: bold;
                            font-size: 12pt !important;
                        }
                    </style>
                <?php endif; ?>
            </div>
        </div>
        <?php if (($user_download_count >= $download_limit && $download_limit > 0)) { ?>
            <div class="panel panel-danger">
                <div class="panel-heading"><?php _e('Limit Over', 'wppromembership'); ?></div>
                <div class="panel-body text-center" id="wpdm-dl-timer-x">
                    <?php _e('Please wait for', 'wppromembership'); ?> <span id="wpdm-dl-timer"></span> <?php _e('to download again.', 'wppromembership'); ?>
                </div>
            </div>

            <script>
                // Set the date we're counting down to
                var countDownDate = <?php echo $time * 1000; ?>; //new Date("Jan 6, 2019 15:37:25").getTime();

                // Update the count down every 1 second
                var x = setInterval(function () {

                    // Get todays date and time
                    var now = new Date().getTime();

                    // Find the distance between now and the count down date
                    var distance = countDownDate - now;

                    // Time calculations for days, hours, minutes and seconds
                    var days = Math.floor(distance / (1000 * 60 * 60 * 24));
                    if ((days + "").length < 2) days = "0" + days;
                    var hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
                    if ((hours + "").length < 2) hours = "0" + hours;
                    var minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
                    if ((minutes + "").length < 2) minutes = "0" + minutes;
                    var seconds = Math.floor((distance % (1000 * 60)) / 1000);
                    if ((seconds + "").length < 2) seconds = "0" + seconds;

                    // Output the result in an element with id="demo"
                    document.getElementById("wpdm-dl-timer").innerHTML = "<span class='label label-warning'>" + days + " days</span> <span class='label label-primary'>" + hours + " hours</span> <span class='label label-info'>"
                        + minutes + " minutes</span> <span class='label label-success'>" + seconds + " seconds</span>";

                    // If the count down is over, write some text
                    if (distance < 0) {
                        clearInterval(x);
                        document.getElementById("wpdm-dl-timer-x").innerHTML = "Download link should be active by now, please refresh this page";
                    }
                }, 1000);
            </script>
        <?php }
    }
    ?>

    <div class="panel panel-default dashboard-panel card">
        <div class="panel-heading card-header"><?php _e('Membership Items', 'wppromembership'); ?></div>
        <div class="panel-body card-body p-0">

            <?php

            //$subs = $wppmuser->getSubscriptions();
            $subs = WPPM()->subscription_manager->getActiveSubscriptionsOfCurrentUser();

            if (count($subs) > 0) {


                if (count($subs) > 1) $args['meta_query']['relation'] = 'OR';

                $cat = (isset($_REQUEST['download-cat']) && $_REQUEST['download-cat'] != '0') ? $_REQUEST['download-cat'] : '';



                $allcats = $cposts = $allpacks = array();
                $args = array('post_type' => 'wpdmpro',
                    'posts_per_page' => -1);
                foreach ($subs as $sub){
                    $plan = $sub->getPlan();
                    if($plan) {
                        $role = $plan->getRoleId();
                        //$allcats += $role->categories;
                        $args['meta_query'][] = array(
                            'key' => '__wpdm_access',
                            'value' => $role,
                            'compare' => 'LIKE',
                        );
                    }
                }

                if(count($args['meta_query']) > 1){
                    $args['meta_query']['relation'] = 'OR';
                }

                if ($cat != '') {
                    $args['tax_query'] = array(
                        array(
                            'taxonomy' => 'wpdmcategory',
                            'field' => 'term_id',
                            'terms' => $cat,
                        )
                    );
                } else {
                    $xargs = array('post_type' => 'wpdmpro',
                        'posts_per_page' => -1);
                    $xargs['tax_query'] = array(
                        'relation' => 'OR',
                        array(
                            'taxonomy' => 'wpdmcategory',
                            'field' => 'term_id',
                            'terms' => $allcats,
                        )
                    );
                    $cposts = get_posts($xargs);
                }

                $posts = get_posts($args);

                foreach ($posts as $post){
                    $allpacks[$post->ID] = $post;
                }
                foreach ($cposts as $post){
                    $allpacks[$post->ID] = $post;
                }


                ?>

                <!--label><?php _e('Category Filter', 'wppromembership'); ?></label>
                <form method="post" action="" id="dl-cat-filter">
                    <?php
                    wp_dropdown_categories(
                        array(
                            'show_option_all' => 'All',
                            'taxonomy' => 'wpdmcategory',
                            'class' => 'dl-cats',
                            'name' => 'download-cat',
                            'selected' => $cat
                        )
                    );
                    ?>
                </form>
            <br/ -->

            <?php
            if (count($allpacks) > 0): ?>
                <table id="wpmp_invoice_table" class="wpmp_invoice table table-striped" style="margin: 0">
                    <thead>
                    <tr>
                        <th><?php _e('Name', 'wppromembership'); ?></th>
                        <th class="text-right"><?php _e('Download', 'wppromembership'); ?></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php foreach ($allpacks as $pack):  ?>
                        <tr>
                            <td><a href='<?php echo get_permalink($pack->ID); ?>'><?php echo $pack->post_title; ?></a></td>
                            <td class="text-right">
                                <?php
                                $ppp = get_the_terms($pack->ID, 'wpdmcategory');
                                if (!empty($ppp)) {
                                    foreach ($ppp as $a => $b) {
                                        $ppp_id = $b->term_id;
                                    }
                                }

                                $download_link = home_url("/?wppmdl=" . $pack->ID);
                                if(!class_exists('\WPDM\AddOn\DownloadLimit') || ($user_download_count < $download_limit && $download_limit > 0)){
                                    ?>
                                    <a href='<?php echo $download_link; ?>' class='btn btn-success btn-xs'><i class="fas fa-users"></i> <?php _e('Download', 'wppromembership'); ?></a>
                                <?php } else { ?>

                                <?php } ?>
                            </td>
                        </tr>
                    <?php endforeach;
                    wp_reset_postdata(); ?>
                    </tbody>
                </table>
            <?php endif; ?>

                <script>
                    jQuery('.dl-cats').on('change', function () {
                        jQuery('#dl-cat-filter').submit();
                    });
                    jQuery('#download-cat').chosen({width:'250px'});
                </script>
            <?php }else{
            ?>
                <div class="alert alert-info"><?php _e('You do not have any active plan. Choose one from available plans.', 'wppromembership'); ?></div>
                <?php
            } ?>

        </div>
    </div>


    <?php
}
