<?php

use WPDM\Form\Form;

$reg_data_fields['name'] = [
    'cols' => [
        [
            'label' => __("First name", "download-manager"),
            'type' => 'text',
            'grid_class' => 'col-md-6 col-sm-12',
            'attrs' => [
                'name' => WPPM_SIGNUP_FORM_DATA_KEY . '[first_name]',
                'id' => 'wppm_first_name',
                'placeholder' => 'Your First Name',
                'required' => 'required'
            ]
        ],
        [
            'label' => __("Last name", "download-manager"),
            'type' => 'text',
            'grid_class' => 'col-md-6 col-sm-12',
            'attrs' => [
                'name' => WPPM_SIGNUP_FORM_DATA_KEY . '[last_name]',
                'id' => 'wppm_last_name',
                'placeholder' => 'Your Last Name',
                'required' => 'required'
            ]
        ]
    ],
    'note' => 'Your full name'
];

$reg_data_fields['username'] = array(
    'label' => __("Username", "download-manager"),
    'type'  => 'text',
    'attrs' => array(
        'name' => WPPM_SIGNUP_FORM_DATA_KEY . '[user_login]',
        'id' => 'wppm_user_login',
        'placeholder' => 'User Login ID',
        'required' => 'required'
    ),
    'note'  => 'Enter a valid email address'
);

$reg_data_fields['email'] = [
    'label' => __("Email", "download-manager"),
    'type'  => 'email',
    'attrs' => [
        'name' => WPPM_SIGNUP_FORM_DATA_KEY . '[user_email]',
        'id' => 'wppm_user_email',
        'placeholder' => 'Your Email Address',
        'required' => 'required'
    ],
    'note'  => 'Enter a valid email address'
];

$reg_data_fields['password'] = array(
    'cols' => [
        [
            'label' => __("Password", "download-manager"),
            'type' => 'password',
            'grid_class' => 'col-md-6 col-sm-12',
            'attrs' => [
                'name' => WPPM_SIGNUP_FORM_DATA_KEY . '[user_pass]',
                'id' => 'wppm_password',
                'placeholder' => 'Be Secure',
                'required' => 'required'
            ]
        ],
        [
            'label' => __("Confirm Password", "download-manager"),
            'type' => 'password',
            'grid_class' => 'col-md-6 col-sm-12',
            'attrs' => [
                'name' => 'confirm_user_pass',
                'confirm' => 'last',
                'id' => 'wppm_confirm_pass',
                'placeholder' => 'Do Not Forget',
                'required' => 'required'
            ]
        ]
    ]
);

$form = new Form(
    $reg_data_fields,
    ['name' => 'wppm_signup_form', 'id' => 'wppm_signup_form', 'method' => 'POST', 'action' => '', 'submit_button' => [], 'noForm' => true]
);

echo $form->render();

?>
<?php do_action("register_form"); ?>
<?php do_action("wpdm_register_form"); ?>
