<?php

namespace WPDM\WPPM\Checkout;


if (!defined('ABSPATH')) exit;



class CheckoutManager
{
    /**
     * holds singleton instance of the class
     */
    private static $instance;

    /**
     * Get singleton instance of the class
     *
     */
    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }


    /**
     * Constructor
     *
     */
    private function __construct()
    {
        $this->addHooks();
    }


    /**
     * add hooks
     */
    public function addHooks()
    {
    }


    /**
     * Render the checkout page
     *
     */
    public function renderCheckout()
    {
        $args = [];
        $file = wpdm_tpl_path("checkout.php",  get_stylesheet_directory() . '/wppromembership', __DIR__.'/');
        wppm_render_template($file, $args);
    }
}
