<?php
if (!defined("ABSPATH")) die('');

?>


<div class="wrap w3eden">
    <div id="wpdm-wrapper-panel" class="panel panel-default">
        <div class="panel-heading">
            <button id="saveformbtn" style="margin-right: 0" type="button" class="btn btn-primary pull-right" data-toggle="modal" data-target="#modal">
                <i class="fa fa-plus" style="margin-right: 5px"></i> Add New Coupon
            </button>
            <b><i class="fa fa-tags" style="margin-right: 5px"></i> <?php _e('Coupons', WPPM_TEXTDOMAIN); ?></b>
        </div>

        <div class="panel-body-np" style="padding-right: 20px">
            <table class="table table-striped table-hover" style="margin-top: 80px">
                <thead>
                    <tr class="thead">
                        <th style="width: 50px;text-align: center"><?php _e('ID', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Coupon Code', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Discount', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Applicable Plans', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Description', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Usage', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Created At', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Expires At', WPPM_TEXTDOMAIN) ?></th>
                        <th class="text-right"><?php _e('Action', WPPM_TEXTDOMAIN) ?></th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($coupons as $coupon) : //pd($coupon); 
                    ?>

                        <tr class="thead">
                            <td class="text-center">
                                <?= $coupon->getId(); ?>
                            </td>

                            <td>
                                <strong><?= $coupon->getCode(); ?></strong>
                            </td>

                            <td>
                                <h4><?= $coupon->getDiscountText(); ?></h4>
                            </td>

                            <td>
                                <strong> <?= $coupon->getApplicablePlanNames() ?> </strong>
                            </td>

                            <td>
                                <?= $coupon->getDescription() ?: '--'; ?>
                            </td>


                            <td><?= $coupon->getUsageText() ?></td>

                            <td><?= wp_date(get_option('date_format'), $coupon->getCreatedAt()->getTimestamp()); ?></td>

                            <td><?= $coupon->getExpiresAt() ? wp_date(get_option('date_format'), $coupon->getExpiresAt()->getTimestamp()) : 'NEVER'; ?></td>

                            <td class="text-right">
                                <a href="<?= add_query_arg(['action' => 'DELETE_COUPON', 'coupon_id' => $coupon->getId()]) ?>" onclick="return confirm('You cannot undo the action, Are you sure delete this coupon?')" class="btn btn-info">
                                    <?php _e('Delete', WPPM_TEXTDOMAIN) ?>
                                </a>
                            </td>
                        </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        </div>
    </div>

    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <form name="user-plans" method="POST" action="">

                <div class="modal-content">
                    <input type="hidden" name="wppm_coupon_nonce" value="<?= wp_create_nonce() ?>" />
                    <!-- header -->
                    <div class="modal-header">
                        <button type="button" class="close pull-right" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true"><i class="fa fa-times-circle"></i></span>
                        </button>
                        <strong class="modal-title">Add New Coupon</strong>
                    </div>

                    <!-- Coupon Form -->
                    <div class="modal-body">
                        <div class="row">
                            <!-- Code -->
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label><?php _e('Coupon Code:', WPPM_TEXTDOMAIN); ?> <span class="color-red">*</span></label>
                                    <input required class="form-control" type="text" required="required" name="coupon[code]" placeholder="Coupon Code. eg CODE25" value="">
                                    <!-- <span class="input-group-addon color-green" style="width: 40px;font-weight: bold" id="dtp">%</span> -->
                                </div>
                            </div>

                            <!-- discount amount -->
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label><?php _e('Discount Amount:', WPPM_TEXTDOMAIN); ?> <span class="color-red">*</span></label>
                                    <input class="form-control" type="number" required="required" name="coupon[discount_amount]" placeholder="e.g. 25" value="">
                                    <!-- <span class="input-group-addon color-green" style="width: 40px;font-weight: bold" id="dtp">%</span> -->
                                </div>
                            </div>

                            <!-- discount type -->
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label><?php _e('Discount Type:', WPPM_TEXTDOMAIN); ?></label>
                                    <select name="coupon[discount_type]" id="dtypes" class="form-control wpdm-custom-select">
                                        <option value="PERCENT">
                                            <?php _e('Percent', WPPM_TEXTDOMAIN); ?> (%)
                                        </option>
                                        <option value="FIXED">
                                            <?php _e('Fixed', WPPM_TEXTDOMAIN); ?> (<?php echo wpdmpp_currency_sign(); ?>)
                                        </option>
                                    </select>
                                </div>
                            </div>

                            <!-- Expires at -->
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label><?php _e('Expire Date:', WPPM_TEXTDOMAIN); ?></label>
                                    <input class="form-control" style="padding: 0 15px" placeholder="Never" id="expires-at" type="date" name="coupon[expires_at]" value="" />
                                </div>
                            </div>

                            <!-- usage limit -->
                            <div class="col-md-6">
                                <div class="form-group">
                                    <label><?php _e('Usage Limit:', WPPM_TEXTDOMAIN); ?></label>
                                    <input class="form-control" placeholder="0 = Unlimited" type="number" name="coupon[usage_limit]" value="" />
                                </div>
                            </div>

                            <!-- Applicable Plans -->
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label><?= __("Applicable In Plans", WPPM_TEXTDOMAIN); ?>: <small class="color-green">(Keep Empty for All)</small></label>
                                    <select id="plan-ids" name="coupon[plan_ids][]" multiple class="selectpicker form-control " placeholder="select plans">
                                        <?php foreach ($plans as $plan) : ?>
                                            <option value="<?= $plan->getId() ?>"> <?= $plan->getName() ?></option>
                                        <?php endforeach; ?>
                                    </select>
                                </div>
                            </div>


                            <!-- Description -->
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label><?php _e('Description:', WPPM_TEXTDOMAIN); ?></label>
                                    <textarea class="form-control" rows="4" name="coupon[description]" placeholder="Coupon Description"></textarea>
                                </div>
                            </div>

                        </div>

                    </div>

                    <!-- Footer -->
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </div>

                </div>
            </form>

        </div>
    </div>
</div>

<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.13.1/css/bootstrap-select.css" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.13.1/js/bootstrap-select.min.js"></script>

<script>
    jQuery(function($) {
        $('#plan-ids').selectpicker();
    });
</script>