<?php

namespace WPDM\WPPM\Cron;


if (!defined('ABSPATH')) exit;

class CronManager
{
    /**
     * holds singleton instance of the class
     */
    private static $instance;

    /**
     * Get singleton instance of the class
     * 
     */
    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }


    /**
     * Constructor 
     * 
     */
    private function __construct()
    {
    }


    /**
     * 
     * 
     */
    public function scheduleCronEvents()
    {
        if (!wp_next_scheduled(WPPM_EVENT_SEND_SUBSCRIPTION_EXPIRATION_REMINDERS)) {

            wp_schedule_event(time(), 'twicedaily', WPPM_EVENT_SEND_SUBSCRIPTION_EXPIRATION_REMINDERS);
        }
    }


    /**
     * 
     * 
     */
    public function clearCronEvents()
    {
        wp_clear_scheduled_hook(WPPM_EVENT_SEND_SUBSCRIPTION_EXPIRATION_REMINDERS);
    }
}
