<?php

namespace WPDM\WPPM\Invoice;

if (!defined('ABSPATH')) exit;




class InvoiceManager
{

    /**
     * holds singleton instance of the class
     */
    private static $instance;


    /**
     * get the singleton instance of the class
     */
    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }

        return self::$instance;
    }


    /**
     * private constructor of the class
     * so this class cannot be created outside
     * 
     */
    private function __construct()
    {
    }


    /**
     * 
     * @return string
     */
    public static function getTableName()
    {
        global $wpdb;
        return $wpdb->prefix . 'wppm_invoices';
    }


    /**
     * 
     * 
     * @return double
     */
    public function sumAmount(InvoiceFilter $filter = null)
    {
        global $wpdb;
        $table_name =  self::getTableName();

        $query = "SELECT SUM(amount) FROM {$table_name} WHERE 1 ";

        if ($filter) {

            if ($filter->getFromDate()) {
                $query  .= " AND `created_at` >= '{$filter->getFromDate()->format('Y-m-d H:m:i')}' ";
            }

            if ($filter->getToDate()) {
                $query  .= " AND `created_at` <= '{$filter->getToDate()->format('Y-m-d H:m:i')}' ";
            }
        }


        $amount = $wpdb->get_var($query) ?: 0;

        return number_format($amount, 2);
    }
}
