<?php

namespace WPDM\WPPM\Payment\Manual;

use WPDM\WPPM\Payment\PaymentSystem;
use WPDM\WPPM\Plan\Plan;
use WPDM\WPPM\Subscription\Subscription;

if (!defined('ABSPATH')) exit;



/**
 * This payment system is used to pay the Free plan payment
 * 
 * 
 */
class ManualPaymentSystem extends PaymentSystem
{
    /**
     * holds singleton instance of the class
     */
    private static $instance;

    /**
     * payment system id
     */
    public $payment_system_id = "manual";

    /**
     * payment system name
     */
    public $payment_system_name = "Manual Pay";

    /**
     * Get singleton instance of the class
     * 
     */
    public static function getInstance()
    {
        if (self::$instance === null) {
            self::$instance = new self;
        }
        return self::$instance;
    }


    /**
     * Constructor 
     * 
     */
    protected function __construct()
    {
        parent::__construct();
        $this->addHooks();
    }


    private function addHooks()
    {
    }


    /**
     * Should the payment system show in settings
     * 
     * @return boolean
     */
    public function showInSettings()
    {
        return false;
    }


    /**
     * Render payment interface
     * 
     */
    function renderPaymentInterface(Plan $plan)
    {
        return false;
    }


    /**
     * Renders settings in global payment settings
     * 
     */
    public function renderSettings()
    {
        echo 'No Settings.';
    }


    public function processSubscription(Subscription $subscription)
    {
    }

}
