<?php

namespace WPDM\WPPM\Payment\PayPal;

use WPDM\WPPM\Invoice\InvoiceParser;

class PayPalInvoiceParser extends InvoiceParser
{
    /**
     *
     * @return double|null
     */
    public function getAmount()
    {
        $amount = wpdm_valueof($this->_data, 'amount/value');
        return number_format((double)$amount, 2);
    }


    /**
     *
     * @return string|null
     */
    public function getCurrencyCode()
    {
        return wpdm_valueof($this->_data, 'amount/currency_code');
    }


    /**
     *
     * @return int|null
     */
    public function getPaymentDate()
    {
        $date = wpdm_valueof($this->_data, 'time');
        return strtotime($date);
    }
}
