<?php

namespace WPDM\WPPM\Payment\PayPal;

use WPDM\WPPM\Subscription\SubscriptionParser;

class PayPalSubscriptionParser extends SubscriptionParser
{

    /**
     * 
     * @return int|null
     */
    public function getCurrentPeriodEndTime()
    {
        return $this->getNextBillingTime();
    }


    /**
     * 
     * @return int|null
     */
    public function getNextBillingTime()
    {
        $next_billing_time =  wpdm_valueof($this->_data, 'billing_info/next_billing_time');
        return strtotime($next_billing_time);
    }

    /**
     * 
     * @return enum 
     */
    public function getStatus()
    {
        return wpdm_valueof($this->_data, 'status');
    }

    /**
     * 
     * @return obj
     */
    public function getLastPaymentData()
    {
        return wpdm_valueof($this->_data, 'billing_info/last_payment');
    }
}
