<?php
if (empty($paypal_plan_id)) {
    echo '<div class="alert alert-danger">'.esc_attr__( 'No Paypal Plan Id found for the selected plan. Please contact system admin.', WPPM_TEXTDOMAIN ).'</div>';
    exit;
}
?>

<div id="paypal-button-container"></div>

<script>
    jQuery(function($) {
        function renderPaypalButton() {
            if(paypal !== undefined) {
                paypal.Buttons({

                    style: {
                        layout: 'horizontal',  /* horizontal | vertical */
                        size: 'medium',    /* medium | large | responsive  */
                        shape: 'rect',      /* pill | rect  */
                        color: 'blue',       /* gold | blue | silver | white | black  */
                        tagline: false
                    },


                    funding: {
                        allowed: [
                            paypal.FUNDING.CARD

                        ],
                        disallowed: [paypal.FUNDING.CREDIT]
                    },


                    createSubscription: function(data, actions) {

                        return actions.subscription.create({

                            'plan_id': "<?= $paypal_plan_id ?>"

                        });

                    },


                    onApprove: function(data, actions) {
                        console.log("paypal payment data", data);
                        var postUrl = "<?= add_query_arg('action', WPPM_AJAX_ACTION_PROCESS_SUBSCRIPTION, admin_url('admin-ajax.php')); ?>";
                        var postData = {
                            'payment_system_id': "<?= $payment_system_id ?>",
                            'plan_id': "<?= $wppm_plan_id ?>",
                            'payment_system_subscription_data': data
                        };

                        WPDM.blockUI('#checkout-form');
                        jQuery.post(postUrl, postData, function(res) {
                            WPDM.unblockUI('#checkout-form');
                            redirectToWPPMAccountPage();
                        }, 'json')
                            .fail(function(res) {
                                console.log(res);
                            });

                    }


                }).render('#paypal-button-container');
            }
            else
                setTimeout("renderPaypalButton", 1000);
        }

        renderPaypalButton();
    })
</script>
