<?php

namespace WPDM\WPPM\Payment\Stripe;

use WPDM\WPPM\Invoice\InvoiceParser;

class StripeInvoiceParser extends InvoiceParser
{

    /**
     * 
     * @return int|null
     */
    public function getPaymentDate()
    {
        $created =  wpdm_valueof($this->_data, 'created');
        return $created;
    }


    /**
     * 
     * @return double|null
     */
    public function getAmount()
    {
        $amount_paid =  wpdm_valueof($this->_data, 'amount_paid');
        return number_format($amount_paid / 100, 2);
    }


    /**
     * 
     * @return string|null
     */
    public function getCurrencyCode()
    {
        return wpdm_valueof($this->_data, 'currency');
    }


    /**
     * 
     * @return url|null
     */
    public function getInvoiceUrl()
    {
        return wpdm_valueof($this->_data, 'hosted_invoice_url');
    }


    /**
     * 
     * @return url|null
     */
    public function getInvoicePDFUrl()
    {
        return wpdm_valueof($this->_data, 'invoice_pdf');
    }
}
