<?php

namespace WPDM\WPPM\Payment\Stripe;

use WPDM\WPPM\Subscription\SubscriptionParser;

class StripeSubscriptionParser extends SubscriptionParser
{

    /**
     * 
     * @return int|null
     */
    public function getNextBillingTime()
    {
        return $this->getCurrentPeriodEndTime();
    }


    /**
     * 
     * @return int|null
     */
    public function getCurrentPeriodEndTime()
    {
        $current_period_end =  wpdm_valueof($this->_data, 'current_period_end');
        return intval($current_period_end);
    }

    /**
     * 
     * @return enum 
     */
    public function getStatus()
    {
    }

    /**
     * 
     * @return array
     */
    public function getLastPaymentData()
    {
        return wpdm_valueof($this->_data, 'latest_invoice');
    }
}
