<form id="stripe-subscription-form">
    <button type="button" id="stripe-checkout-btn" class="btn btn-primary btn-lg btn-block">
        <?php echo apply_filters('wppm_stripe_sub_button_label', 'Pay With Stripe') ?>\
    </button>
    <!-- We'll put the error messages in this element -->
    <div id="stripe-errors" role="alert"></div>
</form>

<script>
    var stripe = Stripe("<?= $publishable_key ?>");
    var checkoutSessionId = "<?= $checkout_session_id ?>";

    var checkoutButton = document.getElementById('stripe-checkout-btn');

    checkoutButton.addEventListener('click', function() {
        stripe.redirectToCheckout({
            sessionId: checkoutSessionId

        }).then(function(result) {
            console.log(result);

            if (result.error) {
                showError(result.error.message);
            }
            // If `redirectToCheckout` fails due to a browser or network
            // error, display the localized error message to your customer
            // using `result.error.message`.
        });
    });

    function showError(message) {
        var displayError = document.getElementById('stripe-errors');
        if (message) {
            displayError.textContent = message;
        } else {
            displayError.textContent = '';
        }
    }
</script>