<?php

namespace WPDM\WPPM\Payment;


abstract class WebhookManager
{
    abstract protected function createWebhook($webhook_url);

    abstract protected function updateWebhook($webhook_id, $webhook_url);

    abstract protected function webhookExists($webhook_id);


    public function __construct(&$payment_system)
    {
        $this->payment_system = &$payment_system;
    }


    /**
     * Create or Update Paypal webhook
     * 
     * @return WebhookSettings
     */
    public function saveWebhook($webhook_settings, $force_update = false)
    {
        //web hook url changed so save it
        if (empty($webhook_settings['id']) || ($force_update && !$this->webhookExists($webhook_settings['id']))) {
            //create new webhook
            $webhook = $this->createWebhook($webhook_settings['url']);
        } else {
            //update the old webhook
            $webhook = $this->updateWebhook($webhook_settings['id'], $webhook_settings['url']);
        }

        return $webhook_settings = [
            'id' => $webhook->id,
            'url' => $webhook->url
        ];
    }
}
