<div style="border: 1px solid #dadada;background: #f6f6f6;border-radius: 8px;overflow: hidden;display: flex;margin-bottom: 30px;height: 100%">
    <input type="hidden" name="action" value="<?= WPPM_AJAX_ACTION_SAVE_PAYMENT_SYSTEMS_SETTINGS; ?>" />
    <!-- Tabs -->
    <div class="col-md-3">
        <ul class="nav nav-pills" role="tablist" id="payment-systems-tabs" style="margin-top: 15px">
            <?php

            use WPDM\WPPM\Payment\RemotePaymentSystem;

            foreach ($payment_systems as $i => $payment_system) : ?>
                <!-- tab -->
                <li role="presentation" class="dblock">
                    <a href="#<?= $payment_system->getPaymentSystemId() ?>" role="tab" data-toggle="pill" aria-controls="<?= $payment_system->getPaymentSystemId(); ?>">
                        <?= $payment_system->getPaymentSystemName(); ?>
                    </a>
                </li>

            <?php endforeach; ?>
        </ul>
    </div>

    <!-- Tab Content -->
    <div class="col-md-9" style="border-left: 1px solid #dadada;background: #ffffff;height: 100%;overflow: auto">
        <div class="tab-content" style="padding: 20px;">
            <input type="hidden" name="<?= WPPM_PAYMENT_SYSTEMS_SETTINGS_NONCE ?>" value="<?= wp_create_nonce(); ?>" />

            <?php foreach ($payment_systems as $i => $payment_system) : ?>
                <div role="tabpanel" class="tab-pane" id="<?= $payment_system->getPaymentSystemId(); ?>">
                    <!-- Common fields -->

                    <!-- Enable Checkbox -->
                    <div class="form-group">
                        <label>
                            <input type="hidden" name="<?= $payment_system->getSettingsFormKey() ?>[enabled]" value=0 />
                            <input type="checkbox" value="1" <?= checked(true, $payment_system->isEnabled()); ?> name="<?= $payment_system->getSettingsFormKey() ?>[enabled]">
                            <?= sprintf(__("Enable %s", "wppromembership"), $payment_system->getPaymentSystemName()); ?>
                        </label>
                    </div>

                    <?php if ($payment_system instanceof RemotePaymentSystem) : ?>

                        <?php if ($payment_system->apiConnected()) : ?>
                            <div class="alert alert-success">
                                You are connected to the <?= $payment_system->getPaymentSystemName() . ' ' . $payment_system->getModeName(); ?> API
                            </div>
                        <?php else : ?>
                            <div class="alert alert-danger">
                                You are not connected to the <?= $payment_system->getPaymentSystemName() . ' ' . $payment_system->getModeName() ?> API.
                                <br>Please Check the <?= $payment_system->getModeName() ?> Settings again.
                            </div>
                        <?php endif; ?>

                        <div class="form-group">
                            <label><?= __("Current Mode", WPPM_TEXTDOMAIN) ?></label>
                            <select name="<?= $payment_system->getSettingsFormKey() ?>[mode]" class="form-control " style="width: 100%; min-width: 150px;">
                                <option value>Select A Mode</option>
                                <option value="live" <?= $payment_system->isLiveMode() ? "selected" : "" ?>>Live</option>
                                <option value="test" <?= $payment_system->isTestMode() ? "selected" : "" ?>>Test</option>
                            </select>
                        </div>

                        <div class="form-group">
                            <input type="checkbox" value="1" name="<?= $payment_system->getSettingsFormKey() ?>[force_update_webhook]">
                            <label><?= __("Force Update Webhook", WPPM_TEXTDOMAIN); ?></label>
                        </div>
                    <?php endif; ?>


                    <!-- Payment system Specific fields -->
                    <?= $payment_system->renderSettings() ?>
                </div>
            <?php endforeach; ?>

        </div>
    </div>

</div>


<script>
    jQuery(function($) {
        var activeTabId = location.hash;

        if (activeTabId) {
            $('#payment-systems-tabs a[href="' + activeTabId + '"]').tab('show');
        } else {
            $('#payment-systems-tabs li:first-child a').tab('show') // Select first tab
        }

        $("#payment-systems-tabs a").click(function(e) {
            e.preventDefault();
            location.hash = $(this).attr('href');
        });
    })
</script>


<script>
    /*jQuery(function($) {
        settingsForm = $("#settings-form");
        settingsSaveBtn = $('#save-settings');

        settingsSaveBtn.click(function(e) {
            e.preventDefault();
            settingsSaveBtn.html('<i class="fa fa-spin fa-sun"></i> Please Wait...');
            var postUrl = "<?= add_query_arg('action', WPPM_AJAX_ACTION_SAVE_PAYMENT_SYSTEMS_SETTINGS, admin_url('admin-ajax.php')); ?>";
            var postData = settingsForm.serialize();
            // console.log(settingsForm.serializeArray()); return;

            $.post(postUrl, postData, function(res) {
                    console.log(res);
                    settingsSaveBtn.html('<i class="fa fa-save"></i> <?php _e('Saved!', 'wppromembership'); ?>');
                    if (confirm("Settings Saved")) {
                        location.reload();

                    }
                })
                .fail(function(res) {
                    var data = res.responseJSON;
                    console.log(data);
                    //showErrors(data);
                });
        });

        // $('select').selectpicker({
        //     style: 'btn-default',
        //     liveSearch: true,
        //     size: 10
        // });

    })*/
</script>

<style>
    .w3eden table {
        width: 100%;
    }

    .w3eden table td {
        width: 20%;
        padding: 5px;
    }

    .w3eden tr td:first-child {
        font-weight: bold !important;
    }

    .dblock {
        display: block;
        width: 100%;
        margin: 0 0 5px !important;
    }

    .nav.nav-pills .dblock a {
        background: #ffffff;
        border-radius: 3px !important;
        font-weight: 600;
        letter-spacing: 0.6px;
        border: 1px solid;

    }

    .nav.nav-pills .dblock:not(.active) a {
        border: 1px solid #dddddd;
    }

    .nav.nav-pills .dblock.active a {
        border: 1px solid #0677d3;
    }
</style>