<?php

namespace WPDM\WPPM\Plan;

/**
 * Compares two Plan Object
 * 
 */
class PlanComparator
{
    /**
     * holds updated plan
     */
    private $new_plan;

    /**
     * holds before update plan
     */
    private $old_plan;


    /**
     * constructor
     */
    public function __construct(Plan $new_plan, Plan $old_plan)
    {
        $this->new_plan = $new_plan;
        $this->old_plan = $old_plan;
    }


    /**
     * 
     * @return boolean
     */
    public function initialAmountChanged()
    {
        return $this->new_plan->getInitialAmount() !== $this->old_plan->getInitialAmount();
    }


    /**
     * Return true if REGULAR bulling amount OR TRAIL amount changed
     * 
     * @return boolean
     */
    public function pricingSchemesChanged()
    {
        return $this->billingAmountChanged() || $this->trialAmountChanged();
    }


    /**
     * 
     * @return boolean
     */
    public function billingAmountChanged()
    {
        return $this->new_plan->getBillingAmount() !== $this->old_plan->getBillingAmount();
    }


    /**
     * 
     * @return boolean
     */
    public function trialAmountChanged()
    {
        return $this->new_plan->getTrialAmount() !== $this->old_plan->getTrialAmount();
    }


    /**
     * 
     * @return boolean
     */
    public function hasTrialBefore()
    {
        return $this->old_plan->hasTrial();
    }
}
