<div class="w3eden">


            <!-- initial payment -->
            <div class="form-group">
                <label for="initial_amount"><?php _e('Initial Payment (Setup Fee)', 'wppromembership'); ?></label>
                <div class="input-group">
                    <div class="input-group-addon"><?php echo $currency_symbol ?></div>
                    <input type="text" name="<?= WPPM_PLAN_META_DATA ?>[initial_amount]" size="20" value="<?= $plan->getInitialAmount() ?>" class="form-control" />
                </div>
                <small><?php _e('The initial amount collected ONE TIME ONLY at subscription.', 'wppromembership'); ?></small>
            </div>

            <!-- billing amount -->
            <div class="form-group">
                <label for="billing_amount"><?php _e('Billing Amount', 'wppromembership'); ?></label>
                <div class="input-group">
                    <div class="input-group-addon">
                        <?php echo $currency_symbol ?></div>
                    <input type="text" size="20" name="<?= WPPM_PLAN_META_DATA ?>[billing_amount]" value="<?= $plan->getBillingAmount() ?>" class="form-control" />
                </div>
                <br />

                <label for="billing_period_count"><?php _e('For Every:', 'wppromembership'); ?></label>
                <em class="text-info d-block"><?php _e('Use 0 for lifetime plan', WPPM_TEXTDOMAIN); ?></em>
                <div class="input-group">

                    <!-- for every Cycle number -->
                    <input type="number" placeholder="Period" id="billing_period_count" name="<?= WPPM_PLAN_META_DATA ?>[billing_period_count]" value="<?= $plan->getBillingPeriodCount() ?>" class="form-control" size="10" />

                    <!-- Cycle period -->
                    <div class="input-group-addon" style="padding: 0">
                        <select name="<?= WPPM_PLAN_META_DATA ?>[billing_period]" id="billing_period" style="border: 0;height: 32px;" class="form-control wpdm-custom-select">
                            <?php foreach ($billing_periods as $period) : ?>
                                <option value="<?= $period['id'] ?>" <?= $period['id'] == $plan->getBillingPeriod() ? "selected = 'selected'" : '' ?>>
                                    <?= $period['name'] ?>
                                </option>
                            <?php endforeach ?>
                        </select>
                    </div>
                </div>

                <em class="text-muted">
                    <?php _e('The amount to be billed REGULARLY after the initial payment.', 'wppromembership'); ?><br/>
                </em>
            </div>

            <!-- Billing Limit -->
            <div class="form-group">
                <label for="billing_limit"><?php _e('Billing Cycle Limit', 'wppromembership'); ?></label>
                <input type="number" name="<?= WPPM_PLAN_META_DATA ?>[billing_limit]" value="<?= $plan->getBillingLimit() ?>" id="billing_limit" size="20" class="form-control" />
                <em class="text-muted">
                    <?php _e('The <strong>total</strong> number of recurring billing cycles for this level, including the trial period (if applicable) but not including the initial payment. Set to <strong>0 (zero)</strong> if membership is indefinite.', 'wppromembership'); ?>
                </em>
            </div>

            <!-- Custom trial checkbox -->
            <div class="form-group">
                <input name="custom_trial" type="hidden" value="0" />
                <label class="d-block">
                    <div class="wppm-switch"><input id="custom_trial" name="custom_trial" type="checkbox" value="yes" <?= ($plan->getTrialPeriodCount() > 0) ? 'checked' : '' ?> onclick="jQuery('.trial_info').slideToggle();" /><div class="wppm-slider round"></div></div> <?php _e('Enable Trial', 'wppromembership'); ?>
                </label>
                <br />
            </div>


            <div class="form-group trial_info" <?= !($plan->getTrialPeriodCount() > 0) ? "style='display:none'" : '' ?>>

                <table class="table table-bordered">
                    <!-- Trial amount -->
                    <tr>
                        <td><?php _e('Trial Billing Amount', 'wppromembership'); ?></td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-addon"><?php echo $currency_symbol ?></div>
                                <input type="text" name="<?= WPPM_PLAN_META_DATA ?>[trial_amount]" value="<?= $plan->getTrialAmount() ?>" class="form-control" id="trial_amount" size="20" />
                            </div>
                        </td>
                    </tr>

                    <!-- Trial limit -->
                    <tr>
                        <td><?php _e('For The First', 'wppromembership'); ?></td>
                        <td>
                            <div class="input-group">
                                <input type="number" class="form-control" id="trial_period_count" name="<?= WPPM_PLAN_META_DATA ?>[trial_period_count]" size="10" value="<?= $plan->getTrialPeriodCount() ?>" />
                                <div class="input-group-addon"><?php _e('Days', 'wppromembership'); ?></div>
                            </div>
                        </td>
                    </tr>
                </table>
            </div>

</div>


<script>
    jQuery(function($) {
        if ('<?= $plan->getBillingPeriod(); ?>' === 'LifeTime' || '<?= $plan->getBillingPeriod(); ?>' === '') {
            $('#billing_period_count, #billing_limit').val('1').attr('disabled', 'disabled');
        }
        $('#billing_period').on('change', function() {
            if ($('#billing_period').val() === 'LifeTime') {
                $('#billing_period_count, #billing_limit').val('1').attr('disabled', 'disabled');
            } else
                $('#billing_period_count, #billing_limit').removeAttr('disabled');
        });

        $('#custom_trial').on('click', function() {
            if (!$(this).is(":checked")) {
                $('#trial_period_count').val('');
                $('#trial_amount').val('');
            }
        });

    })
</script>