<?php
if (!defined('ABSPATH')) die();

global $wppm;
?>
<div class="w3eden">
    <div class="row pmpro-plans pmpro-default">
        <?php foreach ($plans as $plan) : ?>

            <?php
            $featured = isset($params['featured']) && $params['featured'] == $plan->id;
            ?>

            <div class="col-md-<?= $cols; ?>">
                <div class="panel card <?= $featured ? 'panel-primary' : 'panel-default'; ?>">

                    <!-- Panel head -->
                    <div class="panel-heading card-header">
                        <div class="plan-name <?= $featured ? 'color-primary' : 'color-default'; ?>">
                            <?= $plan->getName(); ?>
                        </div>
                        <div class="plan-recurring-price  <?= $featured ? 'color-primary' : 'color-default'; ?> ">
                            <?= $plan->getBillingText() ?>
                            <i class="far fa-question-circle text-muted"></i>
                        </div>
                    </div>

                    <!-- Panel body -->
                    <div class="panel-body card-body">
                        <div class='well trail-info'>
                            <?= $plan->getTrialText() ?>
                        </div>

                        <?php if ($show_description) : ?>
                            <div class="plan-desc">
                                <?= $plan->getDescription() ?>
                            </div>
                        <?php endif ?>

                        <ul class="plan-features list-group" style="margin-bottom: 0">
                            <?= $plan->getFeaturesAsLi() ?>
                        </ul>

                    </div>

                    <!-- card footer. subscribed/subscribe button -->
                    <div class="panel-footer card-footer text-right">
                        <?php if (in_array($plan->id, $active_plan_ids)) : ?>
                            <a class="btn <?= $featured ? 'btn-primary' : 'btn-secondary' ?> btn-block btn-lg disabled" href="#">
                                <i class="fa fa-user-circle-o"></i> &nbsp;<?php _e('Subscribed', 'wppromembership'); ?>
                            </a>
                        <?php else :  ?>
                            <a href="<?= add_query_arg(['wppm_task' => 'checkout', 'plan_id' => $plan->id], $plan_url) ?>" class="btn <?= $featured ? 'btn-primary' : 'btn-secondary' ?> btn-block btn-lg" style="color:#fff !important;">
                                <?php _e('Subscribe', 'wppromembership'); ?>
                            </a>
                        <?php endif; ?>
                    </div>
                </div>
            </div>
        <?php endforeach; ?>
    </div>
</div>
<style>
    .pmpro-plans.pmpro-default .cursym {
        line-height: 20px;
    }
</style>