<input type="hidden" name="<?= WPPM_GENERAL_SETTINGS_NONCE ?>" value="<?= wp_create_nonce(); ?>" />
<input type="hidden" name="action" value="wppm_save_general_settings" />


<div class="panel panel-default">
    <div class="panel-heading"><?php _e('Pages', WPPM_TEXTDOMAIN); ?></div>
    <div class="panel-body">
        <div class="form-group">
            <label for="default_role"><?php _e('Membership Plans Page', 'wppromembership'); ?></label><br />
            <?php wp_dropdown_pages(array('selected' => wpdm_valueof($settings, 'wppm_plans_page'), 'name' => WPPM_GENERAL_SETTINGS_KEY . '[wppm_plans_page]', 'show_option_none' => 'None Selected', 'class' =>  "form-control input-lg")); ?>
        </div>

        <div class="form-group">
            <label><?= __("Membership Account Page", WPPM_TEXTDOMAIN); ?>:</label>
            <?php wp_dropdown_pages([
                'name' => WPPM_GENERAL_SETTINGS_KEY . '[wppm_account_page_id]',
                'class' => 'form-control input-lg',
                'selected' => wpdm_valueof($settings, 'wppm_account_page_id')
            ]) ?>
        </div>
        <div class="form-group">
            <input type="hidden" value="0" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[redirect]'  ?>"  />
            <label><input type="checkbox" value="1" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[redirect]'  ?>" <?php checked(wpdm_valueof($settings, 'redirect'), 1); ?> /> <?= esc_attr__('Automatically redirect users to account page from restricted contents', WPPM_TEXTDOMAIN); ?></label>
        </div>
    </div>
</div>
<div class="panel panel-default">
    <div class="panel-heading"><?php _e('Sitewide Protection', WPPM_TEXTDOMAIN); ?></div>
    <div class="panel-body">
        <input type="hidden" value="0" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[lockdown]'  ?>"  />
        <label><input type="checkbox" value="1" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[lockdown]'  ?>" <?php checked(wpdm_valueof($settings, 'lockdown'), 1); ?> /> <?= esc_attr__('Member only site access', WPPM_TEXTDOMAIN); ?></label>

    </div>
</div>
<div class="panel panel-default">
    <div class="panel-heading"><?php _e('Protect Post Types', WPPM_TEXTDOMAIN); ?></div>
    <div class="panel-body">
        <input type="hidden" value="1" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[is_guarded]'  ?>">
        <?php foreach ($post_types as $post_type) : ?>
            <label><input type="checkbox" <?= in_array($post_type->name, $guarded_post_types) ? 'checked' : '' ?> value="<?= $post_type->name ?>" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[guarded_post_types][]'  ?>"> <?= $post_type->labels->name ?></label> ( <?= $post_type->name ?> )
        <?php endforeach; ?>
    </div>
</div>
<div class="panel panel-default">
    <div class="panel-heading"><?php _e('Protect Taxonomies', WPPM_TEXTDOMAIN); ?></div>
    <div class="panel-body">
        <input type="hidden" value="1" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[is_guarded]'  ?>">
        <?php foreach ($taxonomies as $taxonomy) : ?>
            <label><input type="checkbox" <?= in_array($taxonomy->name, $guarded_taxonomies) ? 'checked' : '' ?> value="<?= $taxonomy->name ?>" name="<?= WPPM_GENERAL_SETTINGS_KEY . '[guarded_taxonomies][]'  ?>"> <?= $taxonomy->labels->name ?></label>  ( <?= $taxonomy->name ?> )
        <?php endforeach; ?>
    </div>
</div>

<div class=" panel panel-default panel-flat">
    <div class="panel-heading">
        <label for="nonmembertext"><?php _e('Message for Logged-in Non-members', 'wppromembership'); ?></label>
    </div>
    <textarea class="form-control border-0 no-shadow" name="<?= WPPM_GENERAL_SETTINGS_KEY . "[nonmembertext]"; ?>" id="nonmembertext"><?= stripslashes(wpdm_valueof($settings, 'nonmembertext')); ?></textarea>
    <div class="panel-footer">
        <small class="litegray"><?php _e('This message replaces the post content for non-members. Available variables', 'wppromembership'); ?>: <b><?php _e('!!levels!!', 'wppromembership'); ?></b>, <b><?php _e('!!referrer!!', 'wppromembership'); ?></b></small></div>
</div>

<div class="panel panel-default panel-flat">
    <div class="panel-heading">
        <label for="notloggedintext"><?php _e('Message for Logged-out Users', 'wppromembership'); ?></label>
    </div>
    <textarea class="form-control border-0 no-shadow" name="<?= WPPM_GENERAL_SETTINGS_KEY . "[notloggedintext]"; ?>" id="notloggedintext"><?= stripslashes(wpdm_valueof($settings, 'notloggedintext', ['validate' => 'html'])); ?></textarea>
    <div class="panel-footer"><small class="litegray"><?php _e('This message replaces the post content for logged-out visitors.', 'wppromembership'); ?></small></div>
</div>

<div class="panel panel-default panel-flat">
    <div class="panel-heading">
        <label for="rsstext"><?php _e('Message for RSS Feed', 'wppromembership'); ?></label>
    </div>
    <textarea class="form-control border-0 no-shadow" name="<?= WPPM_GENERAL_SETTINGS_KEY . "[rsstext]"; ?>" id="rsstext"><?= stripslashes(wpdm_valueof($settings, 'rsstext')); ?></textarea>
    <div class="panel-footer"><small class="litegray"><?php _e('This message replaces the post content in RSS feeds.', 'wppromembership'); ?></small></div>
</div>
