<?php

use WPDM\WPPM\Stats\StatsManager;

?>

<div class="wrap w3eden">
    <div id="wpdm-wrapper-panel" class="panel panel-default">
        <div class="panel-heading">

            <b><i class="fa fa-tags" style="margin-right: 5px"></i> <?php _e('Membership Reports', WPPM_TEXTDOMAIN); ?></b>
        </div>
        <div class="panel-body-np" style="padding-top: 100px">
            <div class="container">
                <div class="row rep-sum">
                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                <?= $count_all_subscriptions ?>
                            </div>
                            <div class="panel-footer">
                                <?php _e('Total Subscribers', WPPM_TEXTDOMAIN);  ?>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                <?= $count_active_subscriptions ?>
                            </div>
                            <div class="panel-footer">
                                <?php _e('Active Subscribers', WPPM_TEXTDOMAIN);  ?>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                <?= count($plans) ?>
                            </div>
                            <div class="panel-footer">
                                <?php _e('Total Plans', WPPM_TEXTDOMAIN);  ?>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                <?= $cancellation_rate ?> %
                            </div>
                            <div class="panel-footer">
                                <?php _e('Cancellation Rate', WPPM_TEXTDOMAIN); ?>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                $ <?= $sum_revenue_this_month ?>
                            </div>
                            <div class="panel-footer">
                                <?php _e('Revenue This Month', WPPM_TEXTDOMAIN); ?>
                            </div>
                        </div>
                    </div>

                    <div class="col-md-2">
                        <div class="panel panel-default">
                            <div class="panel-body">
                                $ <?= $sum_revenue_this_year ?>
                            </div>
                            <div class="panel-footer">
                                <?php _e('Revenue This Year', WPPM_TEXTDOMAIN); ?>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="panel panel-default">
                    <div class="panel-heading text-center">
                        Subscriptions
                    </div>
                    <div class="panel-body">
                        <div id="chart" style="min-height: 400px;"></div>
                    </div>

                    <div class="panel-footer text-center">
                        <form name="stats-filters" action="" method="post" style="text-align: center">

                            <?php _ex('Show', 'Dropdown label, e.g. Show Daily Revenue for January', WPPM_TEXTDOMAIN) ?>

                            <!-- Period filter -->
                            <select name="filters[period]" id="period" class="form-control wpdm-custom-select" style="width: 100px;display: inline-block">
                                <option value="MONTH" <?php selected(wpdm_valueof($filters, 'period'), "MONTH"); ?>><?php _e('Monthly', WPPM_TEXTDOMAIN); ?></option>
                                <option value="YEAR" <?php selected(wpdm_valueof($filters, 'period'), "YEAR"); ?>><?php _e('Annual', WPPM_TEXTDOMAIN); ?></option>
                            </select>

                            <!-- stats type filter -->
                            <select name="filters[stats_type]" id="stats-type" class="form-control wpdm-custom-select" style="width: auto;display: inline-block">
                                <option value="SUBSCRIPTIONS" <?php selected(wpdm_valueof($filters, 'stats_type'), "SUBSCRIPTIONS"); ?>><?php _e('Subscriptions', WPPM_TEXTDOMAIN); ?></option>
                            </select>

                            <span id="for"><?php _ex('for', 'Dropdown label, e.g. Show Daily Revenue for January', WPPM_TEXTDOMAIN) ?></span>

                            <!-- month filter -->
                            <select name="filters[month]" id="month" class="form-control wpdm-custom-select" style="width: auto;display: inline-block">
                                <option value>Select Month</option>
                                <?php foreach ($months as $month) : ?>
                                    <option value="<?= $month['value']; ?>" <?php selected(wpdm_valueof($filters, 'month'), $month['value']); ?>>
                                        <?= $month['name'] ?>
                                    </option>
                                <?php endforeach; ?>
                            </select>

                            <!-- year filter -->
                            <select name="filters[year]" id="year" class="form-control wpdm-custom-select" style="width: auto;display: inline-block">
                                <?php for ($i = date('Y'); $i > 2015; $i--) { ?>
                                    <option value="<?php echo $i; ?>" <?php selected(wpdm_valueof($filters, 'year'), $i); ?>><?php echo $i; ?></option>
                                <?php } ?>
                            </select>

                            <span id="for"><?php _ex('for', 'Dropdown label, e.g. Show Daily Revenue for January', WPPM_TEXTDOMAIN) ?></span>

                            <!-- plan filter -->
                            <select name="filters[plan_id]" class="form-control wpdm-custom-select" style="width: auto;display: inline-block">
                                <option value>All Plan</option>
                                <?php foreach ($plans as $plan) : ?>
                                    <option value="<?= $plan->getId() ?>" <?php selected(wpdm_valueof($filters, 'plan_id'), $plan->getId()); ?>>
                                        <?= $plan->getName() ?>
                                    </option>
                                <?php endforeach; ?>
                            </select>

                            <input type="submit" class="btn btn-primary" value="<?php _ex('VIEW REPORT', 'Submit button value.', WPPM_TEXTDOMAIN); ?>" style="width: auto;display: inline-block" />
                        </form>
                    </div>

                </div>


                <div class="row">
                    <div class="col-md-6">
                        <?= StatsManager::getInstance()->renderSubscriptionsCancellationTable() ?>
                    </div>

                    <div class="col-md-6">
                        <?= StatsManager::getInstance()->renderSubscriptionsRevenueTable() ?>
                    </div>
                </div>

            </div>
        </div>
    </div>
</div>
<style>
    .rep-sum .panel {
        text-align: center;
        letter-spacing: 0.5px;
    }

    .rep-sum .panel-body {
        font-size: 14pt;
        font-weight: 700;
    }

    .panel-footer {
        font-weight: 600;
        font-size: 90%;
    }

    .w3eden select.wpdm-custom-select {
        width: auto !important;
        font-size: 9pt;
        padding-right: 30px !important;
    }
</style>

<script>
    jQuery(function($) {


        if ($("#period").val() == "YEAR") {
            $("#month").hide();
        }
        $("#period").change(function() {
            if ($(this).val() == "MONTH") {
                $("#month").show();
            } else {
                $("#month").hide();
            }
        })

    })
</script>

<script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
<script type="text/javascript">
    google.charts.load('current', {
        'packages': ['bar']
    });
    google.charts.setOnLoadCallback(drawChart);

    function drawChart() {
        var data = new google.visualization.DataTable();

        var columns = <?= json_encode($chart_columns) ?>;
        for (var i = 0; i < columns.length; i++) {
            data.addColumn(columns[i]);
        }

        var chartData = <?= json_encode($chart_data) ?>;
        data.addRows(chartData);

        var options = {
            title: "Report",
            width: "50%",
            curveType: 'function',
            bars: 'vertical',
            bar: {
                groupWidth: "90%"
            },
            legend: {
                position: 'bottom'
            },
            backgroundColor: {
                fill: '#ffffff'
            }
        };

        var chart = new google.charts.Bar(document.getElementById('chart'));
        chart.draw(data, options);
    }
</script>