<?php

namespace WPDM\WPPM\Subscription;

use WPDM\WPPM\Core\DateTimeInterval;

class SubscriptionFilter
{
    use DateTimeInterval;


    private $plan_id;

    private $user_id;

    private $subscription_status;


    public function __construct($data = null)
    {
        if (is_array($data)) {
            if (isset($data['from_date'])) {
                $this->setFromDate($data['from_date']);
            }

            if (isset($data['to_date'])) {
                $this->setToDate($data['to_date']);
            }
        }
    }


    /**
     * Get the value of subscription_status
     */
    public function getSubscriptionStatus()
    {
        return $this->subscription_status;
    }


    /**
     * Set the value of subscription_status
     *
     * @return  self
     */
    public function setSubscriptionStatus($subscription_status)
    {
        $this->subscription_status = $subscription_status;

        return $this;
    }

    /**
     * Get the value of plan_id
     */
    public function getPlanId()
    {
        return $this->plan_id;
    }

    /**
     * Set the value of plan_id
     *
     * @return  self
     */
    public function setPlanId($plan_id)
    {
        $this->plan_id = $plan_id;

        return $this;
    }

    /**
     * Get the value of user_id
     */
    public function getUserId()
    {
        return $this->user_id;
    }

    /**
     * Set the value of user_id
     *
     * @return  self
     */
    public function setUserId($user_id)
    {
        $this->user_id = $user_id;

        return $this;
    }
}
