<?php
if(!defined("ABSPATH")) die('');

$roles = WPPM()->role_manager->getRoles();
$total = count(get_users(['role__in' => array_keys($roles)]));
$paged = wpdm_query_var('paged', 'int', 1);
$subscribers = get_users(['role__in' => array_keys($roles), 'number' => 20, 'paged' => $paged]);

?>


    <div class="wrap w3eden">
        <div id="wpdm-wrapper-panel" class="panel panel-default">
            <div class="panel-heading">
                <b><i class="fa fa-users" style="margin-right: 5px"></i> <?php _e('Active Subscribers', WPPM_TEXTDOMAIN); ?></b>
            </div>


            <div class="panel-body-np" style="padding-right: 20px">
                <table class="table table-striped table-hover" style="margin-top: 80px">
                    <thead>
                    <tr class="thead">
                        <th style="width: 50px;text-align: center"><?php _e('ID', WPPM_TEXTDOMAIN) ?></th>
                        <th style="width: 300px"><?php _e('Subscriber Info', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Active Subscriptions', WPPM_TEXTDOMAIN) ?></th>
                        <th><?php _e('Signup Date', WPPM_TEXTDOMAIN) ?></th>
                        <th class="text-right"><?php _e('Action', WPPM_TEXTDOMAIN) ?></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php foreach ($subscribers as $subscriber){  ?>
                        <tr class="thead">
                            <td class="text-center"><h4><?php echo $subscriber->ID; ?></h4></td>
                            <td>
                                <strong><?php echo $subscriber->display_name; ?></strong><br/>
                                <?php echo $subscriber->user_email; ?>
                            </td>
                            <td>
                                <?php
                                $data = [];
                                foreach ($subscriber->roles as $role){
                                    if(isset($roles[$role]))
                                        $data[] = "<a href='#'>".$roles[$role]."</a>";
                                }
                                echo implode(", ", $data);
                                ?>
                            </td>
                            <td><?php echo wp_date(get_option('date_format'), strtotime($subscriber->user_registered)); ?></td>
                            <td class="text-right">
                                <a href="edit.php?post_type=wppm_plan&page=wppm_account&user_id=<?php echo $subscriber->ID; ?>" class="btn btn-info"><?php _e('Manage', WPPM_TEXTDOMAIN) ?></a>
                            </td>
                        </tr>
                    <?php } ?>
                    </tbody>
                </table>
            </div>
            <div class="panel-footer text-right">
                <?php
                    echo wpdm_paginate_links($total, 20, $paged, 'paged');
                ?>
            </div>


        </div>
    </div>

