<?php

/**
 * Plugin Name: WP Pro Membership
 * Plugin URI: https://www.wpdownloadmanager.com/download/wp-pro-membership/
 * Description: User Subscription & Membership Management Plugin for WordPress Download Manager
 * Version: 3.5.3
 * Author: WordPress Download Manager
 * Text Domain: wppromembership
 * Author URI: https://www.wpdownloadmanager.com/
 * Update URI: wppromembership
 */

require 'vendor/autoload.php';

define('WPPM_BASE_PATH', plugin_dir_path(__FILE__));
define('WPPM_BASE_URL', plugin_dir_url(__FILE__));

define('WPPM_PUBLIC_PATH', WPPM_BASE_PATH . 'public/');
define('WPPM_PUBLIC_URL', WPPM_BASE_URL . 'public/');

define('WPPM_ADMIN_PATH', WPPM_BASE_PATH . 'admin/');
define('WPPM_ADMIN_URL', WPPM_BASE_URL . 'admin/');


/**
 * Initiate the global wppm to use throughout the application
 */

if(defined('WPDM_VERSION')) {
    global $wppm,  $wpmp_currency_symbol, $wpmp_currency_code;
    $wppm = WPDM\WPPM\WPPM::getInstance();


    if (!function_exists('WPPM')) {
        /**
         * @return \WPDM\WPPM\WPPM
         */
        function WPPM()
        {
            global $wppm;
            return $wppm;
        }
    }

    register_activation_hook(__FILE__, array($wppm, 'activate'));
    register_deactivation_hook(__FILE__, array($wppm, 'deactivate'));
}

